#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "greedy.h"
 

void afficher(int nlig, int ncol);
void ecrire(int x, int y, char car);
void effacer(int nlig, int ncol);
void ecrire_chaine(int x, int y, char *chaine);
void dessin_branches(int x, int y1, int y2);
void dessin_arbre(noeud *base, int niveau, int *position);
void entree_minim(score **d, int R, char supprimee[], int *imin, int *jmin);
void retablir_noeuds(noeud *base);
noeud *calculer_arbre(score **d);


extern int NBRE_LETTRES, X, INCONNU;
extern sequence *seq;
extern indice maxlong, minlong;
extern int Ra, R, nseqbasemin, nseqmin;
extern long RL;
extern indice longalig;

extern score **sim, max_sim;

extern indice nech;

extern score DISTANCE_MAX;
extern char plein, vide;
extern int long_branche, separation;
extern int num_feuille;
extern char **grille;
extern noeud **noeuds;

extern gscore SCORE_MIN;

void afficher(int nlig, int ncol)
{
int x, y;

for (y=0; y < nlig; y++, printf("\n"))
    for (x=0; x < ncol; x++)
   	printf("%c", grille[y][x]);
printf("\n");
}

void ecrire(int x, int y, char car)
{

grille[y][x] = car;
}

void effacer(int nlig, int ncol)
{
int x, y;

for (y=0; y < nlig; y++)
    for (x=0; x < ncol; x++)
	ecrire(x, y, vide);
}

void ecrire_chaine(int x, int y, char *chaine)
{
int i;

for (i=0; chaine[i] != 0; i++)
	ecrire(x+i, y, chaine[i]);
}

void dessin_branches(int x, int y1, int y2)
{

int i;

for (i=y1; i <= y2; i++)
	ecrire(x, i, plein);

for (i=1; i <= long_branche; i++)
    {
	ecrire(x+i, y1, plein);
	ecrire(x+i, y2, plein);
    }
}

void dessin_arbre(noeud *base, int niveau, int *position)
{
int position1, position2;
char num[10];

if (base->noeud1 == NULL)
   {
	*position = num_feuille * separation;

	sprintf(num, "%d", base->num);

	ecrire_chaine(niveau+1, *position, num);

	num_feuille++;
   }
else
   {
	dessin_arbre(base->noeud1, niveau+long_branche+1, &position1);

	dessin_arbre(base->noeud2, niveau+long_branche+1, &position2);

	*position = (position1 + position2) / 2;

	dessin_branches(niveau, position1, position2);
   }
}

void entree_minim(score **d, int R, char supprimee[], int *imin, int *jmin)
{
int i, j;

score minim = DISTANCE_MAX;

*imin = 0; *jmin = 0;

for (i=1; i < R; i++)
 if (! supprimee[i])
  for (j=0; j < i; j++)
   if (! supprimee[j])
    if (minim > d[i][j])
     {
	minim = d[i][j];
	*imin = i;
	*jmin = j;
     }
}

void retablir_noeuds(noeud *base)
{
int x;

if (base->noeud1 != NULL)
   {
	retablir_noeuds(base->noeud1); 
	retablir_noeuds(base->noeud2);
   }
else
   {
	x = base->num;
	noeuds[x] = base;
   }
}

noeud *calculer_arbre(score **d)
{
int x, y, z, s, k;
score *nbre;
noeud  *nnoeud;
char *supprimee;

DISTANCE_MAX = - (SCORE_MIN.b + 1);

supprimee = (char *) allouer(R);
nbre = (score *) allouer(R * sizeof(score));

for (x=0; x < R; x++)
   {
	nbre[x] = 1;
	supprimee[x] = false;

	noeuds[x] = (noeud *) allouer(sizeof(noeud));
	noeuds[x]->noeud1 = noeuds[x]->noeud2 = NULL;
	noeuds[x]->num = x;

	noeuds[x]->premier = (int *) allouer(sizeof(int));
	noeuds[x]->dernier = (int *) allouer(sizeof(int));
	noeuds[x]->premier[0] = 1;
	noeuds[x]->dernier[0] = noeuds[x]->longueur = seq[x].longueur;
   }

for (k=1; k < R; k++)
   {
	entree_minim(d, R, supprimee, &x, &y);

	supprimee[x] = supprimee[y] = true;

	s = nbre[x] + nbre[y];

	for (z=0; z < R; z++)
	    if (! supprimee[z])
		d[x][z] = d[z][x] = (nbre[x]*d[x][z] + nbre[y]*d[y][z]) / s;

	supprimee[x] = false;
	nbre[x] += nbre[y];

	nnoeud = (noeud *) allouer(sizeof(noeud));
	nnoeud->noeud1 = noeuds[x]; nnoeud->noeud2 = noeuds[y]; 
	nnoeud->num = R;
	noeuds[x] = nnoeud;
   }

retablir_noeuds(nnoeud);

liberer(supprimee);
liberer(nbre);

return(nnoeud);
}

