#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
 
#include "greedy.h"

extern void aligne_2noeuds(noeud *base, noeud *n1, noeud *n2, int *poids, int poids_max);	
extern void recalculer_frontieres(char *eliminee, indice **Succ, indice **Pred, 
			int *NSucc, int *NPred, int *npred);
extern score score_paire_seq(noeud *n1, noeud *n2);
extern score score_remplacement(noeud *n1, noeud *n2);
extern int profond(noeud *base);
extern void effacer(int nlig, int ncol);
extern void dessin_arbre(noeud *base, int niveau, int *position);
extern void afficher(int nlig, int ncol);
extern void minmaxlong(void);
extern void init_echelles_front(void);
extern void lire_distances(void);
extern void calculer_blocs(void);
extern score calcul_gap_score(indice i, indice j);
extern indice mise_en_forme(lettre *u, indice m, char ALIGNEMENT);
extern noeud *calculer_arbre(score **d);
extern noeud *nj_calculer_arbre(score **d);
extern void EcrireSequence(FILE *f, int x);
extern int ecrire_plus_proches_sequences(void);

void reallouer_espace_prog_dynamique(indice longueur1, indice longueur2);
void allouer_espace_prog_dynamique(void);
void liberer_espace_prog_dynamique(void);
void fusion_ancrages(indice ancrage1, indice ancrage2, char *eliminee);
void grouper(noeud *base, char *eliminee, indice **Succ, indice **Pred, 
		int *NSucc, int *NPred, int *npred, int *poids, int poids_max);
void generer_colonne_alig(noeud *base, indice i, indice ia);
void produire_alignement(noeud *arbre);
void distances_selon_paire_alig(score **ds);
char distances_selon_blocs(score **d);
indice nbre_ancrages_min(int x);
indice nbre_ancrages(int x);
void ecrire_sequences(void);
int eliminer_les_sequences_trop_eloignes(void);
void liberer_arbre(noeud *arbre);
noeud *aligner_entre_ancrages(void);
void allouer_ech_front_mat(void);
void liberer_ech_front_mat(void);
score cout_alignement_paire(int x , int y, int longalig);
score cout_alignement_paire_select(int x , int y, int longalig, char *site_selectionne);
score cout_alignement(void);
void lissage(void);
int algo_greedy(void);
int calculer_poids(noeud *arbre, int *poids, int poid, int poid_max);
int profondeur_rec(noeud *arbre, int p, int pmax);
int profondeur(noeud *arbre);
void meme_Classe(indice s1, indice s2);

extern char famille[100];
extern lettre code[128];
extern char decode[100];
extern char DNA;

extern int NBRE_LETTRES, X, INCONNU;
extern sequence *seq;
extern indice maxlong, minlong;
extern int Ra, R, nseqbasemin, nseqmin;
extern long RL;
extern indice longalig;
extern indice lmin, lmax, nerreurs, pas;

extern echelle *ech;
extern indice nech, anech;
extern indice **seuil_g, **seuil_d;
extern indice *topolog;
extern indice *gauche1, *gauche2, *droite1, *droite2, **pos_;
extern char  ECHELLES_INIT, CALCULER_ECHELLES;

extern char MARQUER_BLOCS;

extern score DISTANCE_MAX;
extern char plein, vide;
extern int long_branche, separation;
extern int num_feuille;
extern char **grille, NJ;
extern noeud **noeuds;

extern score alphaS, betaS, alphaD, betaD;
extern float beta, alpha;
extern score **sim, max_sim, **dis;
extern char CLUSTALW;
extern char COMPTE_GAPS_EXTREMAUX, DISTANCES_PAR_BLOCS, PROFILE;
extern lettre *coli, *colj, *colip, *coljp, *colg;
extern int *num_seq1, *num_seq2;
extern int nbseq1, nbseq2, nbseq;
extern gscore *d, *f;
extern gscore SCORE_MIN;

extern char *histoire_d, *histoire_f;
extern char *histoire_pp_remp, *histoire_pp_supp, *histoire_pp_inse;

extern int (*pp)[2], (*succ_pp)[3], *pp_i, *Rr, *Lr;
extern char (*tpp)[2], (*succ_tpp)[3], *contrainte;
extern indice alongueur1, alongueur2, asomme;

extern char **ch;
extern score **dist_entre_seq;

extern char NOUVELLE_SEQ;
extern int **Classe;

extern char RECURSIF;
extern char DEBUG, STATISTIQUES;

extern double TAUX_MIN;
extern char PS;


void allouer_espace_prog_dynamique(void)
{
indice longueur = 2 * maxlong;

if (DEBUG)	printf("houna 22\n");

d = (gscore *) allouer((longueur+2)*sizeof(gscore)); 
f = (gscore *) allouer((longueur+2)*sizeof(gscore)); 

histoire_d = (char *) allouer(longueur+2);
histoire_f = (char *) allouer(longueur+2);

histoire_pp_remp = (char *) allouer(longueur+longueur+2);
histoire_pp_inse = (char *) allouer(longueur+longueur+2);
histoire_pp_supp = (char *) allouer(longueur+longueur+2);

if (DEBUG)	printf("houna 24\n");

pp = (int (*)[2]) allouer((longueur+2)*2*sizeof(int));
succ_pp = (int (*)[3]) allouer((longueur+longueur+2)*3*sizeof(int));	
tpp = (char (*)[2]) allouer((longueur+2)*2*sizeof(char));
succ_tpp = (char (*)[3]) allouer((longueur+longueur+2)*3*sizeof(char));
pp_i = (int *) allouer((longueur+longueur+2)*sizeof(int));
Rr = (int *) allouer((longueur+2)*sizeof(int));
Lr = (int *) allouer((longueur+2)*sizeof(int));
contrainte = (char *) allouer((longueur+2)*sizeof(char));

if (DEBUG)	printf("houna 26 (%d)\n", RECURSIF);

if (!RECURSIF)	ch = (char **) callouer_mat(sizeof(char), maxlong+2, maxlong+2);
}

void reallouer_espace_prog_dynamique(indice longueur1, indice longueur2)
{
indice longueur;


if (longueur1 > 2*alongueur1)
   {
	liberer(contrainte);  
	liberer(Lr); liberer(Rr);
   }
 
if (longueur2 > 2*alongueur2)
   {
	liberer(histoire_f); liberer(histoire_d);
	liberer(f); liberer(d);
	liberer(pp); liberer(tpp);
   }

if (longueur1+longueur2 > 2*(alongueur1+alongueur2))
   {
	liberer(pp_i); liberer(succ_tpp); liberer(succ_pp);  
	liberer(histoire_pp_remp); liberer(histoire_pp_inse); liberer(histoire_pp_supp); 
   }

if (!RECURSIF && ((longueur1 > alongueur1) || (longueur2 > alongueur2)))
	ch = (char **) recallouer_mat2((void **) ch, sizeof(char), 
				alongueur1+2, longueur1+2, longueur2+2);

if (longueur1 > 2*alongueur1)
   {
	longueur = 2 * longueur1;

if (DEBUG) printf("reallouer Rr et Lr (nouv long. = %d)\n", longueur);

	Rr = (int *) allouer((longueur+2)*sizeof(int));
	Lr = (int *) allouer((longueur+2)*sizeof(int));
	contrainte = (char *) allouer((longueur+2)*sizeof(char));

	alongueur1 = longueur1; 
   }
 
if (longueur2 > 2*alongueur2)
   {
	longueur = 2 * longueur2;

	d = (gscore *) allouer((longueur+2)*sizeof(gscore));
	f = (gscore *) allouer((longueur+2)*sizeof(gscore));

	histoire_d = (char *) allouer(longueur+2);
	histoire_f = (char *) allouer(longueur+2);

	pp = (int (*)[2]) allouer((longueur+2)*2*sizeof(int));
	tpp = (char (*)[2]) allouer((longueur+2)*2*sizeof(char));

	alongueur2 = longueur2;
   }

if (longueur1+longueur2 > 2*asomme)
   {
	longueur = 2 * (longueur1 + longueur2);

	histoire_pp_remp = (char *) allouer(longueur+2);
	histoire_pp_inse = (char *) allouer(longueur+2);
	histoire_pp_supp = (char *) allouer(longueur+2);

	succ_pp = (int (*)[3]) allouer((longueur+2)*3*sizeof(int));
	succ_tpp = (char (*)[3]) allouer((longueur+2)*3*sizeof(char));
	pp_i = (int *) allouer((longueur+2)*sizeof(int));

	asomme = longueur1 + longueur2;
   }



}

void liberer_espace_prog_dynamique(void)
{
if (!RECURSIF)
	liberer_mat((void **) ch, alongueur1+2); 

liberer(contrainte);  
liberer(Lr); liberer(Rr);
liberer(pp_i); liberer(tpp); liberer(succ_tpp); liberer(pp); liberer(succ_pp);  

liberer(histoire_pp_remp); liberer(histoire_pp_inse); liberer(histoire_pp_supp); 
liberer(histoire_f); liberer(histoire_d);

liberer(f); liberer(d);
}

void fusion_ancrages(indice ancrage1, indice ancrage2, char *eliminee)
{
int x;
indice i;

if (ancrage1 > ancrage2 && ancrage2 > 0)
   {
	for (x=0; x < R; x++)
	   {
		if (ech[ancrage2].ind[x] > 0)
		     {

if (DEBUG && !eliminee[x] && ech[ancrage1].ind[x] > 0 && ech[ancrage1].ind[x] != ech[ancrage2].ind[x])
{
printf("erreur fusion de %d et %d, indices %d et %d, x=%d\n", 
ancrage1, ancrage2,
ech[ancrage1].ind[x], ech[ancrage2].ind[x], x);
exit(0);
}
			ech[ancrage1].ind[x] = i = ech[ancrage2].ind[x];
			seq[x].ech[i] = ancrage1;
		     }
		ech[ancrage2].ind[x] = 0;	
		/* elimine ancrage2 (pour calcul de front) */
	   }
   }
}

void grouper(noeud *base, char *eliminee, indice **Succ, indice **Pred, 
		int *NSucc, int *NPred, int *npred, int *poids, int poids_max)
{
noeud *n1, *n2;
indice i, i1, i2, *ancrages;
int a, b, c, x;

if (DEBUG) printf("alignement\n");

if (base->noeud1 != NULL)
   {
	n1 = base->noeud1; 	n2 = base->noeud2;

	grouper(n1, eliminee, Succ, Pred, NSucc, NPred, npred, poids, poids_max); 
	grouper(n2, eliminee, Succ, Pred, NSucc, NPred, npred, poids, poids_max);

	a = n1->num;		b = n2->num;

if (DEBUG) printf("alignement de noeuds representes par %d et %d\n", a, b);

if (DEBUG) printf("alignement de noeuds de long %d et %d. base=%d\n", n1->longueur, 
						n2->longueur, base);

	base->alig = (frag *) allouer( (n1->longueur + n2->longueur + 1) * sizeof(frag) ); 

if (DEBUG) printf("avant reallouer_espace_prog_dynamique\n");

	reallouer_espace_prog_dynamique(n1->longueur, n2->longueur);

	calcul_gap_score(n1->longueur, n2->longueur);

if (DEBUG)
   {
	printf("fct gap (score) : %d + %d (k-1)\n", alphaS, betaS);
	printf("fct gap (distance) : %d + %d (k-1)\n", alphaD, betaD);
	printf("alignement des noeuds\n");
   }

	aligne_2noeuds(base, n1, n2, poids, poids_max);

if (DEBUG) printf("alignement de longueur %d\n", base->longueur);

	base->num = a;
	noeuds[a] = base;

	ancrages = (indice *) allouer((base->longueur+1) * sizeof(indice));

if (DEBUG) printf("ancrages alloues\n");

	for (i=1; i <= base->longueur; i++)
	   {
		i1 = base->alig[i].i; 	i2 = base->alig[i].j;

		if (i1 == 0)	seq[a].ech[i1] = 0;
		if (i2 == 0)	seq[b].ech[i2] = 0;

		ancrages[i] = max(seq[a].ech[i1], seq[b].ech[i2]);
		fusion_ancrages(ancrages[i], 
				min(seq[a].ech[i1], seq[b].ech[i2]), eliminee);

		if (ancrages[i] > 0) 	ech[ancrages[i]].ind[a] = i;
	   }

	liberer(seq[a].ech);
	seq[a].ech = ancrages;
	eliminee[b] = true;

if (DEBUG) printf("recalculer_frontieres\n");

	if (nech > 0) recalculer_frontieres(eliminee, Succ, Pred, NSucc, NPred, npred);

if (DEBUG) printf("fin recalculer_frontieres\n");

   }
}

void generer_colonne_alig(noeud *base, indice i, indice ia)
{
int x;
indice i1, i2;

if (base->noeud1 != NULL)
     {
	i1 = base->alig[i].i; i2 = base->alig[i].j;
	if (i1 > 0) generer_colonne_alig(base->noeud1, i1, ia); 
	if (i2 > 0) generer_colonne_alig(base->noeud2, i2, ia); 
     }
else {
	x = base->num;
	seq[x].alig[ia] = seq[x].u[i];
     }
}

void produire_alignement(noeud *arbre)
{
int x;
indice i;

longalig = arbre->longueur;

for (x=0; x < R; x++)
   {
	seq[x].alig = (lettre *) allouer(longalig+2);

	for (i=1; i <= longalig; i++)
		seq[x].alig[i] = '-';

	seq[x].alig[0] = ' '; seq[x].alig[longalig+1] = 0; 
   }


for (i=1; i <= longalig; i++)
	generer_colonne_alig(arbre, i, i);
}

void distances_selon_paire_alig(score **ds)
{
noeud n1, n2;
int x, y;
int premier1, premier2, dernier1, dernier2;
score val, dist_min, dist_max;

dist_min = 0;
dist_max = SCORE_MIN.b / (2*R);

for (x=0; x < R; x++) ds[x][x] = 0;

for (x=0; x < R-1; x++)
   for (y=x+1; y < R; y++)
     {
	n1.num = x; n2.num = y;
	n1.noeud1 = n1.noeud2 = n2.noeud1 = n2.noeud2 = NULL; 
	n1.premier = &premier1; n1.dernier = &dernier1;
	premier1 = 1; dernier1 = n1.longueur = seq[x].longueur; 
	n2.premier = &premier2; n2.dernier = &dernier2;
	premier2 = 1; dernier2 = n2.longueur = seq[y].longueur; 

	if (!NOUVELLE_SEQ || x > 0)
	     {
		val = ds[x][y] = ds[y][x] = -score_remplacement(&n1, &n2);
			/*(-score_paire_seq(&n1, &n2)*maxlong)/min(seq[x].longueur,seq[y].longueur);*/
		if (dist_min > val)	dist_min = val;
		if (dist_max < val)	dist_max = val;
	     }

/*	if (!NOUVELLE_SEQ) 
		printf("distance entre seq %d et seq %d: %d\n", x+1, y+1, ds[x][y]);
	else {
		if (x > 0)
			printf("distance entre seq %d et seq %d: %d\n", x, y, ds[x][y]);
	     }
*/
     }
/*printf("\n");*/


if (NOUVELLE_SEQ)
   {
	dist_min--;
	for (x=0; x < Ra; x++)
	   for (y=0; y < x; y++)
		ds[x][y] = ds[y][x] = dist_min;
	for (x=Ra; x < R; x++)
		ds[0][x] = ds[x][0] = dist_min;
	for (x=Ra; x < R; x++)
	   for (y=Ra; y < x; y++)
		ds[x][y] = ds[y][x] = dist_max;
   }
}

char distances_selon_blocs(score **d)
{
score cpt;
int x, y, n;
indice i, j;
char bon;
score dist_max, DISTANCE_MAX, dist_min;
char *valide;

dist_max = SCORE_MIN.b / (2*R);
DISTANCE_MAX = - (SCORE_MIN.b+1);

dist_min = 0;

/*if (NOUVELLE_SEQ)
    {
	valide = (char *) allouer(nech+1);
	for (n=1; n <= nech; n++)
	    {
		for (x=Ra; x < R && ech[n].ind[x] == 0; x++);
		if (x == R)	valide[n] = false;
		else		valide[n] = true;
	    }
    }*/

for (x=0; x < R; x++)
    {
	d[x][x] = 0;

	Classe[x][NBRE_SEG] = 1; 
	Classe[x][REP_CLASSE] = Classe[x][IDX] = x; 
    }

for (x=0; x < R; x++)
   for (y=0; y < x; y++)
     {
	cpt = 0; bon = false;

	for (j=1; j <= seq[y].longueur; j++)
	   {
		n = seq[y].ech[j];
		if (n >= 1 && n <= nech && ech[n].ind[x] > 0 
				/*&& (!NOUVELLE_SEQ || valide[n])*/)
		     {
			i = ech[n].ind[x];
			cpt += sim[ coder(seq[x].u[i]) ][ coder(seq[y].u[j]) ];
			bon = true;
		     }
	   }

	if (!bon)
	     {
		d[x][y] = d[y][x] = DISTANCE_MAX;
	     }
	else {
			d[x][y] = d[y][x] = -cpt;

			if (-cpt > dist_max)
				dist_max = -cpt;

			if (-cpt < dist_min)
				dist_min = -cpt;

    			if (Classe[x][REP_CLASSE] != Classe[y][REP_CLASSE])
				meme_Classe(x, y);
	     }
      }

for (x=n=0; x < R; x++)
  if (x == Classe[x][REP_CLASSE])
	n++;

dist_max++;

for (x=0; x < R; x++)
   for (y=0; y < x; y++)
     if (d[x][y] == DISTANCE_MAX)
	d[x][y] = d[y][x] = dist_max;

if (NOUVELLE_SEQ)
   {
	dist_min--;
	for (x=0; x < Ra; x++)
	   for (y=0; y < x; y++)
		d[x][y] = d[y][x] = dist_min;
	for (x=Ra; x < R; x++)
		d[0][x] = d[x][0] = dist_min;
	for (x=Ra; x < R; x++)
	   for (y=Ra; y < x; y++)
		d[x][y] = d[y][x] = dist_max;

/*	liberer(valide);*/
   }

return(n <= 2);
}

indice nbre_ancrages_min(int x)
{
return((indice) (seq[x].longueur*TAUX_MIN));
}

indice nbre_ancrages(int x)
{
int cpt = 0; 
indice j, n;

for (j=1; j <= seq[x].longueur; j++)
	   {
		n = seq[x].ech[j];
		if (n >= 1 && n <= nech)
			cpt++;
	   }


return(cpt);
}


int eliminer_les_sequences_trop_eloignes(void)
{
	score cpt;
	int x, y, n, z, nb_seq_supp;
	indice i, j;
	char bon;
	char *valide;
	sequence tmp;
	FILE *f;
	char nom[100], c;


	if (!PS)	return(0);

	extension(nom, famille, "psc");
	f = fopen(nom, "w");

	for (x=Ra, nb_seq_supp=0; x < R; x++)
	     {
		n = nbre_ancrages(x);

		fprintf(f, "%sPS = %f\n\n", seq[x].nom, 
				((float) n/seq[x].longueur));

    	   	if (n < nbre_ancrages_min(x))
		     {
			printf("\nSupprime la sequence : %s", seq[x].nom);
			printf("score de proximite (PS) : %f\n", 
				((float) n/seq[x].longueur));

			nb_seq_supp++;
		     }
	     }

	fclose(f);
	printf("\nScore de proximite (PS) des sequences dans <%s>\n\n", nom);
	fflush(stdout);

	if (nb_seq_supp > 0)
	     {
		extension(nom, famille, "kept");
		f = fopen(nom, "w");
		for (x=Ra; x < R; x++)
		    if (nbre_ancrages(x) >= nbre_ancrages_min(x))
			EcrireSequence(f, x);
		fclose(f);
	     }

	return (nb_seq_supp);
}

void liberer_arbre(noeud *arbre)
{

if (arbre->noeud1 != NULL)
    {
	liberer_arbre(arbre->noeud1); liberer_arbre(arbre->noeud2); 
	liberer(arbre->alig);
	liberer(arbre->scol);
    }

liberer(arbre->premier);
liberer(arbre->dernier);
liberer(arbre);
}

int profondeur_rec(noeud *arbre, int p, int pmax)
{
int p1, p2;

if (arbre->noeud1 == NULL)
     {
	if (p > pmax)	return(p);
	else		return(pmax);
     }
else {
	p1 = profondeur_rec(arbre->noeud1, p+1, pmax); 
	p2 = profondeur_rec(arbre->noeud2, p+1, pmax);
	return(max(p1, p2));
     }
}

int profondeur(noeud *arbre)
{
return(profondeur_rec(arbre, 0, 0));
}

int calculer_poids(noeud *arbre, int *poids, int poid, int poids_max)
{
int p1, p2;

if (arbre->noeud1 == NULL)
     {
	poids[arbre->num] = poid;
	return(max(poid, poids_max));
     }
else {
	p1 = calculer_poids(arbre->noeud1, poids, poid-1, poids_max);
	p2 = calculer_poids(arbre->noeud2, poids, poid-1, poids_max);
	return(max(p1, p2));
     }
}

noeud *aligner_entre_ancrages(void)
{
score **ds;
noeud *arbre;
int position, x, y;
char *eliminee;
indice **Succ, **Pred;
int *NSucc, *NPred, *npred;
int nlig, ncol;
FILE *fich;
int *poids, poids_max;

if (DEBUG) printf("houna 0\n");

eliminee = (char *) allouer(R);
for (x=0; x < R; x++)	eliminee[x] = false;
topolog = (indice *) allouer(sizeof(indice)); 	/* sera re'alloue' */

if (DEBUG) printf("houna 10\n");

num_seq1 = (int *) allouer(R * sizeof(int));
num_seq2 = (int *) allouer(R * sizeof(int));
coli = (lettre *) allouer(R * sizeof(lettre));
colj = (lettre *) allouer(R * sizeof(lettre));
colip = (lettre *) allouer(R * sizeof(lettre));
coljp = (lettre *) allouer(R * sizeof(lettre));
colg = (lettre *) allouer(R * sizeof(lettre));
for (x=0; x < R; x++)	colg[x] = X;

Succ = (indice **) callouer_mat(sizeof(indice), nech+2, R);
Pred = (indice **) callouer_mat(sizeof(indice), nech+2, R);
NSucc = (int *) allouer((nech+2) * sizeof(int));
NPred = (int *) allouer((nech+2) * sizeof(int));
npred = (int *) allouer((nech+2) * sizeof(int));

poids = (int *) allouer(R * sizeof(int));
ds = (score **) callouer_mat(sizeof(score), R, R);

if (DEBUG) printf("houna 20\n");

allouer_espace_prog_dynamique();

alongueur1 = alongueur2 = maxlong;
asomme = 2*maxlong;

noeuds = (noeud **) allouer(R * sizeof(noeud *));


if (DEBUG)	printf("calcul distances entre les sequences\n");

if (DISTANCES_PAR_BLOCS)
     {
	if (!distances_selon_blocs(ds))
		distances_selon_paire_alig(ds);
     }
else	distances_selon_paire_alig(ds);

if (DEBUG)	
   {
	printf("distances entre les sequences : \n");

	for (y=0; y < R; y++)
		printf("%8d ", y);
	printf("\n   0");

	for (x=0; x < R; x++, printf("\n%4d", x))
	    for (y=0; y < R; y++)
		printf("%8d ", ds[x][y]);

	printf("\n");
   }

if (NJ)	arbre = nj_calculer_arbre(ds);
else	arbre = calculer_arbre(ds);

poids_max = calculer_poids(arbre, poids, profondeur(arbre) + 1, 0);

if (DEBUG)	
   {
	if (NJ)		printf("arbre obtenu par NJ\n");
	else		printf("arbre obtenu par UPGMA\n");

/*printf("profondeur=%d\n", profondeur(arbre));*/

	nlig = separation * R;
	ncol = (long_branche+1) * profondeur(arbre) + 20; 

/*printf("nlig=%d, ncol=%d\n", nlig, ncol);*/

	grille = (char **) callouer_mat(sizeof(char), nlig, ncol);

/*printf("effacer\n");*/

	effacer(nlig, ncol); 		

/*printf("effacer fait\n");*/

	num_feuille = 0;
	dessin_arbre(arbre, 0, &position);
	afficher(nlig, ncol);

	liberer_mat((void **) grille, nlig);


	printf("\npoids: ");
	for (x=0; x < R; x++)
		printf("(%d,%d) ", x, poids[x]);
	printf("\npoids max = %d\n", poids_max);
   }

liberer_mat((void **) ds, R);

if (DEBUG) printf("groupement\n");

/*if (nech > 0) 	lissage();*/

grouper(arbre, eliminee, Succ, Pred, NSucc, NPred, npred, poids, poids_max);

if (DEBUG) printf("fin groupement\n");

liberer_espace_prog_dynamique();

if (DEBUG) printf("fin liberer_espace_prog_dynamique\n");

liberer(topolog); 

liberer(npred); liberer(NPred); liberer(NSucc); 
liberer_mat((void **) Pred, nech+2); liberer_mat((void **) Succ, nech+2); 

liberer(num_seq1); liberer(num_seq2); 
liberer(coli); liberer(colj); liberer(colip); liberer(coljp); liberer(colg); 

liberer(eliminee);

liberer(poids);

if (DEBUG) printf("fin aligner_entre_ancrages\n");

return(arbre);
}


void allouer_ech_front_mat(void)
{
long nmax, na;
int x;

seuil_g = (indice **) callouer_mat(sizeof(indice), maxlong+2, R+1); 	/* sera re'alloue' */
seuil_d = (indice **) callouer_mat(sizeof(indice), maxlong+2, R+1); 	/* sera re'alloue' */

ech = (echelle *) allouer((maxlong+2) * sizeof(echelle));		/* sera re'alloue' */
for (na=0; na <= maxlong+1; na++)
    {
	ech[na].ind = (indice *) allouer(R * sizeof(indice));
    }
anech = maxlong;

for (x=0; x < R; x++)
   {
	seq[x].ech = (indice *) allouer((seq[x].longueur+2)*sizeof(indice));
	seq[x].pos_ech_pred = (indice *) 
				allouer((seq[x].longueur+2)*sizeof(indice));
	seq[x].pos_ech_succ = (indice *) 
				allouer((seq[x].longueur+2)*sizeof(indice));
   }

gauche1 = (indice *) allouer(R * sizeof(indice));
gauche2 = (indice *) allouer(R * sizeof(indice));
droite1 = (indice *) allouer(R * sizeof(indice));
droite2 = (indice *) allouer(R * sizeof(indice));
pos_ = (indice **) callouer_mat(sizeof(indice), R, R);
Classe = (int **) callouer_mat(sizeof(int), R, R+2);

}

void liberer_ech_front_mat(void)
{
long nmax, na;
int x;

liberer_mat((void **) Classe, R);
liberer(gauche1); liberer(gauche2); liberer(droite1); liberer(droite2); 
liberer_mat((void **) pos_, R); 

liberer_mat((void **) seuil_d, anech+2); liberer_mat((void **) seuil_g, anech+2);

for (x=0; x < R; x++)
   {
	liberer(seq[x].ech); 
	liberer(seq[x].pos_ech_pred); 
	liberer(seq[x].pos_ech_succ); 
   }

for (na=0; na <= anech+1; na++)
   {
	liberer(ech[na].ind); 
    }
liberer(ech);
}

void meme_Classe(indice s1, indice s2)
{
indice s, r, r1, r2, n, n1, n2, i1, i2;


r1 = Classe[s1][REP_CLASSE];
r2 = Classe[s2][REP_CLASSE];
n1 = Classe[r1][NBRE_SEG];
n2 = Classe[r2][NBRE_SEG];

if (n1 < n2)
    { 
	s = s1; s1 = s2; s2 = s; 
	r = r1; r1 = r2; r2 = r; 
	n = n1; n1 = n2; n2 = n; 
    }


for (i1=IDX+n1, i2=IDX; i2 < IDX + n2; i2++, i1++)
    {
	s = Classe[r1][i1] = Classe[r2][i2];
	Classe[s][REP_CLASSE] = r1;
    }
    

n = Classe[r1][NBRE_SEG] += n2;
}

score cout_alignement_paire(int x , int y, int longalig)
{
char car1, car2;
score cout;
indice i, k, premier_x, dernier_x, premier_y, dernier_y, debut, fin;

if (!COMPTE_GAPS_EXTREMAUX)
    {
	premier_x = premier_y = 0;

	for (i=1; i <= longalig; i++)
	   {
		if (seq[x].alig[i] != '-')
		     {
			if (premier_x == 0)	premier_x = i;
			dernier_x = i;
		     }
		if (seq[y].alig[i] != '-')
		     {
			if (premier_y == 0)	premier_y = i;
			dernier_y = i;
		     }
	     }
    }

cout = 0;

calcul_gap_score(seq[x].longueur, seq[y].longueur);

if (!COMPTE_GAPS_EXTREMAUX)
    {
	debut = max(premier_x, premier_y);
	fin = min(dernier_x, dernier_y);
    }

for (i=1; i <= longalig; )
    {
	for (k=0; i <= longalig && seq[x].alig[i] == '-'; i++)
	    if (seq[y].alig[i] != '-')
		k++;
	if (k > 0) 
	   { 
		if (!COMPTE_GAPS_EXTREMAUX && (i <= premier_y || i > dernier_y))
			cout += betaD * k;
		else	cout += alphaD + betaD * (k - 1); 
		k = 0; 
	   }

	for (k=0; i <= longalig && seq[y].alig[i] == '-'; i++)
	    if (seq[x].alig[i] != '-')
		k++;
	if (k > 0) 
	   { 
		if (!COMPTE_GAPS_EXTREMAUX && (i <= premier_x || i > dernier_x))
			cout += betaD * k;
		else	cout += alphaD + betaD * (k - 1); 
		k = 0; 
	   }

	for (; i <= longalig 	&& seq[x].alig[i] != '-' 
				&& seq[y].alig[i] != '-'; i++)
	    {
		car1 = coder(seq[x].alig[i]);
		car2 = coder(seq[y].alig[i]);
		cout += dis[car1][car2];
	    }
    }

return(cout);
}

score cout_alignement_paire_select(int x , int y, int longalig, char *site_selectionne)
{
char car1, car2;
score cout;
indice i, k, premier_x, dernier_x, premier_y, dernier_y;


if (!COMPTE_GAPS_EXTREMAUX)
    {
	premier_x = premier_y = 0;

	for (i=1; i <= longalig; i++)
	   {
		if (seq[x].alig[i] != '-')
		     {
			if (premier_x == 0)	premier_x = i;
			dernier_x = i;
		     }
		if (seq[y].alig[i] != '-')
		     {
			if (premier_y == 0)	premier_y = i;
			dernier_y = i;
		     }
	     }
    }

cout = 0;

calcul_gap_score(seq[x].longueur, seq[y].longueur);

for (i=1; i <= longalig; )
  {
    if (site_selectionne[i])
      {
	for (k=0; i <= longalig && site_selectionne[i] && seq[x].alig[i] == '-'; i++)
	    if (seq[y].alig[i] != '-')
		k++;
	if (k > 0) 
	   { 
		if (!COMPTE_GAPS_EXTREMAUX && (i <= premier_y || i > dernier_y))
			cout += betaD * k;
		else	cout += alphaD + betaD * (k - 1); 
		k = 0; 
	   }

	for (k=0; i <= longalig && site_selectionne[i] && seq[y].alig[i] == '-'; i++)
	    if (seq[x].alig[i] != '-')
		k++;
	if (k > 0) 
	   { 
		if (!COMPTE_GAPS_EXTREMAUX && (i <= premier_x || i > dernier_x))
			cout += betaD * k;
		else	cout += alphaD + betaD * (k - 1); 
		k = 0; 
	   }

	for (; i <= longalig 	&& site_selectionne[i] 
				&& seq[x].alig[i] != '-' && seq[y].alig[i] != '-'; i++)
	    {
		car1 = coder(seq[x].alig[i]);
		car2 = coder(seq[y].alig[i]);
		cout += dis[car1][car2];
	    }
      }
    else	i++;
  }

return(cout);
}

score cout_alignement(void)
{
indice i;
int x, y;
score cout;


cout = 0;

for (x=0; x < R-1; x++)
	for (y=x+1; y < R; y++)
		cout += cout_alignement_paire(x , y, longalig);

return(cout);
}


void lissage(void)
{
indice i, ip, n, bord_min;
int x;
int ind_, anc_;

bord_min = min(4, max((lmin-1)/2, 1));


for (x=Ra; x < R; x++)
   {
	ip = 0;
	for (i=1; i <= seq[x].longueur; i++)
	    {
		if ((n=seq[x].ech[i]) == 0)	ip = i;
		else {
			if (n > 0 && i-ip < bord_min)
			    {
				seq[x].ech[i] = -n;
				ech[n].ind[x] = 0;
			    }
		     }
	    }
	ip = seq[x].longueur+1;
	for (i=seq[x].longueur; i > 0; i--)
	    {
		if ((n=seq[x].ech[i]) == 0)	ip = i;
		else {
			if (n > 0 && ip-i < bord_min)
			    {
				seq[x].ech[i] = -n;
				ech[n].ind[x] = 0;
			    }
		     }
	    }
	for (i=1; i <= seq[x].longueur; i++)
	   if (seq[x].ech[i] < 0)
	     {
		n = -seq[x].ech[i];
		seq[x].ech[i] = 0;
		ech[n].R--;
	     }
   }

for (n=1; n <= nech; n++)
	if (ech[n].R == 1)
	     {
		for (x=0; ech[n].ind[x] == 0; x++);
		i = ech[n].ind[x];
		ech[n].ind[x] = seq[x].ech[i] = 0;
	     }


}

int algo_greedy(void)
{
int x, n, nb_seq_supp;
indice i, j;
FILE *fich;
noeud *arbre;
int ind_, anc_;

minmaxlong();

allouer_ech_front_mat(); /* utilise maxlong */

init_echelles_front(); /* utilise les gaps et maxlong au cas ou NOUVELLE_SEQ */

for (x=0; x < R; x++)	/* supprimer les gaps */
	seq[x].longueur = mise_en_forme(seq[x].u, seq[x].longueur, false);

minmaxlong();

lire_distances(); /* utilise maxlong */


if (NOUVELLE_SEQ)
	printf("\nALIGNE <%s> : AJOUTE %d SEQUENCE(S) A UN ALIGNEMENT DE %d SEQUENCES\n\n",
			famille, R-Ra, Ra-1);
else	printf("\nALIGNE <%s> : %d SEQUENCES DE LONGUEURS COMPRISES ENTRE %d ET %d\n\n",
			famille, R, minlong, maxlong);
fflush(stdout);

if (DEBUG)
   for (x=0; x < R; x++)
	printf("   [%d] de longueur %d\n", x, seq[x].longueur);

if (lmax > 0) calculer_blocs();

if (CALCULER_ECHELLES)	
    {
	fich = fopen("echelles", "w");
	for (n=1; n <= nech; fprintf(fich, " %d\n", ech[n].R), n++)
	   {
		for (x=0; x < R; x++)
			if (ech[n].ind[x] > 0)	
				fprintf(fich, "{%d,%d}", x, ech[n].ind[x]);
	   }
	fclose(fich);
	exit(0);
    }

/*nb_seq_supp = eliminer_les_sequences_trop_eloignes();

if (nb_seq_supp != 0)
    {
	liberer_ech_front_mat();
	return(nb_seq_supp);
    }*/

printf("\n   2eme ETAPE: ALIGNEMENT ENTRE LES BLOCS\n\n");
fflush(stdout);

arbre = aligner_entre_ancrages();

liberer_ech_front_mat();


produire_alignement(arbre);


liberer_arbre(arbre);
liberer(noeuds);

nb_seq_supp = ecrire_plus_proches_sequences();

return (nb_seq_supp);
}

