#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
 
#include "greedy.h"

extern int segments_alignables(int x, indice i, int y, indice j, indice l);
extern double proba_paire_seg(indice l, int x, indice i, int y, indice j);


void label(facteur *h, int *seq_label, indice *position_label, indice *taille_label);
void ajouter_arc(facteur *h, int x, indice position_label, indice taille_label, indice pos);
facteur *facteur_successeur_par_une_lettre(facteur *p, int y, indice j);
facteur *nouveau_facteur(facteur *p, facteur *q, indice l);
void cherche_rapide(facteur *p, int y, indice j, indice k, facteur **hp, facteur **h);
void cherche_lent(facteur *pp, facteur *p, int y, indice j, indice k, 
		facteur **hp, facteur **h, indice *jj, indice *kk);
facteur *construire_arbre_suffixes(void);
void liberer_arbre_suffixes(facteur *arbre);
void liberer_arbre_suffixes_rec(facteur *arbre);
void sauver_position(int x, indice i, indice classe, position *P, indice *nbi);
void chercher_positions_rec(facteur *p, indice classe, position *P, indice *nbi);
void chercher_positions(facteur *p, indice classe, position *P, indice *nbi);
facteur *cherche_mot_exact_rec(facteur *p, int y, indice j, indice k);
void ajouter(coccurrence *longue, coccurrence *courte);
void creer_ensemble(occurrence *p);
void union_ensembles(coccurrence *cp, coccurrence *cq);
void fusionner_occurrences(occurrence *p, occurrence *q);
indice largeur_elargie(indice l, int x, indice i, int y, indice j, indice *pg, indice *pd);
void fusionner_occurrence_facteur_rec(occurrence *p, facteur *f, indice l);
void fusionner_occurrence_facteur(occurrence *p, facteur *f, indice l);
void fusionner_facteurs_rec(facteur *f1, facteur *f2, indice l);
void fusionner_facteurs(facteur *f1, facteur *f2, indice l);
char facteur_nouv_seq_rec(facteur *f);
char facteur_nouv_seq(facteur *f);
void cherche_mot_rec(facteur *p, int y, indice j, indice k, indice lm, indice e, facteur *mot);
void cherche_mot_smot_scr_rec(facteur *p, int y, indice j, indice k, indice lm, indice scr_min, facteur *mot);
void cherche_mot_scr_rec(facteur *p, int y, indice j, indice k, indice lm, 
					score scr_min, score scr_mot, facteur *mot);
void cherche_mot(facteur *p, int y, indice j, indice k, indice lm, indice e, facteur *mot);
void init_occurrences(facteur *f);
void init_occurrences_facteurs(facteur *p, indice k);
int groupement_segments_similaires_alignables(facteur *arbre, facteur *p, 
		indice l, indice k, indice e);
void classer_occurrences_rec(facteur *f, indice *classe, position *P, indice *nbi);
void classer_occurrences(facteur *f, indice *classe, position *P, indice *nbi);
void classer_occurrences_facteurs(facteur *p, indice k, indice *classe, position *P, indice *nbi);
void supprimer_coccurrences_rec(facteur *f);
void supprimer_coccurrences(facteur *f);
void supprimer_coccurrences_facteurs(facteur *p, indice k);
indice trier_classes(indice nclasses, position *P, indice *nbi, indice *ordre, 
	indice *presence, indice *idx_classes);
indice partition_occurrences(facteur *arbre, indice k, indice e,  
	position *P, indice *nbi, indice *ordre, indice *presence, indice *idx_classes);
void init_occurrences_rec(facteur *f);

void init_facteurs(facteur *p, indice k);
void supprimer_cfacteurs(facteur *p, indice k);
void classer_facteurs(facteur *p, indice k, indice *classe, position *P, indice *nbi);
void creer_ensemble_facteur(facteur *p);
void ajouter_facteurs(cfacteur *longue, cfacteur *courte);
void union_ensembles_facteurs(cfacteur *cp, cfacteur *cq);

extern int NBRE_LETTRES, X, INCONNU;
extern sequence *seq;
extern indice maxlong, minlong, sous_mot_long;
extern int Ra, R, nseqbasemin, nseqmin;
extern long RL;
extern indice longalig;
extern char DEBUG, PAR_ERREURS, TRIER_CLASSE, PAR_FACTEURS;
extern char decode[100];
extern lettre code[128];
extern int **sim;
extern score max_sim;
extern char NOUVELLE_SEQ;
extern double MUp;
extern indice long_bloc;

score scr_smot, scr_mot, scr_mot_min, *file_mot, scr_min_global;
indice pointeur_file;


void label(facteur *h, int *seq_label, indice *position_label, indice *taille_label)
{

*seq_label = h->seq;
*position_label = h->label_pos;
*taille_label = h->label_taille;
}

void ajouter_arc(facteur *h, int x, indice position_label, indice taille_label, indice pos)
{
facteur *t;
occurrence *o;

if (taille_label == 0) /* fin de sequence */
     {
/*printf("{%d,%d} ", x, pos);*/
	o = (occurrence *) allouer(sizeof(occurrence));
	o->pocc = h->occ;
	h->occ = o;

	o->seq = x;
	o->pos = pos;
     }
else {
	t = (facteur *) allouer(sizeof(facteur));
	t->pfrere = h->pfils;
	h->pfils = t;
	t->pfils = NULL;
	t->lien = NULL;

	t->seq = x;
	t->label_pos = position_label;
	t->label_taille = taille_label;
	t->pos = pos;

	o = (occurrence *) allouer(sizeof(occurrence));
	o->pocc = NULL;
	t->occ = o;
	o->seq = x;
	o->pos = pos;
/*printf("%d fils de %d\n", t, h);*/
     }
}

facteur *facteur_successeur_par_une_lettre(facteur *p, int y, indice j)
{
facteur *q;
lettre c;

c = coder(seq[y].u[j]);

for (q=p->pfils; q != NULL 
	&& c != coder(seq[q->seq].u[q->label_pos]); q=q->pfrere);

return(q);
}

facteur *nouveau_facteur(facteur *p, facteur *q, indice l)
{
indice j, k;
facteur *r, *fr;


j = q->label_pos; 
k = q->label_taille; 

r = (facteur *) allouer(sizeof(facteur));

r->seq = q->seq;
r->pos = q->pos;
r->label_pos = j;
r->label_taille = l;
r->occ = NULL;
r->lien = NULL;
r->pfils = q;
r->pfrere = q->pfrere;

q->label_pos = j + l;
q->label_taille = k - l; 
q->pfrere = NULL;

if (p->pfils == q)
	p->pfils = r;
else {
	for (fr=p->pfils; fr->pfrere != q ; fr=fr->pfrere);
	fr->pfrere = r;
     }

/*printf("%d fils de %d et nouveau pere de %d, labels (%d,%d,%d) et (%d,%d,%d)\n",
r, p, q, r->seq, j, l, q->seq, j+l, k-l);*/

return(r);
}

void cherche_rapide(facteur *p, int y, indice j, indice k, facteur **hp, facteur **h)
{
facteur *pp, *q;
indice s, ji;

pp = NULL;

ji = j;

while (k > 0)
   {
	pp = p;
	q = facteur_successeur_par_une_lettre(p, y, j);

	s = q->label_taille;

	if (s <= k)
	     {
		p = q;
		j += s;
		k -= s;
	     }
	else {
		p = nouveau_facteur(p, q, k);
		k = 0;
	     }
   }
*hp = pp;
*h = p;
}

void cherche_lent(facteur *pp, facteur *p, int y, indice j, indice k, 
		facteur **hp, facteur **h, indice *jj, indice *kk)
{
char b;
indice l, r, s;
int z;
facteur *q;



b = false;

if (k > 0)
  do
   {
	q = facteur_successeur_par_une_lettre(p, y, j);
	if (q == NULL)	b = true;
	else {
		label(q, &z, &r, &s);
		for (l=1; l < s && 
			coder(seq[y].u[j+l]) == coder(seq[z].u[r+l]); l++);
		j += l;
		k -= l;
		pp = p;

		if (l == s)	p = q;
		else {
			p = nouveau_facteur(p, q, l);
			b = true;
		     }
	      }
   } while(!b);

*hp = pp;
*h = p;
*jj = j;
*kk = k;
}

void liberer_arbre_suffixes_rec(facteur *f)
{
occurrence *q, *qs;

if (f->pfils != NULL)	liberer_arbre_suffixes_rec(f->pfils);

if (f->pfrere != NULL)	liberer_arbre_suffixes_rec(f->pfrere);

for (q=f->occ; q != NULL; q=qs)
    {
	qs = q->pocc;
	liberer(q);
    }
liberer(f);

}

void liberer_arbre_suffixes(facteur *f)
{
occurrence *q, *qs;

if (f->pfils != NULL)	liberer_arbre_suffixes_rec(f->pfils);

for (q=f->occ; q != NULL; q=qs)
    {
	qs = q->pocc;
	liberer(q);
    }
liberer(f);
}


facteur *construire_arbre_suffixes(void)
{
facteur *p, *hp, *h, *qp, *q, *t;
indice r, s, i, j, k, is;
int x, y;

p = (facteur *) allouer(sizeof(facteur)); /* racine */
p->pfrere = p->pfils = p->lien = NULL;
p->occ = NULL;
hp = NULL;
h = p;

x = i = 0;


do  {
	for (i++; i <= seq[x].longueur && coder(seq[x].u[i]) == INCONNU; i++);
	if (i <= seq[x].longueur)
	     {
		r = i - 1;
		for (is=i; coder(seq[x].u[is]) != INCONNU 
			&& is <= seq[x].longueur; is++);
		s = is - r;
	     }
	else {
		x++; i = 0;
	     }
    }
while (x < R && i == 0);


while (x < R)
   {

	if (hp == NULL)	
		cherche_lent(NULL, p, x, r+1, s-1, &hp, &h, &r, &s);
	else {
		label(h, &y, &j, &k);

		if (hp == p)	cherche_rapide(p, y, j+1, k-1, &qp, &q);
		else 		cherche_rapide(hp->lien, y, j, k, &qp, &q);

		h->lien = q;

		cherche_lent(qp, q, x, r, s, &hp, &h, &r, &s);
	     }

	ajouter_arc(h, x, r, s, i);

	if ((i == seq[x].longueur) 
		|| (i < seq[x].longueur && coder(seq[x].u[i+1]) == INCONNU))
	    {
		do  {
			for (i++; i <= seq[x].longueur 
				&& coder(seq[x].u[i]) == INCONNU; i++);
			if (i <= seq[x].longueur)
			     {
				r = i - 1;
				for (is=i; coder(seq[x].u[is]) != INCONNU 
					&& is <= seq[x].longueur; is++);
				s = is - r;
			     }
			else {
				x++; i = 0;
			     }
		    }
		while (x < R && i == 0);

		h->lien = p;
		hp = NULL;
		h = p; /* revenir a la racine */
	    }
	else	i++;
   }

return(p);
}


void sauver_position(int x, indice i, indice classe, position *P, indice *nbi)
{
indice c;

/*if (DEBUG)	printf("(%d,%d) ", x, i);*/

c = nbi[classe+1];

P[c].seq = x;
P[c].ind = i;

nbi[classe+1]++;
}

void chercher_positions_rec(facteur *p, indice classe, position *P, indice *nbi)
{
occurrence *q;

/*printf("arc (%d,%d,%d)\n", p->seq, p->label_pos, p->label_taille);*/

for (q=p->occ; q != NULL; q=q->pocc)
	sauver_position(q->seq, q->pos, classe, P, nbi);

if (p->pfils != NULL)	chercher_positions_rec(p->pfils, classe, P, nbi);

if (p->pfrere != NULL)	chercher_positions_rec(p->pfrere, classe, P, nbi);
}

void chercher_positions(facteur *p, indice classe, position *P, indice *nbi)
{
occurrence *q;

/*printf("arc (%d,%d,%d)\n", p->seq, p->label_pos, p->label_taille);*/

for (q=p->occ; q != NULL; q=q->pocc)
	sauver_position(q->seq, q->pos, classe, P, nbi);

if (p->pfils != NULL)	chercher_positions_rec(p->pfils, classe, P, nbi);
}

facteur *cherche_mot_exact_rec(facteur *p, int y, indice j, indice k)
/*facteur *p;  	racine de l'arbre */
/*indice k;	 	longueur du mot a rechercher */
/*int y;		sequence contenant le mot */
/*indice j;	 	position du mot a rechercher dans la sequence y */
{
char existe;
indice l, r, s;
int z;
facteur *q, *n;

existe = true;

q = facteur_successeur_par_une_lettre(p, y, j);
if (q == NULL)	existe = false;
else {
		label(q, &z, &r, &s);

		for (l=1, k--; k > 0 && l < s 
			&& coder(seq[y].u[j+l]) == coder(seq[z].u[r+l]); l++, k--);
		j += l;

		if (k > 0 && l < s)	existe = false;
     }

if (existe) 
   {
	if (k > 0) 	n = cherche_mot_exact_rec(q, y, j, k);
	else		n = q;
   }
else	n = NULL;

return(n);
}

coccurrence *rep=NULL;

void creer_ensemble(occurrence *p)
{
coccurrence *c;

c = (coccurrence *) allouer(sizeof(coccurrence));
c->suivant = NULL;
c->representant = c->dernier = c;
c->nbre = 1;
c->occ = p;

p->classe = (coccurrence *) c;
}

void ajouter(coccurrence *longue, coccurrence *courte)
{
coccurrence *c;

c = longue->dernier;

c->suivant = courte;

for (c=courte; c != NULL; c=c->suivant)
	c->representant = longue;

longue->nbre += courte->nbre;
longue->dernier = courte->dernier;

}

void union_ensembles(coccurrence *cp, coccurrence *cq)
{

if (cp->nbre <= cq->nbre)	ajouter(cq, cp);
else				ajouter(cp, cq);
}

void fusionner_occurrences(occurrence *p, occurrence *q)
{
coccurrence *cp, *cq;

if (p->classe == NULL)	creer_ensemble(p);
cp = p->classe;

if (q->classe == NULL)	creer_ensemble(q);
cq = q->classe;

if (cp->representant != cq->representant)
	union_ensembles(cp->representant, cq->representant);

}

indice largeur_elargie(indice l, int x, indice i, int y, indice j, indice *pg, indice *pd)
{
indice k, larg, jf, e, g, d, mg, md, li, lj, lx, ly;
lettre a, b, *pa, *pb;
score sc, sp, st, stmax;


	lx = seq[x].longueur;
	ly = seq[y].longueur;

	a = coder(seq[x].u[i]); b = coder(seq[y].u[j]); 
	for (g=1, mg=0, pa=(&seq[x].u[i])-1, pb=(&seq[y].u[j])-1,sp=sim[a][b],st=stmax=0; 
		i > g && j > g && g < long_bloc && (sc=sim[coder(*pa)][coder(*pb)])+sp >= scr_min_global; 
		pa--, pb--, g++, sp=sc, st+=sc)
	  if (st+sc > stmax)
	     {
		stmax = st+sc;
		mg = g;
	     }
	g = mg;

	a = coder(seq[x].u[i+l-1]); b = coder(seq[y].u[j+l-1]); 
	for (d=1, md=0, pa=(&seq[x].u[i])+l, pb=(&seq[y].u[j])+l, li=i+l, lj=j+l,sp=sim[a][b],st=stmax=0; 
		li <= lx && lj <= ly && d < long_bloc && (sc=sim[coder(*pa)][coder(*pb)])+sp >= scr_min_global; 
		li++, lj++, pa++, pb++, d++, sp=sc, st+=sc)  
	  if (st+sc > stmax)
	     {
		stmax = st+sc;
		md = d;
	     }
	d = md;

	*pg = g; *pd = d;
	return(l + g + d);
}

void fusionner_occurrence_facteur_rec(occurrence *p, facteur *f, indice l)
{
occurrence *q;
indice g, d;

for (q=f->occ; q != NULL; q=q->pocc)
    if ( segments_alignables(p->seq, p->pos, q->seq, q->pos, l) &&
	(l >= long_bloc || largeur_elargie(l, p->seq, p->pos, q->seq, q->pos, &g, &d) >= long_bloc) )
		fusionner_occurrences(p, q);

if (f->pfils != NULL)	fusionner_occurrence_facteur_rec(p, f->pfils, l);

if (f->pfrere != NULL)	fusionner_occurrence_facteur_rec(p, f->pfrere, l);
}

void fusionner_occurrence_facteur(occurrence *p, facteur *f, indice l)
{
occurrence *q;
indice g, d;

for (q=f->occ; q != NULL; q=q->pocc)
    if ( segments_alignables(p->seq, p->pos, q->seq, q->pos, l) &&
	(l >= long_bloc || largeur_elargie(l, p->seq, p->pos, q->seq, q->pos, &g, &d) >= long_bloc) )
		fusionner_occurrences(p, q);

if (f->pfils != NULL)	fusionner_occurrence_facteur_rec(p, f->pfils, l);
}

void fusionner_facteurs_rec(facteur *f1, facteur *f2, indice l)
{
occurrence *q;

for (q=f1->occ; q != NULL; q=q->pocc)
    if (!NOUVELLE_SEQ || q->seq >= Ra)
	fusionner_occurrence_facteur(q, f2, l);

if (f1->pfils != NULL)	fusionner_facteurs_rec(f1->pfils, f2, l);

if (f1->pfrere != NULL)	fusionner_facteurs_rec(f1->pfrere, f2, l);
}

void creer_ensemble_facteur(facteur *p)
{
cfacteur *c;

c = (cfacteur *) allouer(sizeof(cfacteur));
c->suivant = NULL;
c->representant = c->dernier = c;
c->mot = p;
c->nbre = 1;

p->lien = (facteur *) c;
}

void ajouter_facteurs(cfacteur *longue, cfacteur *courte)
{
cfacteur *c;

c = longue->dernier;

c->suivant = courte;

for (c=courte; c != NULL; c=c->suivant)
	c->representant = longue;

longue->nbre += courte->nbre;
longue->dernier = courte->dernier;

}

void union_ensembles_facteurs(cfacteur *cp, cfacteur *cq)
{

if (cp->nbre <= cq->nbre)	ajouter_facteurs(cq, cp);
else				ajouter_facteurs(cp, cq);
}

char facteur_nouv_seq_rec(facteur *f)
{
occurrence *q;

for (q=f->occ; q != NULL && q->seq < Ra; q=q->pocc);
if (q != NULL) return(true);
else {
	if (f->pfils != NULL && facteur_nouv_seq_rec(f->pfils))
		return(true);
	else {
		if (f->pfrere != NULL)	
			return(facteur_nouv_seq_rec(f->pfrere));
		else	return(false);
	     }
     }
}

char facteur_nouv_seq(facteur *f)
{
occurrence *q;

for (q=f->occ; q != NULL && q->seq < Ra; q=q->pocc);
if (q != NULL) return(true);
else {
	if (f->pfils != NULL && facteur_nouv_seq_rec(f->pfils))
		return(true);
	else 	return(false);
     }
}

void fusionner_facteurs(facteur *f1, facteur *f2, indice l)
{
occurrence *q;
cfacteur *cp, *cq;

if (PAR_FACTEURS)
     {
	if (f1->lien == NULL)	creer_ensemble_facteur(f1);
	cp = (cfacteur *) f1->lien;

	if (f2->lien == NULL)	creer_ensemble_facteur(f2);
	cq = (cfacteur *) f2->lien;

	if (cp->representant != cq->representant &&
			(!NOUVELLE_SEQ || facteur_nouv_seq(f1)))
		union_ensembles_facteurs(cp->representant, cq->representant);
     }
else {
	for (q=f1->occ; q != NULL; q=q->pocc)
	    if (!NOUVELLE_SEQ || q->seq >= Ra)
		fusionner_occurrence_facteur(q, f2, l);

	if (f1->pfils != NULL)	fusionner_facteurs_rec(f1->pfils, f2, l);
     }
}



void cherche_mot_rec(facteur *p, int y, indice j, indice k, indice lm, indice e, facteur *mot)
/*facteur *p;  	racine de l'arbre */
/*indice k;		longueur du mot a rechercher */
/*int y;		sequence contenant le mot */
/*indice j;		position du mot a rechercher dans la sequence y */
/*indice e;		nombre d'erreurs maximum */
/*facteur *mot;	*/
{
indice l, r, s, ne, kk;
int z;
facteur *q, *n;

scr_min_global = 0;

if (p != NULL)
    {
	label(p, &z, &r, &s);

	for (l=0, ne=0, kk=k; ne <= e && kk > 0 && l < s; l++, kk--)
	   if (coder(seq[y].u[j+l]) != coder(seq[z].u[r+l]))
		ne++;

	if (ne <= e)
	   {
		if (kk == 0)	fusionner_facteurs(p, mot, lm);
		else {
			if (e-ne > 0)
				cherche_mot_rec(p->pfils, y, j+s, kk, lm, e-ne, mot);
			else {
				q = cherche_mot_exact_rec(p, y, j+s, kk);
				if (q != NULL)	fusionner_facteurs(q, mot, lm);
			     }
		     }
	   }

	cherche_mot_rec(p->pfrere, y, j, k, lm, e, mot);
    }
}

void cherche_mot_smot_scr_rec(facteur *p, int y, indice j, indice k, indice lm, indice scr_min, facteur *mot)
/*facteur *p;  	racine de l'arbre */
/*indice k;	 	longueur du mot a rechercher */
/*int y;		 	sequence contenant le mot */
/*indice j;	 	position du mot a rechercher dans la sequence y */
/*indice scr_min;	score de sous mot minimum */
/*facteur *mot;	*/
{
indice l, r, s, kk, i;
int z;
facteur *q, *n;
score scrp, anc_file_mot[1000], anc_scr_smot, anc_scr_mot;
indice anc_pointeur_file;

if (p != NULL)
    {
	label(p, &z, &r, &s);

	anc_scr_mot = scr_mot;
	anc_scr_smot = scr_smot;
	anc_pointeur_file = pointeur_file;
	for (i=0; i < sous_mot_long; i++)
		anc_file_mot[i] = file_mot[i];

	for (l=0, kk=k; scr_smot >= scr_min && kk > 0 && l < s; l++, kk--)
	   {
		scr_smot -= file_mot[pointeur_file];
		scrp = sim[coder(seq[y].u[j+l])][coder(seq[z].u[r+l])];
		file_mot[pointeur_file] = scrp;
		pointeur_file = (pointeur_file + 1) % sous_mot_long;
		scr_smot += scrp;
		scr_mot += scrp;
	   }

	if (scr_smot >= scr_min && scr_mot+kk*max_sim >= scr_mot_min)
	   {
		if (kk == 0)
		     {
			if (scr_mot >= scr_mot_min)
				fusionner_facteurs(p, mot, lm);
		     }
		else 		
			cherche_mot_smot_scr_rec(p->pfils, y, j+s, kk, lm, scr_min, mot);
	   }

	scr_mot = anc_scr_mot;
	scr_smot = anc_scr_smot;
	pointeur_file = anc_pointeur_file;
	for (i=0; i < sous_mot_long; i++)
		file_mot[i] = anc_file_mot[i];

	cherche_mot_smot_scr_rec(p->pfrere, y, j, k, lm, scr_min, mot);
    }
}


void cherche_mot_scr_rec(facteur *p, int y, indice j, indice k, indice lm, 
					score scr_min, score scr_mot, facteur *mot)
/*facteur *p;  		racine de l'arbre */
/*indice k;	 	longueur du mot a rechercher */
/*int y;		sequence contenant le mot */
/*indice j;	 	position du mot a rechercher dans la sequence y */
/*indice scr_min;	score de sous mot minimum */
/*facteur *mot;	*/
{
indice l, r, s, kk, i;
int z;
score scrm, restemax, scrp;
lettre *pa, *pb;

scr_min_global = scr_min;

if (p != NULL)
    {
	scrm = scr_mot;

	label(p, &z, &r, &s);

	pa = &seq[y].u[j]; pb = &seq[z].u[r]; 

	for (l=0, kk=k, restemax=k*max_sim; 
			scrm+restemax >= scr_min && kk > 0 && l < s && (scrp = sim[coder(*pa)][coder(*pb)]) > 0; 
			l++, kk--, restemax-=max_sim, pa++, pb++)
		scrm += scrp;

	if (scrp > 0 && scrm+restemax >= scr_min)
	   {
		if (kk == 0)	fusionner_facteurs(p, mot, lm);
		else 		cherche_mot_scr_rec(p->pfils, y, j+s, kk, lm, scr_min, scrm, mot);
	   }

	cherche_mot_scr_rec(p->pfrere, y, j, k, lm, scr_min, scr_mot, mot);
    }
}


void cherche_mot(facteur *p, int y, indice j, indice k, indice lm, indice e, facteur *mot)
/*facteur *p;  	racine de l'arbre */
/*indice k;	 	longueur du mot a rechercher */
/*int y;		sequence contenant le mot */
/*indice j;	 	position du mot a rechercher dans la sequence y */
/*indice e;		nombre d'erreurs maximum ou score de sous mot minimum */
/*facteur *mot;	*/
{
indice i;
facteur *q;

if (PAR_ERREURS)	cherche_mot_rec(p->pfils, y, j, k, lm, e, mot);
else			cherche_mot_scr_rec(p->pfils, y, j, k, lm, (score) e, 0, mot);

/*else {
	scr_smot = max_sim * sous_mot_long;
	for (i=0; i < sous_mot_long; i++)
		file_mot[i] = max_sim;
	pointeur_file = 0;
	scr_mot = 0;

	cherche_mot_smot_scr_rec(p->pfils, y, j, k, lm, e, mot);
     }*/
}

void init_occurrences_rec(facteur *f)
{
occurrence *q;

for (q=f->occ; q != NULL; q=q->pocc)	q->classe = NULL;

if (f->pfils != NULL)	init_occurrences_rec(f->pfils);

if (f->pfrere != NULL)	init_occurrences_rec(f->pfrere);
}

void init_occurrences(facteur *f)
{
occurrence *q;

for (q=f->occ; q != NULL; q=q->pocc)	q->classe = NULL;

if (f->pfils != NULL)	init_occurrences_rec(f->pfils);
}

void init_occurrences_facteurs(facteur *p, indice k)
{
indice r, s;
int z;

if (p != NULL)
    {
	label(p, &z, &r, &s);

	if (k <= s)	init_occurrences(p);
	else		init_occurrences_facteurs(p->pfils, k-s);

	init_occurrences_facteurs(p->pfrere, k);
    }
}

int groupement_segments_similaires_alignables(facteur *arbre, facteur *p, 
				indice l, indice k, indice e)
{
indice r, s;
int z;

if (p != NULL)
    {
	label(p, &z, &r, &s);

	if (k <= s)
		cherche_mot(arbre, p->seq, p->pos, l, l, e, p);
	else
		groupement_segments_similaires_alignables(arbre, p->pfils, l, k-s, e);

	groupement_segments_similaires_alignables(arbre, p->pfrere, l, k, e);
    }
}

void classer_occurrences_rec(facteur *f, indice *classe, position *P, indice *nbi)
{
indice r, s, c;
int z;
coccurrence *cp;
occurrence *q;

for (q=f->occ; q != NULL; q=q->pocc)
    {
		cp = (coccurrence *) q->classe;
		if (cp != NULL && cp == cp->representant)
		    {
			c = nbi[*classe];

			while (cp != NULL)
			   {
				P[c].seq = cp->occ->seq;
				P[c].ind = cp->occ->pos;
				c++;
				cp = cp->suivant;
			   }

			if (c - nbi[*classe] >= nseqmin)
			   {
				(*classe)++;
				nbi[*classe] = c;
			   }
		    }
     }

if (f->pfils != NULL)	classer_occurrences_rec(f->pfils, classe, P, nbi);

if (f->pfrere != NULL)	classer_occurrences_rec(f->pfrere, classe, P, nbi);
}

void classer_occurrences(facteur *f, indice *classe, position *P, indice *nbi)
{
indice r, s, c;
int z;
coccurrence *cp;
occurrence *q;

for (q=f->occ; q != NULL; q=q->pocc)
    {
		cp = (coccurrence *) q->classe;
		if (cp != NULL && cp == cp->representant)
		    {
			c = nbi[*classe];

			while (cp != NULL)
			   {
				P[c].seq = cp->occ->seq;
				P[c].ind = cp->occ->pos;
				c++;
				cp = cp->suivant;
			   }

			if (c - nbi[*classe] >= nseqmin)
			   {
				(*classe)++;
				nbi[*classe] = c;
			   }
		    }
     }

if (f->pfils != NULL)	classer_occurrences_rec(f->pfils, classe, P, nbi);
}

void classer_occurrences_facteurs(facteur *p, indice k, indice *classe, position *P, indice *nbi)
{
indice r, s;
int z;
coccurrence *cp;

if (p != NULL)
    {
	label(p, &z, &r, &s);

	if (k <= s)
		classer_occurrences(p, classe, P, nbi);
	else
		classer_occurrences_facteurs(p->pfils, k-s, classe, P, nbi);

	classer_occurrences_facteurs(p->pfrere, k, classe, P, nbi);
    }
}

void supprimer_coccurrences_rec(facteur *f)
{
indice r, s, c;
int z;
coccurrence *cp, *cs;
occurrence *q;

for (q=f->occ; q != NULL; q=q->pocc)
    {
		cp = (coccurrence *) q->classe;
		if (cp != NULL && cp == cp->representant)
		    {
			while (cp != NULL)
			   {
				cp->occ->classe = NULL;
				cs = cp;
				cp = cp->suivant;
				liberer(cs);
			   }
		    }
     }

if (f->pfils != NULL)	supprimer_coccurrences_rec(f->pfils);

if (f->pfrere != NULL)	supprimer_coccurrences_rec(f->pfrere);
}

void supprimer_coccurrences(facteur *f)
{
indice r, s, c;
int z;
coccurrence *cp, *cs;
occurrence *q;

for (q=f->occ; q != NULL; q=q->pocc)
    {
		cp = (coccurrence *) q->classe;
		if (cp != NULL && cp == cp->representant)
		    {
			while (cp != NULL)
			   {
				cp->occ->classe = NULL;
				cs = cp;
				cp = cp->suivant;
				liberer(cs);
			   }
		    }
     }

if (f->pfils != NULL)	supprimer_coccurrences_rec(f->pfils);
}

void supprimer_coccurrences_facteurs(facteur *p, indice k)
{
indice r, s;
int z;

if (p != NULL)
    {
	label(p, &z, &r, &s);

	if (k <= s)
		supprimer_coccurrences(p);
	else
		supprimer_coccurrences_facteurs(p->pfils, k-s);

	supprimer_coccurrences_facteurs(p->pfrere, k);
    }
}

indice trier_classes(indice nclasses, position *P, indice *nbi, indice *ordre, 
		indice *presence, indice *idx_classes)
{
int x;
indice p, nocc, nc, maxim, ambig;
char garder;

for (x=0; x < R; x++)
    {
	presence[x] = false;
	idx_classes[x] = 0;
    }
idx_classes[R] = idx_classes[R+1] = 0;

for(nc=0;  nc < nclasses; nc++)
    {
/*printf("classe %d: ", nc);*/
	garder = true;
	nocc = 0;

	for (p=nbi[nc]; p < nbi[nc+1]; p++) 
	    {
		x = P[p].seq;
		if (!presence[x])	presence[x] = true;
		else			garder = false;
		nocc++;
/*printf("(%d,%d)", x, P[p].ind);*/
	    }

/*printf("\n");*/
	if (garder)	idx_classes[nocc+1]++;

	for (p=nbi[nc]; p < nbi[nc+1]; p++) 
	    {
		x = P[p].seq;
		presence[x] = false;
	    }
    }

for (nocc=1; nocc <= R+1; nocc++)
	idx_classes[nocc] += idx_classes[nocc-1];

maxim = idx_classes[R+1];
ambig = 0;

for(nc=0;  nc < nclasses; nc++)
    {
	garder = true;
	nocc = 0;

	for (p=nbi[nc]; p < nbi[nc+1]; p++) 
	    {
		x = P[p].seq;
		if (!presence[x])	presence[x] = true;
		else			garder = false;
		nocc++;
	    }

	if (garder)
	     {
		ordre[maxim-idx_classes[nocc]-1] = nc;
		idx_classes[nocc]++;
	     }
	else {
		ordre[idx_classes[R+1]] = nc;
		idx_classes[R+1]++;
	     }
/*
	if (garder)
	     {
		ordre[nclasses-idx_classes[nocc]-1] = nc;
		idx_classes[nocc]++;
	     }
	else {
		ordre[ambig] = nc;
		ambig++;
	     }
*/
	for (p=nbi[nc]; p < nbi[nc+1]; p++) 
	    {
		x = P[p].seq;
		presence[x] = false;
	    }
    }
return(nclasses);
}

void init_facteurs(facteur *p, indice k)
{
indice r, s;
int z;

if (p != NULL)
    {
	label(p, &z, &r, &s);

	if (k <= s)	p->lien = NULL;
	else		init_facteurs(p->pfils, k-s);

	init_facteurs(p->pfrere, k);
    }
}

void supprimer_cfacteurs(facteur *p, indice k)
{
indice r, s;
int z;
cfacteur *cp, *cf;

if (p != NULL)
    {
	label(p, &z, &r, &s);

	if (k <= s)
	    {
		cp = (cfacteur *) p->lien;
		if (!(NOUVELLE_SEQ && cp == NULL) && cp == cp->representant)
		    {
			while (cp != NULL)
			   {
				cf = cp;
				cp = cp->suivant;
				liberer(cf);
			   }
		    }
	    }
	else	supprimer_cfacteurs(p->pfils, k-s);

	supprimer_cfacteurs(p->pfrere, k);
    }
}

void classer_facteurs(facteur *p, indice k, indice *classe, position *P, indice *nbi)
{
indice r, s;
int z;
cfacteur *cp;

if (p != NULL)
    {
	label(p, &z, &r, &s);

	if (k <= s)
	    {
		cp = (cfacteur *) p->lien;
		if (!(NOUVELLE_SEQ && cp == NULL) && cp == cp->representant)
		    {
			nbi[(*classe)+1] = nbi[*classe];

			while (cp != NULL)
			   {
				chercher_positions(cp->mot, *classe, P, nbi);
				cp = cp->suivant;
			   }

			if (nbi[(*classe)+1] - nbi[*classe] >= nseqmin)
			   {
				(*classe)++;
			   }
		    }
	    }
	else	classer_facteurs(p->pfils, k-s, classe, P, nbi);

	classer_facteurs(p->pfrere, k, classe, P, nbi);
    }
}

indice partition_occurrences(facteur *arbre, indice k, indice e,  
			position *P, indice *nbi, indice *ordre, indice *presence, indice *idx_classes)
{
indice classe, cl;

if (PAR_FACTEURS)	init_facteurs(arbre->pfils, k);
else			init_occurrences_facteurs(arbre->pfils, k);

if (!PAR_ERREURS)
	file_mot = (score *) allouer(sous_mot_long * sizeof(score));

groupement_segments_similaires_alignables(arbre, arbre->pfils, k, k, e);

if (DEBUG)	printf("groupement_segments_similaires_alignables fait\n");

if (!PAR_ERREURS)	liberer(file_mot);

classe = 0; nbi[0] = 0;
if (PAR_FACTEURS)	classer_facteurs(arbre->pfils, k, &classe, P, nbi);
else			classer_occurrences_facteurs(arbre->pfils, k, &classe, P, nbi);

if (DEBUG)	printf("classer_occurrences fait\n");

if (PAR_FACTEURS)	supprimer_cfacteurs(arbre->pfils, k);
else			supprimer_coccurrences_facteurs(arbre->pfils, k);

if (DEBUG)	printf("supprimer_coccurrences_facteurs fait\n");

if (TRIER_CLASSE)
     {
	if (classe > 0) 
		classe = trier_classes(classe, P, nbi, ordre, presence, idx_classes);
     }
else {
	for (cl=0; cl < classe; cl++)	ordre[cl] = cl;
     }

return(classe);
}

