#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
 
#include "greedy.h"

extern int alignable(int x, indice i, int y, indice j);
extern int chemin(int x, indice i, int y, indice j);
extern indice frontiere_pred(int x, indice i, int y);
extern indice frontiere_succ(int x, indice i, int y);
extern int ajouter_paire_arcs(int seq1, int seq2, indice i, indice j);
extern int ajouter_paire_arcs_NOUVELLE_SEQ(int seq1, int seq2, indice i, indice j);
extern indice partition_occurrences(facteur *arbre, indice k, indice e,  
	position *P, indice *nbi, indice *ordre, indice *presence, indice *idx_classes);
extern char paire_significative(indice l, int x, indice i, indice larg1, int y, indice j, indice larg2);
extern double proba_bloc(int m, indice *l, indice *g, tbloc *bloc);
extern void lire_scores_karlin(void);
extern void breakpoint(char *s);
extern double proba_paire_seg(indice l, int x, indice i, int y, indice j);
extern void meme_Classe(indice s1, indice s2);
extern int afficher_echelle(int, indice);
extern facteur *construire_arbre_suffixes();
extern void liberer_arbre_suffixes(facteur *arbre);

void trier_seg(indice base, indice l, position_g *segments, indice pseg, indice dseg, 
	indice *ancrages, indice *ngroupes, position_b *nsegments, indice *idxg);
void trier_en_blocs_adm_rec(indice l, indice ncar, position_b *nsegments, indice pseg, indice dseg, 
	indice ns, indice nbrseg, position_g *segments, indice *idxg, indice *nbloc);
void trier_en_blocs_adm(indice l, indice ncar, position_b *nsegments, indice pseg, indice dseg, 
	indice ns, indice nbrseg, position_g *segments, indice *idxg, indice *nbloc);
indice blocs_qlq_admissibles(indice l, indice k, position *P, indice *nbi, indice *ancrages, 
	indice *idxg, indice *idxb, position_g *segments, position_b *nsegments);
indice longueur_alignable(indice l, int x, indice i, int y);
char paire_groupes_seg_significative(position_b *segments, indice s1, indice s2, indice l, 
							position_b *nsegments, tbloc *bloc);
char bloc_admissible(tbloc *bloc, indice l, indice nbre_seg);
char introduit_gap_base(int x, indice i, int sa, indice k);
char aligner(int x, indice i, int y, indice j, int z, indice k);
int inserer_bloc(tbloc *bloc, indice l, indice nbre_seg);
int inserer_bloc_elargi(tbloc *bloc, indice l, indice g, indice nbre_seg);
void liberer_tab_bloc(tabloc *blocs_sign, indice nbre_blocs);
void ajouter_bloc(tbloc *bloc, indice nbre_seg, indice nbre_blocs, double proba, indice longueur);
int decouper_en_blocs_peu_probables(position_b *nsegments, position_b *segments, 
					indice nbre_segments, indice l, tbloc *bloc, int nbre_blocs_sign);
int selectionner_blocs_significatifs(indice l, position_b *nsegments, position_b *segments_rep, 
	indice nb, indice *idxb, indice *idxg, indice ns, tbloc *bloc, int nbre_blocs_sign);
void frequences_lettres(double *p);
indice filtrer_classes(indice nclasses, position *P, indice *nbi, indice *ordre);
char blocs_compatibles(indice l, tbloc *bloc1, indice nbre_seg1, tbloc *bloc2, indice nbre_seg2);
int inserer_blocs_sign(tabloc *blocs_sign, int nbre_blocs_sign, indice l);
void calculer_blocs(void);

extern sequence *seq;
extern indice maxlong, minlong;
extern int Ra, R, nseqbasemin, nseqmin;
extern long RL;
extern indice longalig;

extern char DEBUG, PAR_ERREURS, PAIRE;
extern int FOIS;
extern char decode[100];
extern lettre code[128];
extern int NBRE_LETTRES, X, INCONNU;
extern char DNA, SIMILARITE;
extern indice lmin, lmax, nerreurs, pas, long_bloc;
extern score score_min_paire;
extern indice nech;
extern indice **seuil_g, **seuil_d;
extern echelle *ech;
extern score scr_mot_min;
extern char ELARGIR;

extern int **sim;
extern score max_sim, moy_diag_sim;

extern double MU, MUp;
extern char ESTIMER, COMPTER_BOUTS, INSERTION_DIRECTE;

extern char NOUVELLE_SEQ, PAS_GAPS_BASE;
extern int **Classe;

tabloc *blocs_sign;
int anbre_blocs_sign, NBPP;


void trier_seg(indice base, indice l, position_g *segments, indice pseg, indice dseg, 
		indice *ancrages, indice *ngroupes, position_b *nsegments, indice *idxg)
{
indice i, j, n, neg0, ng, ns, nns, g, np, deb;
int x;

/*printf("base=%d, l=%d\n", base, l);*/

ng = idxg[0] = 0;


for (ns=pseg; ns < dseg; ns++)
    {
	x = segments[ns].seq;
	i = segments[ns].ind + base;
	n = seq[x].ech[i];
	if (ancrages[n] == -1)
	     {
		ancrages[n] = ng;
		ng++;
		idxg[ng] = 1;
	     }
	else {
		g = ancrages[n];
		idxg[g+1]++;
	     }
    }


if (ng > 1)
    {
	for (g=1; g <= ng; g++)	idxg[g] += idxg[g-1];

	neg0 = idxg[1]; /* nbre de segments dans le groupe 0 */

	for (ns=pseg; ns < dseg; ns++)
	    {
		x = segments[ns].seq;
		i = segments[ns].ind + base;
		n = seq[x].ech[i];
		g = ancrages[n];
		nns = idxg[g];	
		nsegments[nns].seq = x;
		nsegments[nns].ind = segments[ns].ind;
		idxg[g]++;
	    }

	for (ns=pseg, nns=0; nns < neg0; ns++, nns++)
	    {
		segments[ns].seq = nsegments[nns].seq;
		segments[ns].ind = nsegments[nns].ind;
	    }

	for (np=0; ns < dseg; ns++, nns++)
	    {
		x = segments[ns].seq = nsegments[nns].seq;
		i = segments[ns].ind = nsegments[nns].ind;
		i += base;
		n = seq[x].ech[i];
		if (n != np)	(*ngroupes)++;
		segments[ns].grp = (*ngroupes) - 1;
		np = n;
	    }
    }

for (ns=pseg; ns < dseg; ns++)
    {
	x = segments[ns].seq;
	i = segments[ns].ind + base;
	n = seq[x].ech[i];
	ancrages[n] = -1;
    }

if (base+1 < l)
    {
	for (ns=pseg+1, deb=pseg, np=segments[pseg].grp; ns < dseg; ns++)
	    {
		ng = segments[ns].grp;
		if (ng != np)
		    {
			if (ns-deb > 1)
				trier_seg(base+1, l, segments, deb, ns, 
					ancrages, ngroupes, nsegments, idxg);
			deb = ns;
		    }
		np = ng;
	    }
	if (dseg-deb > 1)
		trier_seg(base+1, l, segments, deb, dseg, 
			ancrages, ngroupes, nsegments, idxg);
    }
}

void trier_en_blocs_adm_rec(indice l, indice ncar, position_b *nsegments, indice pseg, indice dseg, 
		indice ns, indice nbrseg, position_g *segments, indice *idxg, indice *nbloc)
{
indice i, j, jf, na, nna, s, sg, sd, idx, n, segment;
int x, y;

segment = idxg[ns];
x = segments[segment].seq;
i = segments[segment].ind + ncar;

na = nna = 0;

for (s=pseg; s < dseg; s++)
    {
	y = nsegments[s].seq;
	j = nsegments[s].ind + ncar;

	if (alignable(x,i,y,j))
	   {
		nsegments[s].ind = -nsegments[s].ind;
		na++;
	   }
	else	nna++;

    }

if (na > 0 && nna > 0)
    {
	sg = pseg; sd = dseg - 1;
	while (sg < pseg+na)
	   {
		while (sg < pseg+na && nsegments[sg].ind < 0) sg++;
		while (sd >= pseg+na && nsegments[sd].ind > 0) sd--;
		if (sg < pseg+na)
		    {
			y = nsegments[sg].seq;
			j = nsegments[sg].ind;
			idx = nsegments[sg].idx;
			n = nsegments[sg].nseg;
			nsegments[sg].seq = nsegments[sd].seq;
			nsegments[sg].ind = nsegments[sd].ind;
			nsegments[sg].idx = nsegments[sd].idx;
			nsegments[sg].nseg = nsegments[sd].nseg;
			nsegments[sd].seq = y;
			nsegments[sd].ind = j;
			nsegments[sd].idx = idx;
			nsegments[sd].nseg = n;
		    }
	   }
	for (s=pseg+na; s < dseg; s++)
		nsegments[s].blc = *nbloc;
	(*nbloc)++;
    }

for (s=pseg; s < pseg+na; s++)
	nsegments[s].ind = -nsegments[s].ind;

if (ncar+1 < l)
     {
	if (na > 1)
		trier_en_blocs_adm_rec(l, ncar+1, nsegments, pseg, pseg+na, ns, 
					nbrseg, segments, idxg, nbloc);
	if (nna > 1)
		trier_en_blocs_adm_rec(l, ncar+1, nsegments, pseg+na, dseg, ns, 
					nbrseg, segments, idxg, nbloc);
     }
else {
	if (ns+1 < nbrseg)
	    {
		if (na > 1)
			trier_en_blocs_adm_rec(l, 0, nsegments, pseg, pseg+na, ns+1, 
						nbrseg, segments, idxg, nbloc);
		if (nna > 1)
			trier_en_blocs_adm_rec(l, 0, nsegments, pseg+na, dseg, ns+1, 
						nbrseg, segments, idxg, nbloc);
	    }
     }
}

void trier_en_blocs_adm(indice l, indice ncar, position_b *nsegments, indice pseg, indice dseg, 
	indice ns, indice nbrseg, position_g *segments, indice *idxg, indice *nbloc)
{
indice i, j, jf, na, nna, s, sg, sd, idx, n, segment, nb;
int x, y;

for (s=0; s < nbrseg; s++)	nsegments[s].blc = 0;
nb = 1; 

for (ns=0; ns < nbrseg; ns++)
{
for (ncar=0; ncar < l; ncar++)
{
/*printf("ns=%d, ncar=%d\n", ns, ncar);*/

segment = idxg[ns];
x = segments[segment].seq;
i = segments[segment].ind + ncar;

for (dseg=pseg=0; dseg < nbrseg && nsegments[dseg].blc == nsegments[pseg].blc; dseg++);

while (pseg < nbrseg)
{
na = nna = 0;

for (s=pseg; s < dseg; s++)
    {
	y = nsegments[s].seq;
	j = nsegments[s].ind + ncar;

	if (alignable(x,i,y,j))
	   {
		nsegments[s].ind = -nsegments[s].ind;
		na++;
	   }
	else	nna++;
    }

if (na > 0 && nna > 0)
    {
	sg = pseg; sd = dseg - 1;
	while (sg < pseg+na)
	   {
		while (sg < pseg+na && nsegments[sg].ind < 0) sg++;
		while (sd >= pseg+na && nsegments[sd].ind > 0) sd--;
		if (sg < pseg+na)
		    {
			y = nsegments[sg].seq;
			j = nsegments[sg].ind;
			idx = nsegments[sg].idx;
			n = nsegments[sg].nseg;
			nsegments[sg].seq = nsegments[sd].seq;
			nsegments[sg].ind = nsegments[sd].ind;
			nsegments[sg].idx = nsegments[sd].idx;
			nsegments[sg].nseg = nsegments[sd].nseg;
			nsegments[sd].seq = y;
			nsegments[sd].ind = j;
			nsegments[sd].idx = idx;
			nsegments[sd].nseg = n;
		    }
	   }
	for (s=pseg+na; s < dseg; s++)
		nsegments[s].blc = nb;
	nb++;
    }

for (s=pseg; s < pseg+na; s++)
	nsegments[s].ind = -nsegments[s].ind;

for (pseg=dseg; dseg < nbrseg && nsegments[dseg].blc == nsegments[pseg].blc; dseg++);
}
}
}

}


indice blocs_qlq_admissibles(indice l, indice k, position *P, indice *nbi, indice *ancrages, 
	indice *idxg, indice *idxb, position_g *segments, position_b *nsegments)
{
indice i, j, p, ns, nsn, np, ng, s, nns, nb, b, ps, n, nsegs;
int x;

/*if (k==0) printf("blocs_qlq_admissibles\n");*/

ns = 0;
for (p=nbi[k]; p < nbi[k+1]; p++) 
    {
	x = P[p].seq;
	i = P[p].ind;

	j = P[p].ind + l - 1;
	while (i < j && seq[x].ech[i] != 0)	i++;
	if (seq[x].ech[i] == 0)
	    {
		segments[ns].seq = P[p].seq;
		segments[ns].ind = P[p].ind;
		segments[ns].grp = ns; 
		ns++;
	    }
	else 	P[p].ind = -P[p].ind;
    }

nsn = ns;

/*if (k==0) printf("1. blocs_qlq_admissibles, ns=%d\n", ns);*/

for (p=nbi[k]; p < nbi[k+1]; p++) 
    {
	i = P[p].ind;
	if (i < 0)
	    {
		segments[ns].seq = P[p].seq;
		P[p].ind = segments[ns].ind = -i;
		segments[ns].grp = nsn; 
		ns++;
	    }
    }

/*if (k==0) printf("2. blocs_qlq_admissibles, ns=%d\n", ns);*/

if (ns - nsn > 1)
     {
	ng = nsn + 1;
	trier_seg(0, l, segments, nsn, ns, ancrages, &ng, nsegments, idxg);
     }

/*if (k==0) printf("blocs_qlq_admissibles, apres trier_seg\n");*/

nsegments[0].seq = segments[0].seq;
nsegments[0].ind = segments[0].ind;
nsegments[0].idx = idxg[0] = 0;
for (s=nns=1, np=segments[0].grp; s < ns; s++)
    {
	ng = segments[s].grp;
	if (ng != np)
	    {
		nsegments[nns-1].nseg = s - idxg[nns-1];

		nsegments[nns].seq = segments[s].seq;
		nsegments[nns].ind = segments[s].ind;
		nsegments[nns].idx = idxg[nns] = s;
		nns++;
	    }
	np = ng;
    }
idxg[nns] = ns;
nsegments[nns-1].nseg = ns - idxg[nns-1];

/*if (k==0) printf("3. blocs_qlq_admissibles, nns=%d\n", nns);*/

trier_en_blocs_adm(l, 0, nsegments, 0, nns, 0, nns, segments, idxg, &nb);

/*if (k==0) printf("blocs_qlq_admissibles, apres trier_en_blocs_adm\n");*/

idxg[0] = 0;
for (s=1; s < nns; s++)
	idxg[s] = idxg[s-1] + nsegments[s-1].nseg;
idxg[nns] = ns;

for (s=nns-1; s >= 0; s--)
    {
	n = idxg[s];
	nsegments[n].blc = nsegments[s].blc;
	nsegments[n].nseg = nsegments[s].nseg;

	for (j=0, i=nsegments[s].idx; j < nsegments[n].nseg; j++, i++)
	    {
		nsegments[n+j].seq = segments[i].seq;
		nsegments[n+j].ind = segments[i].ind;
		nsegments[n+j].idx = segments[i].grp;
		nsegments[n+j].blc = nsegments[n].blc;
	    }
    }

/*if (k==0) printf("blocs_qlq_admissibles, ici\n");*/

for (s=n=0; s < nns; s++)
    {
	b = nsegments[idxg[s]].blc;
	ps = s;
	for (nsegs=0; s < nns && b == nsegments[idxg[s]].blc; s++)
		nsegs += nsegments[idxg[s]].nseg;
	if (s-ps >= 2 && nsegs >= nseqmin)
	   {
		idxb[n] = ps;
		n++;
	   }
    }
 
return(n);
}


indice longueur_alignable(indice l, int x, indice i, int y)	
/* retourne le nombre de caracteres de la seq y alignables avec le segment (x,i,l) */
{

if (x == y) 	return(seq[x].longueur);
else		return(max(l, frontiere_succ(x, i, y) - frontiere_pred(x, i+l-1, y) - 1));
}

char paire_groupes_seg_significative(position_b *segments, indice s1, indice s2, indice l, 
							position_b *nsegments, tbloc *bloc)
{
indice i, j, jf, e, longueur1, longueur2, nbre, largeur, ll, gg;
int x, y, ss, seg;
char a, b;
score scr;

if (!ESTIMER)	return(true);

x = segments[s1].seq;
y = segments[s2].seq;
i = segments[s1].ind; 
j = segments[s2].ind; 

return(proba_paire_seg(l, x, i, y, j) <= MUp);

/*longueur1 = longueur_alignable(l, x, i, y);
longueur2 = longueur_alignable(l, y, j, x);

seg = 0;
if (segments[s1].nseg > 1)	largeur = l;
else				largeur = longueur2;
for (ss=segments[s1].idx, nbre=segments[s1].nseg; nbre > 0; ss++, nbre--)
     {
	bloc[seg].seq = nsegments[ss].seq;
	bloc[seg].ind = nsegments[ss].ind;
	bloc[seg].largeur = largeur;
	seg++;
     }
if (segments[s2].nseg > 1)	largeur = l;
else				largeur = longueur1;
for (ss=segments[s2].idx, nbre=segments[s2].nseg; nbre > 0; ss++, nbre--)
     {
	bloc[seg].seq = nsegments[ss].seq;
	bloc[seg].ind = nsegments[ss].ind;
	bloc[seg].largeur = largeur;
	seg++;
     }

ll = l; gg = 0;
return(proba_bloc(segments[s1].nseg + segments[s2].nseg, &ll, &gg, bloc) <= MUp);
*/
}

char bloc_admissible(tbloc *bloc, indice l, indice nbre_seg)
{
int s1, s2, x, y;
indice i, j, jd, jf;
char car_alignable;

for (s1=1, car_alignable=true; s1 < nbre_seg && car_alignable; s1++)
     for (s2=0; s2 < s1 && car_alignable; s2++)
	    {
		x = bloc[s1].seq;
		i = bloc[s1].ind;
		y = bloc[s2].seq;
		j = jd = bloc[s2].ind;
		jf = j + l;
		for (; j < jf; i++, j++)
		   if (!alignable(x, i, y, j))	
			car_alignable = false;
	     }
return(car_alignable);
}


char introduit_gap_base(int x, indice i, int z, indice k)
{
indice n, is, p, ps;

n = seq[z].ech[k];
p = ech[n].ind[0];

is = seq[x].pos_ech_succ[i];
if (is > 0) 
   {
	n = seq[x].ech[is];
	ps = ech[n].ind[0];
	if (is - i > ps - p)	return(true);
   }

is = seq[x].pos_ech_pred[i];
if (is > 0) 
   {
	n = seq[x].ech[is];
	ps = ech[n].ind[0];
	if (i - is > p - ps)	return(true);
   }

return(false);
}

char aligner(int x, indice i, int y, indice j, int z, indice k)
{

if (!alignable(x, i, y, j))	
   {
	printf("BUG: (%d,%d) et (%d,%d) non alignables\n",x, i, y, j); 
	if (DEBUG)
	    {
		afficher_echelle(x, i);
		afficher_echelle(y, j);
	    }
	exit(0);
   }


if (NOUVELLE_SEQ && PAS_GAPS_BASE && (introduit_gap_base(x,i,z,k) || introduit_gap_base(y,j,z,k)))
	return(false);

/*if (!NOUVELLE_SEQ || R - Ra > 1)*/
	ajouter_paire_arcs(x, y, i, j);
/*else			
	ajouter_paire_arcs_NOUVELLE_SEQ(x, y, i, j);*/

return(true);
}

int inserer_bloc(tbloc *bloc, indice l, indice nbre_seg)
{
int s, x, y, z;
indice i, j, k;

z = k = 0;

if (NOUVELLE_SEQ && PAS_GAPS_BASE)
    {
	for (s=0; s < nbre_seg-1 && bloc[s].seq >= Ra; s++);
	if (bloc[s].seq < Ra)
	   {
		z = bloc[s].seq;
		k = bloc[s].ind   +l/2;
	   }
	else	return(false);
    }

for (s=0; s < nbre_seg-1; s++)
    {
	x = bloc[s].seq;
	i = bloc[s].ind   + l/2; /* n'introduire que l'ancrage central */
	y = bloc[s+1].seq;
	j = bloc[s+1].ind  + l/2;
	aligner(x, i, y, j, z, k);
    }

return(true);
}

int inserer_bloc_elargi(tbloc *bloc, indice l, indice g, indice nbre_seg)
{
int s, x, y, z;
indice i, j, jf, k;

z = k = 0;

if (NOUVELLE_SEQ && PAS_GAPS_BASE)
    {
	for (s=0; s < nbre_seg-1 && bloc[s].seq >= Ra; s++);
	if (bloc[s].seq < Ra)
	   {
		z = bloc[s].seq;
		k = bloc[s].ind   +l/2;
	   }
	else	return(false);
    }

for (s=0; s < nbre_seg-1; s++)
	    {
		x = bloc[s].seq;
		i = bloc[s].ind - g;
		y = bloc[s+1].seq;
		j = bloc[s+1].ind - g;
		jf = j + l;
		for (; j < jf; i++, j++)
			aligner(x, i, y, j, z, k);
	     }
return(true);
}

void liberer_tab_bloc(tabloc *blocs_sign, indice nbre_blocs)
{
int b;

for (b=0; b < nbre_blocs; b++)
	liberer(blocs_sign[b].bloc);

liberer(blocs_sign);
}

void ajouter_bloc(tbloc *bloc, indice nbre_seg, indice nbre_blocs, double proba, indice longueur)
{
int s;


if (nbre_blocs >= anbre_blocs_sign)
   {
	blocs_sign = (tabloc *) reallouer(blocs_sign, 2 * nbre_blocs * sizeof(tabloc));
	anbre_blocs_sign = 2 * nbre_blocs;
   }


blocs_sign[nbre_blocs].bloc = (tbloc *) allouer(nbre_seg * sizeof(tbloc));
blocs_sign[nbre_blocs].nbre = nbre_seg;
blocs_sign[nbre_blocs].proba = proba;
blocs_sign[nbre_blocs].longueur = longueur;

for (s=0; s < nbre_seg; s++)
   {
	blocs_sign[nbre_blocs].bloc[s].seq = bloc[s].seq;
	blocs_sign[nbre_blocs].bloc[s].ind = bloc[s].ind;
   }
}


int decouper_en_blocs_peu_probables(position_b *nsegments, position_b *segments, 
					indice nbre_segments, indice l, tbloc *bloc, int nbre_blocs_sign)
{
indice s1, s2, is, is1, is2, s, ss, n, i, j, jf, jd, nbre, nbre_total, anbpp, idxf, seg, largeur;
int x, y;
int ajouter_paire_arcs(int, int, indice, indice);
indice ll, gg;
double proba;

for (s=0; s < nbre_segments; s++)
    {
	Classe[s][NBRE_SEG] = 1; 
	Classe[s][REP_CLASSE] = s; 
	Classe[s][IDX] = s; 		
    }

for (s1=0; s1 < nbre_segments-1; s1++)
  for (s2=s1+1; s2 < nbre_segments; s2++)
    if ( Classe[s1][REP_CLASSE] != Classe[s2][REP_CLASSE]
     		&& paire_groupes_seg_significative(segments, s1, s2, l, nsegments, bloc) )
	meme_Classe(s1, s2);

anbpp = NBPP;

for (s=0; s < nbre_segments; s++)
  if (s == Classe[s][REP_CLASSE])
     {
	n = Classe[s][NBRE_SEG];

	idxf = IDX+n;

	seg = 0;

	for (is1=IDX, nbre_total=0; is1 < idxf; is1++)
	   {
		s1 = Classe[s][is1];
		x = segments[s1].seq;
		i = segments[s1].ind;

		if (segments[s1].nseg > 1)
			largeur = l;
		else {
			largeur = 0;
			for (is2=IDX; is2 < idxf; is2++)
			   if (is2 != is1)
			     {
				s2 = Classe[s][is2];
				y = segments[s2].seq;
				j = segments[s2].ind;

				largeur = max(largeur, longueur_alignable(l, y, j, x));
			     }
		     }

		for (ss=segments[s1].idx, nbre=segments[s1].nseg; nbre > 0; ss++, nbre--)
		     {
			bloc[seg].seq = nsegments[ss].seq;
			bloc[seg].ind = nsegments[ss].ind;
			bloc[seg].largeur = largeur;
			seg++;
		     }

		nbre_total += segments[s1].nseg;
	   }

	ll = l; gg = 0;
	if (n >= 2 && nbre_total >= nseqmin && (proba=proba_bloc(nbre_total, &ll, &gg, bloc)) <= MU)
	    {
		if (DEBUG)	printf("bloc significatif trouve\n");

		if (INSERTION_DIRECTE) 	inserer_bloc(bloc, l, nbre_total);
					/*inserer_bloc_elargi(bloc, ll, gg, nbre_total);*/
		else			ajouter_bloc(bloc, nbre_total, nbre_blocs_sign, proba, ll);

		nbre_blocs_sign++;
		NBPP++;
	    }
      }
if (DEBUG)	printf("%d bloc(s) peu probables selectionnes\n", NBPP-anbpp);

return(nbre_blocs_sign);
}



int selectionner_blocs_significatifs(indice l, position_b *nsegments, position_b *segments_rep, 
	indice nb, indice *idxb, indice *idxg, indice ns, tbloc *bloc, int nbre_blocs_sign)
{
indice b, irs, is, s, i, j, numb, jf, x;

for (b=0; b < nb; b++)
    {
	for (irs=idxb[b], numb=nsegments[idxg[irs]].blc, s=0; 
		idxg[irs] < ns && numb == nsegments[idxg[irs]].blc; irs++, s++)
	    {
		is = idxg[irs];
		x = segments_rep[s].seq = nsegments[is].seq;
		segments_rep[s].ind = nsegments[is].ind;
		segments_rep[s].nseg = nsegments[is].nseg;
		segments_rep[s].idx = is;
	    }

	nbre_blocs_sign = decouper_en_blocs_peu_probables(nsegments, segments_rep, s, l, bloc, nbre_blocs_sign);
    }

return(nbre_blocs_sign);
}


void frequences_lettres(double *p)
{
indice i, longueur;
int x;
char c;

for (i=0; i < NBRE_LETTRES; i++) p[i] = 0;
for (x=0, longueur=0; x < R; x++)
   {
   	for (i=1; i <= seq[x].longueur; i++)
	    {
		c = coder(seq[x].u[i]);
		if (c < NBRE_LETTRES)
			p[c]++;
	    }
	longueur += seq[x].longueur;
   }
for (i=0; i < NBRE_LETTRES; i++) p[i] = p[i] / longueur;
}

indice filtrer_classes(indice nclasses, position *P, indice *nbi, indice *ordre)
/* supprime les familles qui ne contiennent que des sequences deja alignes */
/* si PAS_GAPS_BASE supprime aussi ceux qui contiennent que des sequences non alignes */
{
indice p, nc, ncl, nncl, na;

for (ncl=nncl=na=0;  ncl < nclasses; ncl++)
     {
	nc = ordre[ncl];

	for (p=nbi[nc]; p < nbi[nc+1]; p++)
		if (P[p].seq >= Ra)	na++;

	if (na > 0 && (!PAS_GAPS_BASE || na != nbi[nc+1]-nbi[nc]))
	    {
		ordre[nncl] = nc;
		nncl++;
	    }
     }
return(nncl);
}



char blocs_compatibles(indice l, tbloc *bloc1, indice nbre_seg1, tbloc *bloc2, indice nbre_seg2)
{
int s1, s2, x, y;
indice i, j, jd, jf, col;
char compatibles, superieur, inferieur, supouegal, infouegal, align;

compatibles = true;

l = 1;	 /*pour gagner tu temps */

/* compatibilite' (trop) stricte 
align = alignable(bloc1[0].seq, bloc1[0].ind, bloc2[0].seq, bloc2[0].ind);

for (col=0; col < l && compatibles; col++)
  	for (s1=0; s1 < nbre_seg1 && compatibles; s1++)
	     {
		x = bloc1[s1].seq;
		i = bloc1[s1].ind + col;
		for (s2=0; s2 < nbre_seg2 && compatibles; s2++)
		    {
			y = bloc2[s2].seq;
			j = bloc2[s2].ind + col;
			if (alignable(x, i, y, j))
			     {
				if (!align)	compatibles = false;
			     }
			else {
				if (align)	compatibles = false;
			     }
		     }
	     }
*/

/*compatibilite' (trop) large */
superieur = inferieur = false;

for (col=0; col < l && compatibles; col++)
  for (s1=0; s1 < nbre_seg1 && compatibles; s1++)
     {
	x = bloc1[s1].seq;
	i = bloc1[s1].ind + col;
	for (s2=0; s2 < nbre_seg2 && compatibles; s2++)
	    {
		y = bloc2[s2].seq;
		j = bloc2[s2].ind + col;
		infouegal = chemin(x, i, y, j);
		supouegal = chemin(y, j, x, i);
		if (infouegal && !supouegal)
		     {
			inferieur = true;
			if (superieur)	compatibles = false;
		     }
		else if (supouegal && !infouegal)
		     {
			superieur = true;
			if (inferieur)	compatibles = false;
		     }
	     }
     }
return(compatibles);
}

static int compare_blocs(tabloc *bloc1, tabloc *bloc2)
{

/* ordre decroissant sur le nombre de blocs compatibles */
if (bloc1->nbre_compatibles < bloc2->nbre_compatibles)	return(1); 
if (bloc1->nbre_compatibles > bloc2->nbre_compatibles)	return(-1);

/* ordre decroissant sur la longueur des blocs (elargies) */
if (bloc1->longueur < bloc2->longueur)	return(1); 
if (bloc1->longueur > bloc2->longueur)	return(-1);

/* ordre croissant sur la probabilite' des blocs */
if (bloc1->proba > bloc2->proba)	return(1);
if (bloc1->proba < bloc2->proba)	return(-1);

return(0);
}

int inserer_blocs_sign(tabloc *blocs_sign, int nbre_blocs_sign, indice l)
{
int n, b, b1, b2;
tbloc *bloc1;

if (DEBUG)
	printf("inserer_blocs_sign\n");

for (b1=0; b1 < nbre_blocs_sign; b1++)
    {
	bloc1 = blocs_sign[b1].bloc;
	n = blocs_sign[b1].nbre;
	blocs_sign[b1].nbre_compatibles = 0;

	for (b2=0; b2 < nbre_blocs_sign; b2++)
	    if ( blocs_compatibles(l, bloc1, n, blocs_sign[b2].bloc, blocs_sign[b2].nbre) )
		blocs_sign[b1].nbre_compatibles++;

/*printf("%d, ", blocs_sign[b1].nbre_compatibles);*/
    }


if (DEBUG)
	printf("debut tri\n");

qsort((char *) blocs_sign, nbre_blocs_sign, sizeof(tabloc), 
		(int (*) (const void *, const void *)) compare_blocs);

n = 0;

if (DEBUG)
	printf("fin tri\n");

for (b=0; b < nbre_blocs_sign; b++)
  if (bloc_admissible(blocs_sign[b].bloc, l , blocs_sign[b].nbre))
     {
	inserer_bloc(blocs_sign[b].bloc, l , blocs_sign[b].nbre);
	n++;
     }

return(n);
}

void calculer_blocs(void)
{
facteur *arbre, *n;
char existe;
indice i, j, ll, gg;
long nclasses_max;
position *P;
indice *nbi, *ordre, *presence, *idx_classes, 
classe, k, *ancrages, *idxg, *idxb, l, nc, ncl, nb, m, nclasses, ns, seuil, posit, debut, fin, par;
position_b *nsegments, *segments_rep;
position_g *segments;
tbloc *bloc;
int fs, x, nseqmin_suiv, y;
int Nblocs = 0;
double prob, proba;
int nbre_blocs_sign;
int e;
int p, q;
int ind_, anc_;

if (PAR_ERREURS)	e = nerreurs;

if (pas == 0)	pas = 1;


printf("\n   1ere ETAPE: CALCUL DES BLOCS\n\n");
fflush(stdout);

arbre = construire_arbre_suffixes();

if (DEBUG) printf("Arbre construit\n");

nclasses_max = RL;
P = (position *) allouer((nclasses_max+1) * sizeof(position));
nbi = (indice *) allouer((nclasses_max+1) * sizeof(indice));
ordre = (indice *) allouer((nclasses_max+1) * sizeof(indice));
presence = (indice *) allouer(R * sizeof(indice));
idx_classes = (indice *) allouer((R+2) * sizeof(indice));

ancrages = (indice *) allouer((RL+1) * sizeof(indice));
for (l=0; l <= RL; l++)	ancrages[l] = -1;

idxg = (indice *) allouer(sizeof(indice));
idxb = (indice *) allouer(sizeof(indice));
segments = (position_g *) allouer(sizeof(position_g));
nsegments = (position_b *) allouer(sizeof(position_b));

segments_rep = (position_b *) allouer(R*sizeof(position_b));
bloc = (tbloc *) allouer(R*sizeof(tbloc));

if (DEBUG) printf("lmin=%d, lmax=%d, pas=%d, nombre de tours: %d\n", 
		lmin, lmax, pas, FOIS);

if (ELARGIR)
     {
	debut = fin = 2;
	par = 0;
     }
else {
	debut = lmax;
	fin = lmin;
	par = pas;
     }

if (score_min_paire == -1)
	score_min_paire = moy_diag_sim * lmin;


for (fs=1;  fs <= FOIS; fs++)
    {
	for (l=debut, long_bloc=lmax; long_bloc >= lmin; l-=par, long_bloc-=pas)
	   {
		if (!PAR_ERREURS)	e = (score_min_paire * l) / long_bloc;

		if (DEBUG)
		   {
			printf("-> longueur de facteur : %d", l);
			if (PAR_ERREURS)	printf("\n");
			else			printf(", score mini = %d\n", e);
		   }

/*printf("Score mini = %d\n", e);*/

		Nblocs = 0;

		nclasses = partition_occurrences(arbre, l, e,  
			P, nbi, ordre, presence, idx_classes);

		if (NOUVELLE_SEQ)
			nclasses = filtrer_classes(nclasses, P, nbi, ordre);

		for(nc=m=0;  nc < nclasses; nc++)
		    if (m < nbi[nc+1]-nbi[nc])
			m = nbi[nc+1]-nbi[nc];

/*for (ncl=0;  ncl < nclasses; ncl++)
    {
	nc = ordre[ncl];
	printf("classe %d: ", nc);
	for (p=nbi[nc]; p < nbi[nc+1]; p++)
	   {
		printf("[%d,%d] ", P[p].seq, P[p].ind);
		fflush(stdout);
	   }
	printf(" (%d segments)\n", nbi[nc+1]-nbi[nc]);
    }*/

		if (DEBUG)
			printf("\nnombre maximum de segments par classe : %d", m);

		m++;
		idxg = (indice *) reallouer(idxg, m*sizeof(indice));
		idxb = (indice *) reallouer(idxb, (m/nseqmin + 2)*sizeof(indice));
		segments = (position_g *) reallouer(segments, m*sizeof(position_g));
		nsegments = (position_b *) reallouer(nsegments, m*sizeof(position_b));

		if (DEBUG)
			printf("longueur de segment = %d, nombre de classes = %d\n", l, nclasses);

		NBPP = 0;

		nbre_blocs_sign = 0;
		if (!INSERTION_DIRECTE)
			blocs_sign = (tabloc *) allouer(2 * maxlong * sizeof(tabloc)); /* sera realloue' au besoin */
		anbre_blocs_sign = 2 * maxlong;

		if (PAIRE)
		  for (ncl=0;  ncl < nclasses; ncl++)
		     {
			nc = ordre[ncl];

			for (p=nbi[nc]+1; p < nbi[nc+1]; p++) 
			    {
				x = bloc[0].seq = P[p].seq;
				i = bloc[0].ind = P[p].ind;

				for (q=nbi[nc]; q < p; q++)
				   {
					y = bloc[1].seq = P[q].seq;
					j = bloc[1].ind = P[q].ind;

					bloc[0].largeur = longueur_alignable(l, x, i, y);
					bloc[1].largeur = longueur_alignable(l, y, j, x);

					Nblocs ++;

					ll = l; gg = 0;
					if ((proba=proba_bloc(2, &ll, &gg, bloc)) <= MU)
					    {
						ajouter_bloc(bloc, 2, nbre_blocs_sign, proba, ll);
						NBPP++;
						nbre_blocs_sign++;
					    }
/*if (x==0) { printf("%d, ", ll); fflush(stdout); }*/
				   }
			    }
		     }
		else
		  for (ncl=0;  ncl < nclasses; ncl++)
		     {
			nc = ordre[ncl];

			ns = nbi[nc+1]-nbi[nc];

			nb = blocs_qlq_admissibles(l, nc, P, nbi,
				ancrages, idxg, idxb, segments, nsegments);

			if (nb > 0) 
			   {
				if (DEBUG)
				printf("%5d: classe %d: %d blocs admissible trouves\n", l, nc, nb);

				nbre_blocs_sign = selectionner_blocs_significatifs(
							l, nsegments, segments_rep, 
							nb, idxb, idxg, ns, bloc, nbre_blocs_sign);

				if (DEBUG)
					printf(" -> %d ancrages\n", nech);
			   }
			Nblocs += nb;
		     }

		if (!INSERTION_DIRECTE)
		     {
			nb = inserer_blocs_sign(blocs_sign, nbre_blocs_sign, l);
			if (nbre_blocs_sign > 0)	liberer_tab_bloc(blocs_sign, nbre_blocs_sign);

			printf("\n%d blocs admissibles de longueur %d ont donne %d blocs significatifs, %d blocs inseres\n",
				Nblocs,long_bloc,NBPP, nb);
			fflush(stdout);
		     }
		else {
			printf("\n%d blocs admissibles de longueur %d ont donne %d blocs significatifs\n",
				Nblocs,long_bloc,NBPP);
			fflush(stdout);
		     }

	   }

    }

liberer_arbre_suffixes(arbre);

liberer(nsegments); liberer(segments); liberer(segments_rep); liberer(bloc); 
liberer(idxb); liberer(idxg); liberer(ancrages); 
liberer(nbi); liberer(ordre); liberer(presence); liberer(idx_classes);  liberer(P); 

}
