#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
 
#include "greedy.h"

extern indice mise_en_forme(lettre *, indice , char);

char ligne_nom(char *ligne);
char *lire_nom(char *ligne, char *nom);
char debut_sequence(char *ligne);
char fin_sequence(char *ligne);
void inter_car(indice i, FILE *f);
void ecrire_nom(char *nom, FILE *f);
void ecrire_annotations(ANNOTATION *, FILE *);
void ecrire_debut_seq(FILE *f);
void ecrire_fin_seq(FILE *f);
ANNOTATION *ajouter_annotation(ANNOTATION *, char *);
void liberer_annotations(ANNOTATION *);
void AjouterAnnotation(int num_seq, char *ligne);
char *LireLigne(char *ligne, FILE *f);
int LireSequence(FILE *f, int num_seq);
int LireSequences(FILE *f);
int RelireSequences(FILE *f);
void EcrireSequenceBourree(FILE *f, int num_seq);
void EcrireAlignement(FILE *f);
int AjouterSequences(FILE *f, int n);
char format(char c);


extern sequence *seq;
extern int anseq;
extern indice maxlong, minlong;
extern int Ra, R, nseqmin;
extern long RL;
extern indice longalig;
extern char DEBUG, FOIS;
extern char decode[100];
extern lettre code[128];
extern char FORMAT_SORTIE;


char *tampon;

char FORMAT, ligne_nom_vue, commentaire_sequence;
int compteur;
FILE *flux;
long position_fich_prec;


/*  --------------------------  Fonction ligne_nom

*/

char ligne_nom(char *ligne)
{
indice i, j;

switch(FORMAT) {

case 	GENBANK	:	return(strncmp(ligne,"LOCUS", 5) == 0);
case 	EMBL 	:	return(strncmp(ligne,"ID", 2) == 0);
case 	NBRF 	:	return(strncmp(ligne,">", 1) == 0);
case 	FASTA 	:	return(strncmp(ligne,">", 1) == 0);
case 	MASE 	:	return(strncmp(ligne,";", 1) != 0);

}

}

/*  --------------------------  Fonction lire_nom

*/

char *lire_nom(char *ligne, char *nom)
{
int i=0, j, l;

nom = (char *) allouer(strlen(ligne) + 1);

strcpy(nom, ligne);

switch(FORMAT) {
case 	GENBANK	:	i = 5; break;
case 	EMBL 	:	i = 2; break;
case 	NBRF 	:	 
case 	FASTA 	:	i = 1; break;
case	MASE	:	i = 0; break;
}

for (j=i, l=strlen(nom); j < l && nom[j] <= ' ' && nom[j] != '\n'; j++);

if (j < l && nom[j] != '\n') 	i = j;

for (j=0; i <= l; j++, i++)
	nom[j] = nom[i];

return(nom);
}

/*  --------------------------  Fonction debut_sequence

*/

char debut_sequence(char *ligne)
{
indice j;

if (FORMAT == F_INCONNU)
   {
	if (strncmp(ligne,"LOCUS", 5) == 0)		FORMAT = GENBANK;
	else { if (strncmp(ligne,"ID", 2) == 0)		FORMAT = EMBL; 
	else { if (strncmp(ligne,">", 1) == 0)		
		  {
			for (j=1; j < (int) strlen(ligne)-1 
					&& ligne[j] != ';'; j++);
			if (ligne[j] == ';')	FORMAT = NBRF;
			else 			FORMAT = FASTA;
		  }
	else { if (strncmp(ligne,";;", 2) == 0)		
			FORMAT = MASE;
	}}}
   }


switch(FORMAT) {

case 	GENBANK	:	return(strncmp(ligne,"ORIGIN", 6) == 0);
case 	EMBL 	:	return(strncmp(ligne,"SQ", 2) == 0);
case 	NBRF 	:	if (ligne_nom(ligne))	
			    {
				ligne_nom_vue = true;
				return(false);
			    }
			return(ligne_nom_vue);
case	MASE	:
case 	FASTA 	: 	return(ligne_nom(ligne));
default		:	return(false);
}
}

/*  --------------------------  Fonction fin_sequence

*/

char fin_sequence(char *ligne)
{

switch(FORMAT) {

case 	GENBANK	:	return(strncmp(ligne,"//", 2) == 0);
case 	EMBL 	:	return(strncmp(ligne,"//", 2) == 0);
case 	MASE 	:	if (ligne[0] == ';')
 				fseek(flux, position_fich_prec, 0);
			return(ligne[0] == ';');
case 	NBRF 	:
case 	FASTA 	:	if (ligne[0] == '>')
 				fseek(flux, position_fich_prec, 0);
 			return(ligne[0] == '>');
}
}


/*  --------------------------  Fonction liberer_annotations

*/

void liberer_annotations(ANNOTATION *annotations)
{
ANNOTATION *anot, *suiv;

for (anot=annotations; anot != NULL; anot=suiv)
   {
	suiv = anot->suivante;
	liberer(anot->annotation);
	liberer(anot);
   }
}


/*  --------------------------  Fonction ajouter_annotation

*/

ANNOTATION *ajouter_annotation(ANNOTATION *annotations, char *ligne)
{
ANNOTATION *anot;

anot = annotations;
annotations =  (ANNOTATION *) malloc(sizeof(ANNOTATION));
annotations->annotation = malloc(strlen(ligne)+1);
strcpy(annotations->annotation, ligne);
annotations->suivante = anot;

return(annotations);
}


/*  --------------------------  Fonction AjouterAnnotation

*/

void AjouterAnnotation(int num_seq, char *ligne)
{
 
seq[num_seq].annotations = ajouter_annotation(seq[num_seq].annotations, ligne);

if (ligne_nom(ligne))
 	seq[num_seq].nom = lire_nom(ligne, seq[num_seq].nom);

}

/*  --------------------------  Fonction LireLigne

*/

char *LireLigne(char *ligne, FILE *f)
{
position_fich_prec = ftell(f);
return(fgets(ligne, MAX_TAILLE_LIGNE, f));
}

/*  --------------------------  Fonction LireSequence

 retourne une sequence (avec ces annotations)
 a partir de la position courante dans le fichier f
*/

int LireSequence(FILE *f, int num_seq)
{
char c, ligne[MAX_TAILLE_LIGNE];
indice l;
int x;

 
if (num_seq+1 > anseq)
   {
	anseq = num_seq + 1;
	seq = (sequence *) reallouer(seq, anseq * sizeof(sequence));
   }

seq[num_seq].annotations = NULL;

/********* lecture des annotations	*********/

ligne_nom_vue = false;

while ( LireLigne(ligne, f) != NULL && !debut_sequence(ligne))
 	AjouterAnnotation(num_seq, ligne);

if (debut_sequence(ligne)) AjouterAnnotation(num_seq, ligne);

ligne_nom_vue = false;

/********* lecture de la sequence	*********/

 
strcpy(tampon, "");
l = 1;

while ( LireLigne(ligne, f) != NULL && !fin_sequence(ligne) )
    {
	l += strlen(ligne);
	tampon = (char *) reallouer(tampon, l);

	strcat(tampon, ligne);
    }

 
seq[num_seq].u = (char *) allouer(l+2);
strcpy(seq[num_seq].u," "); 
strcpy(seq[num_seq].u+1, tampon);

if (seq[num_seq].u[1] == 0)
     {
	liberer(seq[num_seq].u);
	return(0);
     }
else {
	seq[num_seq].longueur = 
		mise_en_forme(seq[num_seq].u, (indice) strlen(seq[num_seq].u), true);
	return(1);
     }
}

/*  --------------------------  Fonction LireSequences

  Lit un fichier de sequences et les met dans seq[]
	retourne le nombre de sequences
*/

int LireSequences(FILE *f)
{
int x;

FORMAT = F_INCONNU;
flux = f;


seq = (sequence *) allouer(100 * sizeof(sequence));
anseq = 100;

tampon = (char *) allouer(100);

for (x=0; LireSequence(f, x); x++);

liberer(tampon);

return(x);
}

/*  --------------------------  Fonction AjouterSequences

  Lit un fichier de sequences et les ajoutes aux n sequences dans seq[]
	retourne le nombre de sequences en tout
*/

int AjouterSequences(FILE *f, int n)
{
int x;

FORMAT = F_INCONNU;
flux = f;

anseq = n;

tampon = (char *) allouer(100);

for (x=n; LireSequence(f, x); x++);

liberer(tampon);


return(x);
}


/*  --------------------------  Fonction RelireSequences

  Relit un fichier de sequences retourne le nombre de sequences lues
*/

int RelireSequences(FILE *f)
{
int x;

FORMAT = F_INCONNU;
flux = f;

anseq = 2*R;

tampon = (char *) allouer(100);

for (x=0; LireSequence(f, x); x++);

liberer(tampon);

return(x);
}


/*  --------------------------  Fonction inter_car

*/

void inter_car(indice i, FILE *f)
{

if (i%60 == 1 && i != 1)	fprintf(f, "\n");

switch(FORMAT) {

case 	GENBANK	:	if (i%60 == 1)		fprintf(f, "%10d ", i);
			else if (i%10 == 1)	fprintf(f, " ");
			break;
case 	EMBL	:	if (i%60 == 1)		fprintf(f, "%10d ", i);
			else if (i%10 == 1)	fprintf(f, " ");
			break;
case 	NBRF 	:
case 	FASTA 	:
case 	MASE	:	break;
}
}

/*  --------------------------  Fonction ecrire_nom

*/

void ecrire_nom(char *nom, FILE *f)
{

switch(FORMAT) {

case 	GENBANK	:	fprintf(f, "LOCUS       %s", nom);
			break;
case 	EMBL	:	fprintf(f, "ID   %s", nom);
			break;
case 	NBRF	:	fprintf(f, ">DL;%s", nom);
			break;
case 	FASTA	:	fprintf(f, ">%s", nom);
			break;
case 	MASE	:	fprintf(f, ";\n%s", nom);
			break;
}

}

/*  --------------------------  Fonction ecrire_annotations

*/

void ecrire_annotations(ANNOTATION *annot, FILE *f)
{

if (annot != NULL) 
   {
	ecrire_annotations(annot->suivante, f);
	fprintf(f, "%s", annot->annotation);
   }
}


/*  --------------------------  Fonction ecrire_debut_seq

*/

void ecrire_debut_seq(FILE *f)
{
}

/*  --------------------------  Fonction ecrire_fin_seq

*/

void ecrire_fin_seq(FILE *f)
{
switch(FORMAT) {

case 	GENBANK	:	fprintf(f, "\n//\n");
			break;
case 	EMBL	:	fprintf(f, "\n//\n");
			break;
case 	NBRF	:	fprintf(f, "\n*\n");
			break;
case 	MASE	:
case 	FASTA	:	fprintf(f, "\n");
			break;
}
}


/*  --------------------------  Fonction EcrireSequenceBourree

*/

void EcrireSequenceBourree(FILE *f, int num_seq)
{
char c, ligne[MAX_TAILLE_LIGNE];
indice i, j;
int x;
 

/********* ecriture des annotations	*********/

if (seq[num_seq].annotations != NULL)
	ecrire_annotations(seq[num_seq].annotations, f);
else {
	if (seq[num_seq].nom != NULL)
		ecrire_nom(seq[num_seq].nom, f);
     }

/********* ecriture de la sequence	*********/

ecrire_debut_seq(f);

for (i=1; i <= longalig; i++)
    {
	inter_car(i, f);
	fprintf(f, "%c", seq[num_seq].alig[i]);
    }

ecrire_fin_seq(f);

}



/*  --------------------------  Fonction EcrireAlignement

*/

void EcrireAlignement(FILE *f)
{
int x;

if (FORMAT_SORTIE != F_INCONNU)	FORMAT = FORMAT_SORTIE;



for (x=Ra; x < R; x++)
	EcrireSequenceBourree(f, x);

}


/*  --------------------------  Fonction EcrireSequence

*/

void EcrireSequence(FILE *f, int num_seq)
{
char c, ligne[MAX_TAILLE_LIGNE];
indice i, j;
int x;
 


/********* ecriture des annotations	*********/

ecrire_nom(seq[num_seq].nom, f);


/********* ecriture de la sequence	*********/

ecrire_debut_seq(f);

for (i=1; i <= seq[num_seq].longueur; i++)
    {
	inter_car(i, f);
	fprintf(f, "%c", seq[num_seq].u[i]);
    }

ecrire_fin_seq(f);

}

/*  --------------------------  Fonction EcrireSequences

*/

void EcrireSequences(FILE *f)
{
int x;

if (FORMAT_SORTIE != F_INCONNU)	FORMAT = FORMAT_SORTIE;



for (x=Ra; x < R; x++)
	EcrireSequence(f, x);

}


/*  --------------------------  Fonction format

*/

char format(char c)
{

switch(c)
 {
	case 	'g':	return GENBANK;
	case 	'e':	return EMBL;
	case 	'n':	return NBRF;
	case 	'f':	return FASTA;
	case 	'm':	return MASE;
 }

return F_INCONNU;
}


