#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
 
#include "greedy.h"

void reallouer_ancrages(void);
void maj_echelles(indice **Succ, indice **Pred, int *NSucc, int *NPred, int *npred);
void transfert(indice n1, indice n2);
void lire_echelles(char *nom);
void init_echelles_base(indice *longueurseq);
void init_echelles_front(void);
void recalculer_frontieres(char *eliminee, indice **Succ, indice **Pred, 
	int *NSucc, int *NPred, int *npred);
double changement(int seq1, int seq2, indice i, indice j, char **ch);
int afficher_echelle(int nseq, indice i);
int ajouter_paire_arcs(int seq1, int seq2, indice i, indice j);
int ajouter_paire_arcs_NOUVELLE_SEQ(int seq1, int seq2, indice i, indice j);
int chemin(int x, indice i, int y, indice j);
int alignable(int x, indice i, int y, indice j);
int segments_alignables(int x, indice i, int y, indice j, indice l);
indice frontiere_pred(int x, indice i, int y);
indice frontiere_succ(int x, indice i, int y);
indice longueur_sgap(lettre *u, indice m);

extern char alphabet(char c);

extern int NBRE_LETTRES, X, INCONNU;
extern sequence *seq;
extern indice maxlong, minlong;
extern int Ra, R, nseqbasemin, nseqmin;
extern long RL;
extern indice longalig;

extern echelle *ech;
extern indice nech, anech;
extern indice **seuil_g, **seuil_d;
extern indice *topolog;
extern indice *gauche1, *gauche2, *droite1, *droite2, **pos_;
extern char  ECHELLES_INIT;

extern noeud **noeuds;

extern char NOUVELLE_SEQ;

extern char DEBUG;

void maj_echelles(indice **Succ, indice **Pred, int *NSucc, int *NPred, int *npred)
{
indice nsucc, ni, nj, s, top, bottom, n0, p, n, i, k, pos_n;
int x;

/* C A L C U L des Succ[n][x] et NPred[n] */

if (DEBUG) printf("ici I\n"); 

for (n=1; n <= nech; n++)	NPred[n] = 0;

for (n=1; n <= nech; n++)
   {
	nsucc = 0;
	for (x=0; x < R; x++)
	  if (ech[n].ind[x] > 0)
	     {
		pos_n = ech[n].ind[x];
		for (i=pos_n+1; i <= seq[x].longueur && seq[x].ech[i] == 0; i++)
			seq[x].pos_ech_pred[i] = pos_n;
		if (i <= seq[x].longueur)
		    {
			seq[x].pos_ech_pred[i] = pos_n;
		 	if (ech[seq[x].ech[i]].R > 0)
			    {
				n0 = Succ[n][nsucc] = seq[x].ech[i];
				ech[n0].R = - ech[n0].R;
				nsucc++;
			    }
		    }
		for (i=pos_n-1; i > 0 && seq[x].ech[i] == 0; i--)
			seq[x].pos_ech_succ[i] = pos_n;
		if (i > 0) 	
			seq[x].pos_ech_succ[i] = pos_n;
	      }
	for (p=0; p < nsucc; p++)
	     {
		n0 = Succ[n][p];
		Pred[n0][NPred[n0]] = n;
		NPred[n0]++;

		ech[n0].R = - ech[n0].R;
	     }
	NSucc[n] = nsucc;
   }

/* C A L C U L de topolog */

topolog = (indice *) reallouer(topolog, (nech+2) * sizeof(indice));

bottom = top = 0;

for (n=1; n <= nech; n++)
    {
	npred[n] = NPred[n];
	if (npred[n] == 0)	{ top++; topolog[top] = n; }
    }


while( bottom != top)
   {
	bottom++;
	ni = topolog[bottom];
	for (s=0; s < NSucc[ni]; s++)
	   {
		nj = Succ[ni][s];
		npred[nj]--;
		if (npred[nj] == 0)
		   {
			top++;
			topolog[top] = nj;
		   }
	   }
   }


for (x=0; x < R; x++)
    {
	seuil_g[0][x] = 0;
	seuil_d[nech+1][x] = seq[x].longueur+1;
    }


for (k=1; k <= nech; k++)
    {
	n0 = topolog[k];
	for (x=0; x < R; x++)
	    {
		if (ech[n0].ind[x] > 0)
			seuil_g[n0][x] = ech[n0].ind[x];
	    	else
		  for (p=0, seuil_g[n0][x]=0; p < NPred[n0]; p++)
		    {
			n = Pred[n0][p];
			if (seuil_g[n][x] > seuil_g[n0][x]) 
				seuil_g[n0][x] = seuil_g[n][x];
		    }
	    }
    }


for (k=nech; k > 0; k--)
    {
	n0 = topolog[k];
	for (x=0; x < R; x++)
	    {
		if (ech[n0].ind[x] > 0)
			seuil_d[n0][x] = ech[n0].ind[x];
		else
		  for (p=0, seuil_d[n0][x]=seq[x].longueur+1; 
					p < NSucc[n0]; p++)
		    {
			n = Succ[n0][p];
			if (seuil_d[n][x] < seuil_d[n0][x]) 
				seuil_d[n0][x] = seuil_d[n][x];
		    }
	    }
    }
}

void transfert(indice n1, indice n2)
{
int x;
indice k;

for (x=0; x < R; x++)
  {
	k = ech[n1].ind[x] = ech[n2].ind[x];
	if (k > 0)	seq[x].ech[k] = n1;

	seuil_g[n1][x] = seuil_g[n2][x];
	seuil_d[n1][x] = seuil_d[n2][x];
  }

ech[n1].R = ech[n2].R;
}

void lire_echelles(char *nom)
{
FILE *f;
int x;
indice i, ind, k;
indice **Succ, **Pred;
int *NSucc, *NPred, *npred;
char *tampon = (char *) allouer(R*25+11);

if (DEBUG) printf("lit echelles nech=%d, anech=%d\n", nech, anech);

f = fopen(nom,"r");
if (f == NULL) { printf("\nErreur dans la lecture du fichier <echelles>\n"); exit(0);}

while (fgets(tampon, R*25+10, f) != NULL)
   {
	nech++;
	reallouer_ancrages();

	for (x=0; x < R; x++)	ech[nech].ind[x] = 0;
	ech[nech].R = 0;

	i = 0;
	while(tampon[i] == '{')
	   {
		i++;
		sscanf(tampon+i, "%d", &x);
		while (tampon[i] >= '0' && tampon[i] <= '9') i++;
		i++;
		sscanf(tampon+i, "%d", &ind);
		while (tampon[i] >= '0' && tampon[i] <= '9') i++;
		i++;
		ech[nech].ind[x] = ind;
		ech[nech].R++;
		seq[x].ech[ind] = nech;
	   }
   }

fclose(f);

if (DEBUG) printf("ici lire echelles, %d echelles lues\n", nech);

liberer(tampon);

if (DEBUG) printf("apres liberation de tampon\n");

Succ = (indice **) callouer_mat(sizeof(indice), nech+2, R);
Pred = (indice **) callouer_mat(sizeof(indice), nech+2, R);
NSucc = (int *) allouer((nech+2) * sizeof(int));
NPred = (int *) allouer((nech+2) * sizeof(int));
npred = (int *) allouer((nech+2) * sizeof(int));
topolog = (indice *) allouer(sizeof(indice));

maj_echelles(Succ, Pred, NSucc, NPred, npred);

liberer(npred); liberer(NPred); liberer(NSucc); 
liberer_mat((void **) Pred, nech+2); liberer_mat((void **) Succ, nech+2); 
liberer(topolog);
}

void init_echelles_base(indice *longueurseq)
{
int x;
indice i, ind, k, nech_deb;
indice **Succ, **Pred;
int *NSucc, *NPred, *npred;
char colonne_nulle;

if (DEBUG) printf("init_echelles_base nech=%d, anech=%d\n", nech, anech);

nech_deb = nech + 1;
for (k=1; k <= maxlong; k++)
   {
	colonne_nulle = true;

	for (x=0; x < Ra && colonne_nulle; x++)
	   if (k <= longueurseq[x] && alphabet(seq[x].u[k]))
		colonne_nulle = false;

	if (!colonne_nulle)
	     {
		nech++;
		reallouer_ancrages();

		ech[nech].R = 0;
		for (x=0; x < Ra; x++)
		    {
			if (k <= longueurseq[x] && alphabet(seq[x].u[k]))
			     {
				ech[nech].ind[x] = 1;
				ech[nech].R++;
			     }
			else	ech[nech].ind[x] = 0;
		    }

		for (x=Ra; x < R; x++)	ech[nech].ind[x] = 0;
	     }
   }

for (x=0; x < Ra; x++)
 for (k=nech_deb, i=1; k <= nech; k++)
   if (ech[k].ind[x])	/* => alphabet(seq[x].u[k])*/
    {
	ech[k].ind[x] = i;
	seq[x].ech[i] = k;
	i++;
    }


if (DEBUG) printf("houna init_echelles_base, %d echelles construites\n", nech);

Succ = (indice **) callouer_mat(sizeof(indice), nech+2, R);
Pred = (indice **) callouer_mat(sizeof(indice), nech+2, R);
NSucc = (int *) allouer((nech+2) * sizeof(int));
NPred = (int *) allouer((nech+2) * sizeof(int));
npred = (int *) allouer((nech+2) * sizeof(int));
topolog = (indice *) allouer(sizeof(indice));

maj_echelles(Succ, Pred, NSucc, NPred, npred);

liberer(npred); liberer(NPred); liberer(NSucc); 
liberer_mat((void **) Pred, nech+2); liberer_mat((void **) Succ, nech+2); 
liberer(topolog);
}

indice longueur_sgap(lettre *u, indice m)
{
indice i, j, n;

for (i=1, j=0; i <= m; i++)
    if (alphabet(u[i]))		j++;

return(j);
}

void init_echelles_front(void)
{
int x;
indice i, *longueurseq;

longueurseq = (indice *) allouer(R * sizeof(indice));

for (x=0; x < R; x++)
   {
	longueurseq[x] = seq[x].longueur;
	seq[x].longueur = longueur_sgap(seq[x].u, seq[x].longueur); 
	for (i=1; i <= seq[x].longueur; i++)
		seq[x].ech[i] = seq[x].pos_ech_succ[i] = seq[x].pos_ech_pred[i] = 0;
   }

nech = 0;

if (ECHELLES_INIT)	lire_echelles("echelles");

if (NOUVELLE_SEQ)	init_echelles_base(longueurseq);

for (x=0; x < R; x++)
	seq[x].longueur = longueurseq[x];

liberer(longueurseq);
}

void recalculer_frontieres(char *eliminee, indice **Succ, indice **Pred, 
			int *NSucc, int *NPred, int *npred)
{
indice nsucc, ni, nj, s, top, bottom, n0, p, n, i, k;
int x;


/* C A L C U L des Succ[n][x] et Pred[n][x] */

for (n=1; n <= nech; n++)	NPred[n] = 0;


for (n=1; n <= nech; n++)
   {
	nsucc = 0;
	for (x=0; x < R; x++)
	  if (!eliminee[x] && ech[n].ind[x] > 0)
	     {
		for (i=ech[n].ind[x]+1; i <= noeuds[x]->longueur
			&& seq[x].ech[i] == 0; i++);
		if (i <= noeuds[x]->longueur && ech[seq[x].ech[i]].R > 0)
		    {
			n0 = Succ[n][nsucc] = seq[x].ech[i];
			ech[n0].R = - ech[n0].R;
			nsucc++;
		    }
	      }

	for (p=0; p < nsucc; p++)
	     {
		n0 = Succ[n][p];
		Pred[n0][NPred[n0]] = n;
		NPred[n0]++;

		ech[n0].R = - ech[n0].R;
	     }
	NSucc[n] = nsucc;
   }

topolog = (indice *) reallouer(topolog, (nech+2) * sizeof(indice));

bottom = top = 0;

for (n=1; n <= nech; n++)
    {
	npred[n] = NPred[n];
	if (npred[n] == 0)	{ top++; topolog[top] = n; }
    }


while( bottom != top)
   {
	bottom++;
	ni = topolog[bottom];
	for (s=0; s < NSucc[ni]; s++)
	   {
		nj = Succ[ni][s];
		npred[nj]--;
		if (npred[nj] == 0)
		   {
			top++;
			topolog[top] = nj;
		   }
	   }
   }

for (x=0; x < R; x++)
  if (!eliminee[x])
    {
	seuil_g[0][x] = 0;
	seuil_d[nech+1][x] = noeuds[x]->longueur + 1;
    }

for (k=1; k <= nech; k++)
    {
	n0 = topolog[k];

	for (x=0; x < R; x++)
	  if (!eliminee[x])
	    {
		if (ech[n0].ind[x] > 0)
			seuil_g[n0][x] = ech[n0].ind[x];
	    	else
		  for (p=0, seuil_g[n0][x]=0; p < NPred[n0]; p++)
		    {
			n = Pred[n0][p];
			if (seuil_g[n][x] > seuil_g[n0][x]) 
				seuil_g[n0][x] = seuil_g[n][x];
		    }
	    }
    }


for (k=nech; k > 0; k--)
    {
	n0 = topolog[k];

	for (x=0; x < R; x++)
	  if (!eliminee[x])
	    {
		if (ech[n0].ind[x] > 0)
			seuil_d[n0][x] = ech[n0].ind[x];
		else
		  for (p=0, seuil_d[n0][x]=noeuds[x]->longueur+1; 
					p < NSucc[n0]; p++)
		    {
			n = Succ[n0][p];
			if (seuil_d[n][x] < seuil_d[n0][x]) 
				seuil_d[n0][x] = seuil_d[n][x];
		    }
	    }
    }


}

void reallouer_ancrages(void)
{
indice na;

if (nech > anech)
   {
	seuil_g = (indice **) recallouer_mat((void **) seuil_g, sizeof(indice), 
					anech+2, nech+2, R+1);
	seuil_d = (indice **) recallouer_mat((void **) seuil_d, sizeof(indice), 
					anech+2, nech+2, R+1);
	ech = (echelle *) reallouer(ech, (nech+2) * sizeof(echelle));
	for (na=anech+2; na <= nech+1; na++)
	    {
		ech[na].ind = (indice *) allouer(R * sizeof(indice));
	    }
	anech = nech;
   }
}

double changement(int seq1, int seq2, indice i, indice j, char **ch)
{
char nouveau_, terminer;
indice n, n1, n2, ng1, ng2, nd1, nd2, nn, k, p;
int x, y;

n1 = ng1 = nd1 = seq[seq1].ech[i];	n2 = ng2 = nd2 = seq[seq2].ech[j];

if (n1 == 0 || n2 == 0 || n1 != n2)
     {
	if (ng1 == 0)
	   {
		k = seq[seq1].pos_ech_pred[i];
		if (k > 0) ng1 = seq[seq1].ech[k];
		k = seq[seq1].pos_ech_succ[i];
		if (k > 0) nd1 = seq[seq1].ech[k];
	   }
	if (ng2 == 0)
	   {
		k = seq[seq2].pos_ech_pred[j];
		if (k > 0) ng2 = seq[seq2].ech[k];
		k = seq[seq2].pos_ech_succ[j];
		if (k > 0) nd2 = seq[seq2].ech[k];
	   }


	if (ng1 == 0)	for (x=0; x < R; x++) gauche1[x] = 0;
	else		for (x=0; x < R; x++) gauche1[x] = seuil_g[ng1][x];
	if (nd1 == 0)	for (x=0; x < R; x++) droite1[x] = seq[x].longueur + 1;
	else		for (x=0; x < R; x++) droite1[x] = seuil_d[nd1][x];
	if (ng2 == 0)	for (x=0; x < R; x++) gauche2[x] = 0;
	else		for (x=0; x < R; x++) gauche2[x] = seuil_g[ng2][x];
	if (nd2 == 0)	for (x=0; x < R; x++) droite2[x] = seq[x].longueur + 1;
	else		for (x=0; x < R; x++) droite2[x] = seuil_d[nd2][x];

	gauche1[seq1] = droite1[seq1] = i;
	gauche2[seq2] = droite2[seq2] = j;

	nn = nech + 1;

	for (x=0; x < R; x++)	
	   {
		ech[nn].ind[x] = 0;
		if (n1 > 0 && ech[n1].ind[x] > 0)
			ech[nn].ind[x] = ech[n1].ind[x];
		else { if (n2 > 0 && ech[n2].ind[x] > 0)
			ech[nn].ind[x] = ech[n2].ind[x];}

		if (ech[nn].ind[x] == 0)
		    {
			seuil_g[nn][x] = max(gauche1[x], gauche2[x]);
			seuil_d[nn][x] = min(droite1[x], droite2[x]);
		    }
		else	seuil_g[nn][x] = seuil_d[nn][x] = ech[nn].ind[x];
	   }
	seuil_g[nn][seq1] = seuil_d[nn][seq1] = ech[nn].ind[seq1] = i;
	seuil_g[nn][seq2] = seuil_d[nn][seq2] = ech[nn].ind[seq2] = j;

	for (x=0; x < R; x++)
	  if (ech[nn].ind[x] > 0)
	    {
		k = ech[nn].ind[x]; n = seq[x].ech[k];
		if (n > 0)
		     {
			for (y=0; y < R; y++)
			     if (x != y && seuil_g[n][y] < seuil_g[nn][y])
				ch[x][y] = ch[y][x] = true;
		     }
		else {
			if (x == seq1)	n = ng1;
			else		n = ng2;

			if (n > 0)
			     {
				for (y=0; y < R; y++)
				     if (x != y && seuil_g[n][y] < seuil_g[nn][y])
					ch[x][y] = ch[y][x] = true;
			     }
			else {
				   for (y=0; y < R; y++)
				     if (x != y && seuil_g[nn][y] > 0)
					ch[x][y] = ch[y][x] = true;
			     }
		     }
	    }

	for (x=0; x < R; x++)
          if (droite1[x] != droite2[x])  
	    for (y=0; y < R; y++)
	      {
		k = seuil_d[nn][x];
		if (k == ech[nn].ind[x]) 	
			k = seq[x].pos_ech_succ[k];
		if (k <= seq[x].longueur && k > 0)
		    {
			n = seq[x].ech[k];
			if (seuil_g[n][y] < seuil_g[nn][y])
				ch[x][y] = ch[y][x] = true;
		    }
	      }
      }
}

int afficher_echelle(int nseq, indice i)
{
char nouveau_, terminer;
indice n, ng, nd, nn, k;
int x, y;

n = ng = nd = seq[nseq].ech[i];

if (ng == 0)
	   {
		k = seq[nseq].pos_ech_pred[i];
		if (k > 0) ng = seq[nseq].ech[k];
		k = seq[nseq].pos_ech_succ[i];
		if (k > 0) nd = seq[nseq].ech[k];
	   }

printf("echelle %d: ", n);
if (n != 0)	
   for (x=0; x < R; x++) 
	printf("%d ", ech[n].ind[x]);

printf("\nfrontiere gauche %d: ", ng);
if (ng != 0)
   for (x=0; x < R; x++) 
	printf("%d ", seuil_g[ng][x]);

printf("\nfrontiere droite %d: ", nd);
if (nd != 0)
   for (x=0; x < R; x++) 
	printf("%d ", seuil_d[nd][x]);

printf("\n");

}

int ajouter_paire_arcs(int seq1, int seq2, indice i, indice j)
{
char nouveau_, terminer;
indice n, n1, n2, ng1, ng2, nd1, nd2, nn, k;
int x, y;

n1 = ng1 = nd1 = seq[seq1].ech[i];	n2 = ng2 = nd2 = seq[seq2].ech[j];

if (n1 == 0 || n2 == 0 || n1 != n2)
     {
	if (ng1 == 0)
	   {
		k = seq[seq1].pos_ech_pred[i];
		if (k > 0) ng1 = seq[seq1].ech[k];
		k = seq[seq1].pos_ech_succ[i];
		if (k > 0) nd1 = seq[seq1].ech[k];
	   }
	if (ng2 == 0)
	   {
		k = seq[seq2].pos_ech_pred[j];
		if (k > 0) ng2 = seq[seq2].ech[k];
		k = seq[seq2].pos_ech_succ[j];
		if (k > 0) nd2 = seq[seq2].ech[k];
	   }

	if (ng1 == 0)	for (x=0; x < R; x++) gauche1[x] = 0;
	else		for (x=0; x < R; x++) gauche1[x] = seuil_g[ng1][x];
	if (nd1 == 0)	for (x=0; x < R; x++) droite1[x] = seq[x].longueur + 1;
	else		for (x=0; x < R; x++) droite1[x] = seuil_d[nd1][x];
	if (ng2 == 0)	for (x=0; x < R; x++) gauche2[x] = 0;
	else		for (x=0; x < R; x++) gauche2[x] = seuil_g[ng2][x];
	if (nd2 == 0)	for (x=0; x < R; x++) droite2[x] = seq[x].longueur + 1;
	else		for (x=0; x < R; x++) droite2[x] = seuil_d[nd2][x];

	gauche1[seq1] = droite1[seq1] = i;
	gauche2[seq2] = droite2[seq2] = j;

/*if (seq1 == 7 && seq2 == 6) printf("ici 1\n");*/

	nn = nech + 1;

	for (x=0; x < R; x++)	
	   {
		ech[nn].ind[x] = 0;
		if (n1 > 0 && ech[n1].ind[x] > 0)
			ech[nn].ind[x] = ech[n1].ind[x];
		else { if (n2 > 0 && ech[n2].ind[x] > 0)
			ech[nn].ind[x] = ech[n2].ind[x];}

		if (ech[nn].ind[x] == 0)
		    {
			seuil_g[nn][x] = max(gauche1[x], gauche2[x]);
			seuil_d[nn][x] = min(droite1[x], droite2[x]);
		    }
		else	seuil_g[nn][x] = seuil_d[nn][x] = ech[nn].ind[x];
	   }
	seuil_g[nn][seq1] = seuil_d[nn][seq1] = ech[nn].ind[seq1] = i;
	seuil_g[nn][seq2] = seuil_d[nn][seq2] = ech[nn].ind[seq2] = j;


	for (x=ech[nn].R=0; x < R; x++)
	  if (ech[nn].ind[x] > 0)
	    {
		k = ech[nn].ind[x]; 
		seq[x].ech[k] = nn;
		ech[nn].R++;
	    }

/*if (seq1 == 7 && seq2 == 6) printf("ici 2\n");*/

	for (x=0; x < R; x++)
          if (droite1[x] != droite2[x])  /* => la front. gauche peut changer */
	    for (y=0; y < R; y++)
	      {
		pos_[x][y] = 0;
		k = seuil_d[nn][x];
		if (k == ech[nn].ind[x]) 	
			k = seq[x].pos_ech_succ[k];
		if (k <= seq[x].longueur)
		  while (k > 0)
		    {
			n = seq[x].ech[k];
			if (seuil_g[n][y] < seuil_g[nn][y])
			    {
				pos_[x][y] = k;
				k = seq[x].pos_ech_succ[k];
			    }
			else	k = 0;
		    }
	      }

	for (x=0; x < R; x++)
          if (droite1[x] != droite2[x])  /* => la front. gauche peut changer */
	    for (y=0; y < R; y++)
	      {
		k = seuil_d[nn][x];
		if (k == ech[nn].ind[x]) 
			k = seq[x].pos_ech_succ[k];
		if (pos_[x][y] > 0)
		  while (k > 0 && k <= pos_[x][y])
		    {
			n = seq[x].ech[k];
			seuil_g[n][y] = seuil_g[nn][y];
			k = seq[x].pos_ech_succ[k];
		    }
	      }

/*if (seq1 == 7 && seq2 == 6) printf("ici 3\n");*/

	for (x=0; x < R; x++)
          if (gauche1[x] != gauche2[x])  /* => la front. droite peut changer */
	    for (y=0; y < R; y++)
	      {
		pos_[x][y] = 0;
		k = seuil_g[nn][x];
		if (k > 0 && k == ech[nn].ind[x])
			k = seq[x].pos_ech_pred[k];
		while (k > 0)
		    {
			n = seq[x].ech[k];
			if (seuil_d[n][y] > seuil_d[nn][y])
			    {
				pos_[x][y] = k;
				k = seq[x].pos_ech_pred[k];
			    }
			else	k = 0;
		    }
	      }

	for (x=0; x < R; x++)
          if (gauche1[x] != gauche2[x])  /* => la front. droite peut changer */
	    for (y=0; y < R; y++)
	      {
		k = seuil_g[nn][x];
		if (k > 0 && k == ech[nn].ind[x])
			k = seq[x].pos_ech_pred[k];
		if (pos_[x][y] > 0)
		  while (k >= pos_[x][y])
		    {
			n = seq[x].ech[k];
			seuil_d[n][y] = seuil_d[nn][y];
			k = seq[x].pos_ech_pred[k];
		    }
	      }

/*if (seq1 == 7 && seq2 == 6) printf("ici 3.5\n");*/

	if (n1 == 0)
	   {
		for (k=i-1; k > 0 && seq[seq1].ech[k] == 0; k--)
			seq[seq1].pos_ech_succ[k] = i;
		if (k > 0) 	
			seq[seq1].pos_ech_succ[k] = i;
		for (k=i+1; k <= seq[seq1].longueur 
					&& seq[seq1].ech[k] == 0; k++)
			seq[seq1].pos_ech_pred[k] = i;
		if (k <= seq[seq1].longueur) 	
			seq[seq1].pos_ech_pred[k] = i;
	   }

	if (n2 == 0)
	   {
		for (k=j-1; k > 0 && seq[seq2].ech[k] == 0; k--)
			seq[seq2].pos_ech_succ[k] = j;
		if (k > 0) 	
			seq[seq2].pos_ech_succ[k] = j;
		for (k=j+1; k <= seq[seq2].longueur 
					&& seq[seq2].ech[k] == 0; k++)
			seq[seq2].pos_ech_pred[k] = j;
		if (k <= seq[seq2].longueur) 	
			seq[seq2].pos_ech_pred[k] = j;
	   }

/*if (seq1 == 7 && seq2 == 6) printf("ici 4\n");*/

	if (n1 > n2)  {	n = n1; n1 = n2; n2 = n; }

	if (n2 == 0)	
	     {
		nech++;

		reallouer_ancrages();
	     }
	else { 
		if (n1 == 0)
		     {
			transfert(n2, nn);
		     }
		else  
		     {
			transfert(n1, nn);

			if (n2 < nech)	transfert(n2, nech);
			nech--;

			reallouer_ancrages();
		     }
	     }
      }
}

int ajouter_paire_arcs_NOUVELLE_SEQ(int seq1, int seq2, indice i, indice j)
{
char nouveau_, terminer;
indice n, n1, n2, k;
int x, y;

if (seq1 != R-1 && seq2 != R-1)
	return(0);

if (seq2 == R-1)
   {
	x = seq1; seq1 = seq2; seq2 = x; 
	k = i; i = j; j = k; 
   }

n1 = seq[seq1].ech[i];	n2 = seq[seq2].ech[j];

if (n1 > 0)	return(0);	/* c'est deja aligne' ! */

/* seq1 == R-1, n1 == 0, n2 > 0 */

seuil_g[n2][seq1] = seuil_d[n2][seq1] = ech[n2].ind[seq1] = i;
seq[seq1].ech[i] = n2;
ech[n2].R++;

k = seq[seq1].pos_ech_succ[i];
  while (k > 0)
    {
	n = seq[seq1].ech[k];
	if (seuil_g[n][seq1] < i)
	    {
		seuil_g[n][seq1] = i;
		k = seq[seq1].pos_ech_succ[k];
	    }
	else	k = 0;
    }

k = seq[seq1].pos_ech_pred[i];
  while (k > 0)
    {
	n = seq[seq1].ech[k];
	if (seuil_g[n][seq1] > i)
	    {
		seuil_g[n][seq1] = i;
		k = seq[seq1].pos_ech_pred[k];
	    }
	else	k = 0;
    }

for (k=i-1; k > 0 && seq[seq1].ech[k] == 0; k--)
	seq[seq1].pos_ech_succ[k] = i;
if (k > 0) 
	seq[seq1].pos_ech_succ[k] = i;
for (k=i+1; k <= seq[seq1].longueur && seq[seq1].ech[k] == 0; k++)
	seq[seq1].pos_ech_pred[k] = i;
if (k <= seq[seq1].longueur) 	
	seq[seq1].pos_ech_pred[k] = i;

}

int chemin(int x, indice i, int y, indice j)
{
indice n2, k;

if (x == y) return(i <= j);

n2 = seq[y].ech[j];

if (n2 == 0) 
    {
	k = seq[y].pos_ech_pred[j];
	if (k > 0) n2 = seq[y].ech[k];
    }

if (n2 == 0)	return(false);
else		return(i <= seuil_g[n2][x]);
}

int alignable(int x, indice i, int y, indice j)
{

if (chemin(x, i, y, j))	return(chemin(y, j, x, i));
else			return(!chemin(y, j, x, i));
}

int segments_alignables(int x, indice i, int y, indice j, indice l)
{
indice k;

for (k=0; k < l && alignable(x, i, y, j); i++, j++, k++);

return(k==l);
}

indice frontiere_pred(int x, indice i, int y) /* on suppose que x!=y */
{
indice n, k;

n = seq[x].ech[i];

if (n == 0)
   {
	k = seq[x].pos_ech_pred[i];
	if (k > 0) n = seq[x].ech[k];
   }

if (n > 0)	return(seuil_g[n][y]);
else		return(0);
}

indice frontiere_succ(int x, indice i, int y) /* on suppose que x!=y */
{
indice n, k;

n = seq[x].ech[i];

if (n == 0)
   {
	k = seq[x].pos_ech_succ[i];
	if (k > 0) n = seq[x].ech[k];
   }

if (n > 0)	return(seuil_d[n][y]);
else		return(seq[y].longueur+1);
}
