#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <string.h>
 
#include "greedy.h"

extern int LireSequences(FILE *f);
extern AjouterSequences(FILE *f, int x);
extern void EcrireAlignement(FILE *f);
extern void EcrireSequenceBourree(FILE *f, int x);
extern indice RelireSequences(FILE *f);
extern score cout_alignement(void);
extern int algo_greedy(void);
extern score cout_alignement_paire_select(int x , int y, int longalig, char *site_selectionne);
extern char format(char c);
extern void lire_scores_karlin(void);
extern void liberer_annotations(ANNOTATION *);

void breakpoint(char *s);
void minmaxlong(void);
void lire_distances(void);
indice uniformiser_longueurs(int nbseq);
void lire_sequences(int argc, char **argv);
void lire_scores_karlin(void);
void init(char ARGUMENTS, int argc, char **argv);
void desinit(void);
void statistiques(void);
void comparaison(void);
void extension(char *nom, char *famille, char *extension);
void ecrire_alignement(void);
void relire_sequences(void);
void ecrire_positions_gaps(void);
int selectionner_sites(char *site_selectionne);
float taux_prox(char *site_selectionne, int x, int y);
int ecrire_plus_proches_sequences(void);
score calcul_gap_score(indice i, indice j);
indice mise_en_forme(lettre *u, indice m, char ALIGNEMENT);
char alphabet(char c);
void greedy(int argc, char **argv);
void marquer_les_gaps_ajoutes(void);
char **greedy_tab(char **sequences, int nombre_seq, int argc, char **argv);
void introduire_sequence_fictive(void);
void supprimer_sequence_fictive(void);

extern score *(matrices[]);

char decode_dna[] = "ATCG-Natcg";
char decode_prot[] = "ABCDEFGHIKLMNPQRSTVWXYZ-?abcdefghiklmnpqrstvwzyz";
char *nom_mat;
int NUM_MAT;
char SIMILARITE;

char famille[100];
lettre code[128];
char decode[100];
char DNA;
score 	**sim, 		/* en entree */
	**dis, 		/* utilisee pour l'alignement entre les blocs (deduite de sim) */
	**sim_karlin, 	/* utilisee pour estimer les blocs (karlin.c) 
			et pour le calcul de l'arbre de groupement (paire_seq.c) */
	max_sim, moy_diag_sim;

int NBRE_LETTRES, X, INCONNU;
sequence *seq;
int anseq;
indice maxlong, minlong, sous_mot_long;
int Ra, R, nseqmin;
long RL;
indice longalig;

echelle *ech;
indice nech, anech;
indice **seuil_g, **seuil_d;
indice *topolog;
indice *gauche1, *gauche2, *droite1, *droite2, **pos_;
char  ECHELLES_INIT, CALCULER_ECHELLES;

indice lmin, lmax, nerreurs, pas, long_bloc;
double MU, MUp;
score score_min_paire;
char BLOCS, PAR_ERREURS, MARQUER_BLOCS, ESTIMER, COMPTER_BOUTS, PAIRE, 
	INSERTION_DIRECTE, TRIER_CLASSE, PAR_FACTEURS;
int FOIS;

double TAUX_MIN, TAUX_SITE_SELECT;
indice BORD_SITE;
char PS;
int TOUR;

score DISTANCE_MAX;
char plein = '#', vide = ' ';
int long_branche = 3, separation = 2;
int num_feuille;
char **grille, NJ;
noeud **noeuds;

score alphaS, betaS, alphaD, betaD, alphaK, betaK;
float beta, alpha;
char pas_d_insertion, pas_de_suppression;
char CLUSTALW;
char COMPTE_GAPS_EXTREMAUX, DISTANCES_PAR_BLOCS, PROFILE, 
ELARGIR, COMPTE_GAP_GAP, MARQUER_GAPS_AJOUTES, PAS_GAPS_BASE;
lettre *coli, *colj, *colip, *coljp, *colg;
int *num_seq1, *num_seq2;
int nbseq1, nbseq2, nbseq;
gscore *d, *f;
gscore SCORE_MIN, DISTANCE_ALIG_MAX;

char *histoire_d, *histoire_f, histoire_e;
char histoire_d_ip_jp, histoire_d_sauv;
char *histoire_pp_remp, *histoire_pp_supp, *histoire_pp_inse;

int (*pp)[2], (*succ_pp)[3], *pp_i, *Rr, *Lr;
char (*tpp)[2], (*succ_tpp)[3], *contrainte;
indice alongueur1, alongueur2, asomme;

char NOUVELLE_SEQ, METTRE_SEQ_BASE;
char nom_fich_seq_ref[100];
int **Classe;

char **ch;
score **dist_entre_seq;
char RECURSIF;
char DEBUG, STATISTIQUES, COMPARAISON;

char FORMAT_SORTIE;


void breakpoint(char *s)
{
static int i=0;
char rien[20];

printf("ici %d: %s\n", i++, s);
fflush(stdout);	/* ++pac */
gets(rien);
}


void **callouer_mat(size_t t_elt, size_t nb_lig, size_t nb_col)
{
void **pointeur;
int i;


/*printf("%d, %d, %d  ", t_elt, nb_lig, nb_col);
breakpoint("callouer_mat");*/

pointeur = (void **) allouer(nb_lig * sizeof(void *));

for (i=0; i < nb_lig; i++)
	pointeur[i] = (void *) allouer(nb_col * t_elt);

return(pointeur);
}

void **recallouer_mat(void **pointeur, size_t t_elt, size_t anc_nb_lig, 
		size_t nb_lig, size_t nb_col)
{
int i;

/*breakpoint("recallouer_mat");*/

if (anc_nb_lig == nb_lig)	return(pointeur);

for (i=nb_lig; i < anc_nb_lig; i++)
	liberer(pointeur[i]);

pointeur = (void **) reallouer(pointeur, nb_lig * sizeof(void *));

for (i=anc_nb_lig; i < nb_lig; i++)
	pointeur[i] = (void *) allouer(nb_col * t_elt);

return(pointeur);
}

void **recallouer_mat2(void **pointeur, size_t t_elt, 
		size_t anc_nb_lig, size_t nb_lig, size_t nb_col)
{
int i;
/*breakpoint("recallouer_mat2");*/

for (i=nb_lig; i < anc_nb_lig; i++)
	liberer(pointeur[i]);

pointeur = (void **) reallouer(pointeur, nb_lig * sizeof(void *));

for (i=0; i < min(anc_nb_lig, nb_lig); i++)
	pointeur[i] = (void *) reallouer(pointeur[i], nb_col * t_elt);

for (i=anc_nb_lig; i < nb_lig; i++)
	pointeur[i] = (void *) allouer(nb_col * t_elt);

return(pointeur);
}

void liberer_mat(void **pointeur, size_t nb_lig)
{
int i;

for (i=0; i < nb_lig; i++)
	liberer(pointeur[i]);

liberer(pointeur);
}


char alphabet(char c)
{
return(c>='A' && c<='Z') || (c>='a' && c<='z');
}

indice mise_en_forme(lettre *u, indice m, char ALIGNEMENT)
{
indice i, j, n;

if (ALIGNEMENT)
     {	
	for (i=1, j=0; i <= m; i++)
	   {
		if ((u[i] == '-') || alphabet(u[i]))
		     {
			j++;
			u[j] = u[i]; 
		     }
	   }
     }
else {
   	for (i=1, j=0; i <= m; i++)
	  if (alphabet(u[i]))
	     {
		j++;
		u[j] = u[i]; 
	     }
     }

u[0] = ' ';
u[j+1] = 0;

return(j);
}

void minmaxlong(void)
{
int x;

for (x=1,RL=minlong=maxlong=seq[0].longueur; x < R; x++)
     {
	if (minlong > seq[x].longueur) minlong = seq[x].longueur;
	if (maxlong < seq[x].longueur) maxlong = seq[x].longueur;

	RL += seq[x].longueur;
     }

if (DEBUG)
	printf("\nles longueurs des %d sequences varient entre %d et %d. Longueur totale : %ld\n", 
		R, minlong, maxlong, RL);

}

score calcul_gap_score(indice i, indice j)
{
score g, gh;
double r;

if (i <= 0 || j <= 0) return(0);

/* dans Clustal W

        if (dnaflag) {
           g = 200.0 * (float)pw_go_penalty;
           gh = pw_ge_penalty * 100.0;
        }
        else {
           if (mat_avscore <= 0)
              g = 200.0 * (float)(pw_go_penalty + log((double)(MIN(n,m))));
           else
              g = 2.0 * mat_avscore * (float)(pw_go_penalty +
                    log((double)(MIN(n,m))));
           gh = pw_ge_penalty * 100.0;
        }
*/

if (CLUSTALW)
     {
	if (DNA)	g = (score) (200. * alpha);
	else		{r = (double) (2. * 113 * (alpha + log( (double) (min(i,j)) ) ));
			g = (score) r; }
	gh = (score) (beta * 100.);

	alphaS = - (g + gh) / 10;
	betaS = - gh / 10;
     }
else {	
	alphaS = (score) - alpha;
	betaS = (score) - beta;
     }

alphaD = -alphaS + max_sim/2;
betaD = -betaS + max_sim/2;

if (DEBUG)	printf("  gap cost: %d + %d (k-1) \n", alphaD, betaD);
}

void lire_distances(void)
{
char c;
score cste, moy_s, max_s, min_s;
int i, j, n1, n2, n;
FILE *f;
char nombre[10], k;


if (nom_mat != NULL)
    {
	f = fopen(nom_mat,"rb");
	if (f == NULL) 
	{printf("\nErreur dans la lecture du fichier %s\n", nom_mat); exit(0);}

	for (j=0; j < NBRE_LETTRES; j++)
	   for (i=0; i <= j; i++)
	     {
		while (fread(&c, 1, 1, f)==1 
				&& c != '-' && (c < '0' || c > '9'));
		for (nombre[0]=c, k=1; fread(&c, 1, 1, f)==1 
				&& (c == '-' || (c >= '0' && c <= '9')); k++) 
			nombre[k] = c;
		nombre[k] = 0;

		sscanf(nombre,"%d", &sim[i][j]);
	     }
	fclose(f);
     }
else {
	if (DNA)
	    {
		if (CLUSTALW)
		     {
			sim[0][0] = sim[1][1] = sim[2][2] = sim[3][3] = 100;
			sim[0][3] = sim[1][2] = 50;
			sim[0][1] = sim[0][2] = sim[1][3] = sim[2][3] = 0;
		     }
		else {
			sim[0][0] = sim[1][1] = sim[2][2] = sim[3][3] = 2;
			sim[0][3] = sim[1][2] = 1;
			sim[0][1] = sim[0][2] = sim[1][3] = sim[2][3] = 0;
		     }
	    }
	else
	    {
		for (j=n=0; j < NBRE_LETTRES; j++)
		    for (i=0; i <= j; i++, n++)
			sim[i][j] = matrices[NUM_MAT][n] * 10;
	    }
     }

if (CLUSTALW)
     {
	if (alpha == -1)	
	   {
		if (DNA)	alpha = 10;
		else		alpha = 10;
	   }
	if (beta == -1)
	   {
		if (DNA)	beta = 5; 
		else		beta = 0.1;
	   }
     }
else {
	if (alpha == -1)	
	   {
		if (DNA)	alpha = 5;
		else		alpha = 300;
	   }
	if (beta == -1)
	   {
		if (DNA)	beta = 2;
		else		beta = 200;
	   }
     }

alphaS = - alpha;
betaS = - beta;

max_s = min_s = sim[0][0]; moy_s = 0;

for (j=0; j < NBRE_LETTRES; j++)
	for (i=0; i <= j; i++)
            {
		sim[j][i] = sim[i][j];
		if (sim[i][j] > max_s) max_s = sim[i][j];
		if (sim[i][j] < min_s) min_s = sim[i][j];
		moy_s += sim[i][j];
            }

max_sim = max_s;

moy_s = moy_s / (NBRE_LETTRES * (NBRE_LETTRES-1) / 2);

for (i=0, moy_diag_sim=0; i < NBRE_LETTRES; i++)
    {
	sim[i][X] = sim[X][i] = min_s;	/* en QNGS inutile */

	sim[i][INCONNU] = sim[INCONNU][i] = moy_s;

	moy_diag_sim += sim[i][i];
    }

moy_diag_sim = moy_diag_sim / NBRE_LETTRES;

if (DEBUG)	printf("moy_diag_sim = %d\n", moy_diag_sim);

if (PROFILE) 	sim[X][X] = min_s; 
else	 	sim[X][X] = max_sim; 

sim[INCONNU][INCONNU] = moy_s;
sim[INCONNU][X] = sim[X][INCONNU] = sim[0][X];

/* distances equivalentes */

for (j=0; j <= NBRE_LETTRES+1; j++)
   for (i=0; i <= j; i++)
	dis[i][j] = dis[j][i] = max_sim - sim[i][j];


calcul_gap_score(maxlong, maxlong);

if (DEBUG)
    {
	printf("\nMatrice score de similarite utilisee :\n");
	for (j=0; j < NBRE_LETTRES+2; j++, printf("\n"))
	      for (i=0; i <= j; i++)
	            printf("%5d",sim[i][j]);
	printf("fct gap (score) : %d + %d (k-1)\n", alphaS, betaS);

	printf("\nMatrice distance utilisee :\n");
	for (j=0; j < NBRE_LETTRES+2; j++, printf("\n"))
	      for (i=0; i <= j; i++)
	            printf("%5d",dis[i][j]);
	printf("fct gap (distance) : %d + %d (k-1)\n", alphaD, betaD);
   }
}

indice uniformiser_longueurs(int nbseq)
{
int x;
indice i, maxlong;

maxlong = seq[0].longueur;

for (x=1; x < nbseq; x++)
  if (maxlong < seq[x].longueur)
	maxlong = seq[x].longueur;

for (x=0; x < nbseq; x++)
  if (seq[x].longueur < maxlong)
    {
printf("corrige seq %d: %d->%d\n", x, seq[x].longueur, maxlong);
	seq[x].u = reallouer(seq[x].u, maxlong+2);
	for (i=seq[x].longueur; i <= maxlong; i++)
		seq[x].u[i] = '-';
	seq[x].u[maxlong+1] = 0;
	seq[x].longueur = maxlong;
    }

return(maxlong);
}

void lire_sequences(int argc, char **argv)
{
FILE *f;
int x, i;

Ra = 0;

for (i=1; i < argc; i++)
    if (argv[i][0] == '-' && (argv[i][1] == 'R' || argv[i][1] == 'C'))
      {
	sscanf(argv[i]+2, "%s", nom_fich_seq_ref); 

	f = fopen(nom_fich_seq_ref,"r");
	if (f == NULL) 
	{printf("\nErreur dans la lecture du fichier %s\n", 
		nom_fich_seq_ref); exit(0);}

	Ra = LireSequences(f);

/*	longalig = uniformiser_longueurs(Ra);*/

	fclose(f);
      }

if (TOUR == 1)
   {
	if (argc < 2 || argv[1] == NULL || argv[1][0] == '-') 
	   {
		printf("\nNom du fichier des sequences a aligner: ");
		scanf("%s",famille);
	   }
	else strcpy(famille, argv[1]);
   }
else	extension(famille, famille, "kept");

f = fopen(famille,"r");
if (f == NULL) 
{printf("\nErreur dans la lecture du fichier %s\n", famille); exit(0);}

if (Ra == 0)	R = LireSequences(f);
else 		R = AjouterSequences(f, Ra);

fclose(f);

}

void init(char ARGUMENTS, int argc, char **argv)
{
indice i, j, k;
int n, x;
float r;
lettre c;
char PROTEINE;
FILE *f;

char nom_fich_ancrages[100];

DNA = PROTEINE = CLUSTALW = false;

nom_mat = NULL;

alpha = beta = -1;

BLOCS = true;
FOIS = -1;

CALCULER_ECHELLES = STATISTIQUES = ECHELLES_INIT = COMPARAISON = false;

ESTIMER = true;

lmin = lmax = nerreurs = pas = score_min_paire = -1;

DEBUG = false;

NUM_MAT = BLOSUM30;

nseqmin = 2;

MU = MUp = -1;

MARQUER_BLOCS = false;
COMPTE_GAPS_EXTREMAUX = false;
COMPTE_GAP_GAP = true;
RECURSIF = true;
COMPTER_BOUTS = false;
NOUVELLE_SEQ = METTRE_SEQ_BASE = false;
INSERTION_DIRECTE = true;
TRIER_CLASSE = true;

PROFILE = false;

PAR_ERREURS = -1;
ELARGIR = -1;
DISTANCES_PAR_BLOCS = -1;
PAR_FACTEURS = -1;

PAIRE = false;

MARQUER_GAPS_AJOUTES = PAS_GAPS_BASE = PS = false;


TAUX_MIN = 0.;
TAUX_SITE_SELECT = -1.0;
BORD_SITE = 2;

FORMAT_SORTIE = F_INCONNU;

NJ = false;

if (ARGUMENTS)
  for (i=0; i < argc; i++)
   if (argv[i][0] == '-')
    {
	switch (argv[i][1])
	   {
		case	'g': DEBUG = true; break; 

		case	'0': RECURSIF = false; break; 

		case	'I': STATISTIQUES = true; break; 
		case    'C': COMPARAISON = true; 

		case	'D': DNA = true; PROTEINE = false; break; 
		case	'P': PROTEINE = true; DNA = false; break; 

 
		case	'a': CALCULER_ECHELLES = true; break; 
		case    'w': sscanf(argv[i]+2, "%d", &n); FOIS = n; break; 
		case    'E': sscanf(argv[i]+2, "%f", &r); MU = r; break; 
		case    'U': sscanf(argv[i]+2, "%f", &r); MUp = r; break; 
		case	'X': ELARGIR = false; break; 
		case	'x': ELARGIR = true; PAR_FACTEURS = false; break; 
		case	'b': DISTANCES_PAR_BLOCS = true; break; 
		case	'v': DISTANCES_PAR_BLOCS = false; break; 
		case	'T': TRIER_CLASSE = false; break; 
		case    'p': sscanf(argv[i]+2, "%d", &n); pas = n; break; 
		case	's': c = *(argv[i]+2);
				if (c >= '0' && c <= '9')
				   {
					sscanf(argv[i]+2, "%d", &n); 
					score_min_paire = n; 
				   }
				PAR_ERREURS = false; break; 
		case    'e': c = *(argv[i]+2);
				if (c >= '0' && c <= '9')
				   {
					sscanf(argv[i]+2, "%d", &n); 
					nerreurs = n; 
				   }
				PAR_ERREURS = true; break; 
		case    'l': sscanf(argv[i]+2, "%d", &n); lmin = n; break; 
		case    'L': sscanf(argv[i]+2, "%d", &n); lmax = n; break; 
		case    'n': sscanf(argv[i]+2, "%d", &n); nseqmin = n; break; 
		case	't': PAIRE = true; INSERTION_DIRECTE = false; break; 
		case    'S': c = *(argv[i]+2);
				if (c == '.' || (c >= '0' && c <= '9'))
				   {
					sscanf(argv[i]+2, "%f", &r); 
					TAUX_MIN = r; 
				   }
				PS = true;
				break; 

		case    'A': sscanf(argv[i]+2, "%f", &r); alpha = r; break; 
		case    'B': sscanf(argv[i]+2, "%f", &r); beta = r; break; 
		case	'c': CLUSTALW = true; break; 
		case	'G': COMPTE_GAPS_EXTREMAUX = true; break; 
		case	'V': COMPTE_GAP_GAP = false; break; 
		case    'M': sscanf(argv[i]+2, "%d", &n); NUM_MAT = n;    break;
		case    'm': nom_mat = allouer(100);
			      sscanf(argv[i]+2, "%s", nom_mat); break; 
		case    'Q': PROFILE = false; break; 
		case    'W': PROFILE = true; break; 
		case    'O': PAR_FACTEURS = false; break; 


		case    'i': ECHELLES_INIT = true; 
			      /*sscanf(argv[i]+2, "%s", nom_fich_ancrages);*/ break;

		case    'R': NOUVELLE_SEQ = true; break;
		case    'N': NOUVELLE_SEQ = true; 
				sscanf(argv[i]+2, "%d", &n); 
				Ra = R - n; break;
		case    '#': MARQUER_GAPS_AJOUTES = true; break;
		case    'F': PAS_GAPS_BASE = true; break;
		case	'r': METTRE_SEQ_BASE = true; break;
		case    'f': sscanf(argv[i]+2, "%f", &r); TAUX_SITE_SELECT = r; break; 

		case    'o': sscanf(argv[i]+2, "%f", &r); 
				FORMAT_SORTIE = format(argv[i][2]); break; 
   	    }
    }


if (TAUX_SITE_SELECT == -1.0)
   {
	if (NOUVELLE_SEQ)	TAUX_SITE_SELECT = 0.8;
	else			TAUX_SITE_SELECT = 0.0;
   }

if (MUp == -1)	MUp = 0.01; 
if (MU == -1)	MU = 0.005; 

if (!DNA && !PROTEINE)
   {
	for (j=k=0, i=1; i <= seq[0].longueur; i++)
	    {
		c = tolower(seq[0].u[i]);
		if (c == 'a' || c == 't' || c == 'u' || c == 'c' || c == 'g' || c == 'n')
			j++;
		if (c != '-' && c > ' ')	k++;
	    }
	if (j < (k/2))	DNA = false;
	else		DNA = true;
   }

if (DNA)
    {
	NBRE_LETTRES = 4;
	for (n=0; n <= 2*NBRE_LETTRES+1; n++)
		decode[n] = decode_dna[n];

	if (DISTANCES_PAR_BLOCS == -1) 	DISTANCES_PAR_BLOCS = true;

	if (PAR_FACTEURS == -1) 	PAR_FACTEURS = true;

	if (FOIS == -1) 		FOIS = 1;

	if (PAR_ERREURS == -1)		PAR_ERREURS = true;

	if (ELARGIR == -1)		ELARGIR = false;

	if (!ELARGIR)
	     {
		if (lmin == -1) 	lmin = 15; 
		if (lmax == -1) 	lmax = 45;
		if (nerreurs == -1) 	nerreurs = 1;
		if (pas == -1) 		pas = 10;
	     }
	else {
		if (lmin == -1) 	lmin = 15; 
		if (lmax == -1) 	lmax = 45;
		if (nerreurs == -1) 	nerreurs = 0;
		if (pas == -1) 		pas = 10;
	     }
    }
else
    {
	if (alpha != -1) 	alpha *= 10;
	if (beta != -1) 	beta *= 10;

	NBRE_LETTRES = 23;
	for (n=0; n <= 2*NBRE_LETTRES+1; n++)
		decode[n] = decode_prot[n];

	if (DISTANCES_PAR_BLOCS == -1) 	DISTANCES_PAR_BLOCS = false;

	if (PAR_FACTEURS == -1) 	PAR_FACTEURS = false;

	if (PAR_ERREURS == -1)		PAR_ERREURS = false;

	if (ELARGIR == -1)		{ ELARGIR = true; PAR_FACTEURS = false; }

	if (FOIS == -1) 		FOIS = 1;

	if (!ELARGIR)
	     {
		if (lmin == -1) 	lmin = 15; 
		if (lmax == -1) 	lmax = 15;
		if (nerreurs == -1) 	nerreurs = 1;
		if (pas == -1) 		pas = 1;
	     }
	else {
		if (lmin == -1) 	lmin = 15; 
		if (lmax == -1) 	lmax = 15;
		if (nerreurs == -1) 	nerreurs = 0;
		if (pas == -1) 		pas = 1;
	     }

	if (score_min_paire == -1)
		score_min_paire = 60 * lmin;
    }

if (DEBUG) printf("nbre de lettres: %d\n", NBRE_LETTRES);

SIMILARITE = true;

X = NBRE_LETTRES;
INCONNU = NBRE_LETTRES + 1;
for (n=0; n < 128; n++) code[n] = INCONNU;
for (n=0; n <= NBRE_LETTRES + 1; n++)
	code[ decode[n] ] = n;
if (DNA) code['U'] = code ['T'];
for (i='A', j='a'; i <= 'Z'; i++, j++)
	code[j] = code[i];

i = sizeof(score)*8-1;
SCORE_MIN.h = SCORE_MIN.b = 1 << i;
DISTANCE_ALIG_MAX.h = DISTANCE_ALIG_MAX.b = - (SCORE_MIN.b+1);

sim = (score **) callouer_mat(sizeof(score), NBRE_LETTRES+2, NBRE_LETTRES+2);
dis = (score **) callouer_mat(sizeof(score), NBRE_LETTRES+2, NBRE_LETTRES+2);
sim_karlin = (score **) callouer_mat(sizeof(score), NBRE_LETTRES+2, NBRE_LETTRES+2);

lire_scores_karlin();

if (nom_mat != NULL) /* verifie si le fichier de matrice existe */
    {
	f = fopen(nom_mat,"rb");
	if (f == NULL) 
	{printf("\nErreur dans la lecture du fichier %s\n", nom_mat); exit(0);}
	fclose(f);
    }

if (NOUVELLE_SEQ) introduire_sequence_fictive();
}

void introduire_sequence_fictive(void)
{
indice k, lg;
int x;

lg = seq[0].longueur;

for (x=0; x < Ra; x++)
  if (lg < seq[x].longueur)
	lg = seq[x].longueur;

if (DEBUG) printf("introduit sequence fictive de longueur %d\n", lg);

if (R+1 > anseq)
   {
	anseq = R + 1;
	seq = (sequence *) reallouer(seq, anseq * sizeof(sequence));
   }

for (x=R; x > 0; x--)	
	seq[x] = seq[x-1]; 

seq[0].nom = (char *) allouer(8); 
strcpy(seq[0].nom, "GAP\n");

seq[0].longueur = lg;
seq[0].u = (lettre *) allouer((lg+2) * sizeof(lettre));
for (k=1; k <= lg; k++)
	seq[0].u[k] = 'o';
seq[0].u[0] = ' '; seq[0].u[lg+1] = 0;

Ra++; R++;
}

void supprimer_sequence_fictive(void)
{
indice k, lg;
int x;

Ra--; R--;

liberer(seq[0].u); liberer(seq[0].nom);

for (x=0; x < R; x++)	seq[x] = seq[x+1];

}


void desinit(void)
{
int x;

liberer_mat((void **) sim, NBRE_LETTRES+2);
liberer_mat((void **) dis, NBRE_LETTRES+2);
liberer_mat((void **) sim_karlin, NBRE_LETTRES+2);
if (NOUVELLE_SEQ)	supprimer_sequence_fictive();
}



void statistiques(void)
{
indice i;
score scr;
FILE *f;
int x;


minmaxlong();
longalig = maxlong;

for (x=0; x < R; x++)
   {
	seq[x].alig = (lettre *) allouer(longalig+2);

	for (i=1; i <= seq[x].longueur; i++)
		seq[x].alig[i] = seq[x].u[i];

	for (; i <= longalig; i++)
		seq[x].alig[i] = '-';

	seq[x].longueur = mise_en_forme(seq[x].u, seq[x].longueur, false);

	seq[x].alig[0] = seq[x].alig[longalig+1] = '!';
   }

minmaxlong();
lire_distances();

if (NOUVELLE_SEQ)	
     {
	ecrire_plus_proches_sequences();
     }
else {	scr = cout_alignement();
	f = fopen("stat", "a");
	fprintf(f, " %d", scr);
	fclose(f);

	f = fopen("desc", "a");
	fprintf(f, " %d", R);
	fprintf(f, " %d", minlong);
	fprintf(f, " %d", maxlong);
	fclose(f);
	printf("Cout de l'alignement: %d \n", scr);
     }

for (x=0; x < R; x++)
	liberer(seq[x].alig);

}

void comparaison(void)
{
indice i, j1, j2, k1, k2;
score erreurs, total;
FILE *f;
int x, x1, x2, y1, y2;

minmaxlong();
longalig = maxlong;

for (x=0; x < R; x++)
   {
	seq[x].alig = (lettre *) allouer(longalig+2);

	for (i=1; i <= seq[x].longueur; i++)
		seq[x].alig[i] = seq[x].u[i];

	for (; i <= longalig; i++)
		seq[x].alig[i] = '-';

	seq[x].longueur = mise_en_forme(seq[x].u, seq[x].longueur, false);

	seq[x].alig[0] = seq[x].alig[longalig+1] = '!';
   }

minmaxlong();

total = erreurs = 0;

if (DEBUG)	printf("compare %d sequences a %d sequences\n", Ra, R-Ra);

for (x1=0; x1 < Ra; x1++)
   {
	x2 = x1 + Ra;

	for (y1=0; y1 < Ra; y1++)
	  if (y1 != x1)
	    {
		y2 = y1 + Ra;

		k1 = k2 = 1;
		j1 = j2 = 0;


		while (k1 <= longalig)
		   {
			for (; k1 <= longalig && coder(seq[x1].alig[k1]) == X; k1++)
				if (coder(seq[y1].alig[k1]) != X)	j1++;
			if (k1 <= longalig && coder(seq[y1].alig[k1]) != X)	j1++;

			for (; k2 <= longalig && coder(seq[x2].alig[k2]) == X; k2++)
				if (coder(seq[y2].alig[k2]) != X)	j2++;
			if (k2 <= longalig && coder(seq[y2].alig[k2]) != X)	j2++;

			if (k1 <= longalig && coder(seq[x1].alig[k1]) != X)
			   {
				if (j1 != j2 || seq[y1].alig[k1] != seq[y2].alig[k2])
					erreurs++;
				total++;
			   }

			k1++; k2++;
		   }
	    }
   }

for (x=0; x < R; x++)
	liberer(seq[x].alig);

f = fopen("stat", "a");
fprintf(f, " %d", erreurs);
fclose(f);

printf("distance entre les 2 alignements: %d (sur %d)\n", erreurs, total);
}

void extension(char *nom, char *famille, char *extension)
{
indice i, j;

strcpy(nom, famille);
for (i=strlen(nom)-1; i >= 0 && nom[i] != '.' && nom[i] != '/'; i--); i++;
if (i == 0 || nom[i-1] == '/')	{ i = strlen(nom); nom[i] = '.'; i++; }

for (j=0; j <= strlen(extension); j++, i++)	nom[i] = extension[j];
}

void ecrire_alignement(void)
{
FILE *f;
char nom[100], c;
int n;

extension(nom, famille, "grd");

printf("Sequences alignees dans <%s>\n\n", nom);
fflush(stdout);

f = fopen(nom, "w");

n = Ra;

if (METTRE_SEQ_BASE) Ra = 1;

EcrireAlignement(f);

Ra = n;

fclose(f);
}

void relire_sequences(void)
{
int x;
FILE *fich;

for (x=0; x < R; x++)
   {
	liberer(seq[x].u);
	liberer(seq[x].nom);
   }
fich = fopen(famille,"r");
if (fich == NULL) 
{printf("\nErreur dans la lecture du fichier %s\n", famille); exit(0);}
R = RelireSequences(fich);
fclose(fich);
for (x=0; x < R; x++)
	seq[x].longueur = mise_en_forme(seq[x].u, seq[x].longueur, false);

}


void ecrire_positions_gaps(void)
{
FILE *f;
char nom[100], c;
int x;

extension(nom, famille, "gap");

printf("Positions des gaps ajoutes dans <%s>\n\n", nom);
fflush(stdout);

f = fopen(nom, "w");

EcrireSequenceBourree(f, 0);

fclose(f);
}

int selectionner_sites(char *site_selectionne)
{
indice i, n, nmax, k, bord;
int x;
char *vrai_site = (char *) allouer(longalig+1);

nmax = k = 0;

for (i=1; i <= longalig; i++)
    {
	n = 0; 

	if (NOUVELLE_SEQ)
	     {
	    	for (x=1; x < Ra; x++)
		     if (seq[x].alig[i] != '-' && coder(seq[x].alig[i]) != INCONNU)
			n++;
	     }
	else {
		for (x=0; x < R; x++)
		     if (seq[x].alig[i] != '-' && coder(seq[x].alig[i]) != INCONNU)
			n++;
	     }

	vrai_site[i] = (n != 0);

	if (nmax < n)	nmax = n;
    }

for (i=1; i <= longalig; i++)
    {
	n = 0; 

	if (NOUVELLE_SEQ)
	     {
	    	for (x=1; x < Ra; x++)
		     if (seq[x].alig[i] != '-' && coder(seq[x].alig[i]) != INCONNU)
			n++;
	     }
	else {
		for (x=0; x < R; x++)
		     if (seq[x].alig[i] != '-' && coder(seq[x].alig[i]) != INCONNU)
			n++;
	     }

	if (n >= (int) (TAUX_SITE_SELECT*nmax))
	   {
		site_selectionne[i] = true; 
		k++;
	   }
	else	site_selectionne[i] = false;

    }

bord = BORD_SITE;

for (i=1; i <= longalig; i++)
  if (vrai_site[i] && !site_selectionne[i])
	for (k=i-1, n=bord; n > 0 && k >= 1; k--)
	   if (vrai_site[k])
		{ site_selectionne[k] = false; n--; }

for (i=longalig; i >= 1; i--)
  if (vrai_site[i] && !site_selectionne[i])
	for (k=i+1, n=bord; n > 0 && k <= longalig; k++)
	   if (vrai_site[k])
		{ site_selectionne[k] = false; n--; }


liberer(vrai_site);

return(k);
}

float taux_prox(char *site_selectionne, int x, int y)
{
indice i, k, l;


for (i=1, k=l=0; i <= longalig; i++)
  if (site_selectionne[i] && seq[x].alig[i] != '-')
     {
	if (seq[x].alig[i] == seq[y].alig[i])	k++;
	l++;

/*if (x==19)
{
if (seq[x].alig[i] == seq[y].alig[i])	printf("O");
else					printf("N");
}*/

     }

/*printf("entre %d et %d = %f\n", x, y, (float) k/l);*/

return((float) k/l);
}

int ecrire_plus_proches_sequences(void)
{
FILE *f;
char nom[100], c;
int x, y, z, nb_seq_supp;
float cout, coutmin;
char *site_selectionne;
indice n;
float t;

if (!PS)	return(0);


extension(nom, famille, "cls");

printf("Sequences les plus proches dans <%s>\n\n", nom);
fflush(stdout);

f = fopen(nom, "w");

site_selectionne = (char *) allouer(longalig+1);
n = selectionner_sites(site_selectionne);

nb_seq_supp = 0;

for (x=Ra; x < R; x++)
    {
	if (NOUVELLE_SEQ)
	     {
		z = 1;
		coutmin = -taux_prox(site_selectionne, x, z);
		for (y=z+1; y < Ra; y++)
		    {
			cout = -taux_prox(site_selectionne, x, y);
			if (coutmin > cout)	{ coutmin = cout; z = y; }
		    }
	     }
	else {
		if (x == 0)	z = 1;
		else		z = 0;
		coutmin = -taux_prox(site_selectionne, x, z);
		for (y=z+1; y < R; y++)
		  if (y != x)
		    {
			cout = -taux_prox(site_selectionne, x, y);
			if (coutmin > cout)	{ coutmin = cout; z = y; }
		    }
	     }

	t = taux_prox(site_selectionne, x, z);

	fprintf(f, "%s", seq[x].nom);
	fprintf(f, "is close to (%f)\n", t);
	fprintf(f, "%s\n", seq[z].nom);

	if (t < TAUX_MIN)
	     {
		printf("\nSupprime la sequence : %s", seq[x].nom);
		printf("score de proximite (PS) : %f\n", t);

		nb_seq_supp++;
	     }
    }

liberer(site_selectionne);

fclose(f);

if (nb_seq_supp > 0)
     {
	extension(nom, famille, "kept");
	f = fopen(nom, "w");
	for (x=Ra; x < R; x++)
	    {
		if (NOUVELLE_SEQ)
		     {
			z = 1;
			coutmin = -taux_prox(site_selectionne, x, z);
			for (y=z+1; y < Ra; y++)
			    {
				cout = -taux_prox(site_selectionne, x, y);
				if (coutmin > cout)	{ coutmin = cout; z = y; }
			    }
		     }
		else {
			if (x == 0)	z = 1;
			else		z = 0;
			coutmin = -taux_prox(site_selectionne, x, z);
			for (y=z+1; y < R; y++)
			  if (y != x)
			    {
				cout = -taux_prox(site_selectionne, x, y);
				if (coutmin > cout)	{ coutmin = cout; z = y; }
			    }
		     }

		t = taux_prox(site_selectionne, x, z);

	    	if (t >= TAUX_MIN)	EcrireSequence(f, x);
	    }
	fclose(f);
    }

return(nb_seq_supp);
}


void greedy(int argc, char **argv)
{
int i, x, nbre_seq_supp;
noeud *arbre;

nbre_seq_supp = 0;
TOUR = 1;

do {

lire_sequences(argc, argv); /* retourne les sequences avec les gaps */


init(true, argc, argv);


if (R==0 || (NOUVELLE_SEQ && R==1)) 
    {
	printf("\nAucune sequence a aligner\n");
	exit(0);
    }
else if (R==1)
    {
	printf("\nUne seule sequence a aligner !\n");
	exit(0);
    }

if (STATISTIQUES)	statistiques();
else {
 	if (COMPARAISON) 	comparaison();
	else {
		nbre_seq_supp = algo_greedy();

		if (nbre_seq_supp == 0)
		     {
			ecrire_alignement();

			if (NOUVELLE_SEQ)
				ecrire_positions_gaps();

			for (x=0; x < R; x++)
				liberer(seq[x].alig);	
			/* allouee dans algo_greedy (aligner_entre_ancrages) */
		     }
	     }
     }


desinit();

for (x=0; x < R; x++)
   {
	liberer(seq[x].u);		/* allouees dans lire_sequences */
	liberer(seq[x].nom);	
	liberer_annotations(seq[x].annotations);	
   }
liberer(seq);	/* allouees dans lire_sequences */

TOUR++;

if (nbre_seq_supp > 0)	printf("\n***********  REALIGNE LES SEQUENCES RETENUES    ***********\n");

} while (nbre_seq_supp > 0);

}

void marquer_les_gaps_ajoutes(void)
{
indice k;
char colonne_nulle;
int x;

for (k=1; k <= longalig; k++)
    if (seq[0].alig[k] == '-')
	for (x=Ra; x < R; x++)
		seq[x].alig[k] *= -1;
}

char **greedy_tab(char **sequences, int nombre_seq, int argc, char **argv)
{
int x;
char **alignement;
indice i, lg;

strcpy(famille, "");

Ra = 0;
R = nombre_seq;
anseq = 2 * R;

seq = (sequence *) allouer(anseq * sizeof(sequence));

for (x=0; x < R; x++)
	    {
		seq[x].longueur = strlen(sequences[x]) - 1;
		seq[x].u = sequences[x];
	    }

init(true, argc, argv);

algo_greedy();

if (DEBUG)	printf("fin algo_greedy\n");

if (MARQUER_GAPS_AJOUTES)
	marquer_les_gaps_ajoutes();

if (DEBUG)	printf("fin marquer_les_gaps_ajoutes\n");


alignement = (char **) allouer((R-Ra) * sizeof(char *));
for (x=Ra; x < R; x++)
	alignement[x-Ra] = seq[x].alig;
for (x=0; x < Ra; x++)	liberer(seq[x].alig);


desinit();

liberer(seq);

if (DEBUG)	printf("fin greedy\n");

return(alignement);
}

