#define   	true	          	1
#define   	false	          	0

#define	  	MAX_TAILLE_LIGNE	50000

#define coder(c)	(((c)>=0) ? (code[c]) :  INCONNU)

#define INS	0
#define SUP     1
#define REM     2
#define ISR	3
#define F_INS	4
#define F_SUP	8
#define STOP	16

#define SUPP	0
#define REMP	1
#define INSE	2

#define BLOSUM30	0
#define BLOSUM62	1

#define NBRE_SEG	0
#define REP_CLASSE	1
#define IDX 		2

#define   	F_INCONNU	0
#define   	GENBANK		1
#define   	EMBL		2
#define   	NBRF		3
#define   	FASTA		4
#define   	MASE		5


typedef char lettre;
typedef int indice;
typedef int score;


typedef struct  {
	score b, h;
	indice l;
	} gscore;

typedef struct  {
	indice ind;
	int seq;
	} position;

typedef struct  {
	indice ind, grp;
	int seq;
	} position_g;

typedef struct  {
	indice ind, blc, idx, nseg;
	int seq;
	} position_b;

typedef struct  {
	indice ind, largeur;
	int seq;
	} tbloc;

typedef struct  {
	tbloc *bloc;
	double proba;
	int nbre, nbre_compatibles, longueur;
	} tabloc;

typedef struct {
	indice *ind;
	int R;
	char *indbase;
	} echelle;

typedef struct {
	indice i, j;
	} frag;

typedef struct Noeud {
	struct Noeud *noeud1, *noeud2;
	int num;

	frag *alig;
	int longueur, *premier, *dernier;
	score *scol;
} noeud;


typedef struct Annotations {
	char *annotation;
	struct Annotations *suivante;
	} ANNOTATION;

typedef struct {
		char *nom;
		lettre *u, *alig;
		ANNOTATION *annotations;

		indice longueur;

		indice *ech, *pos_ech_pred, *pos_ech_succ;

	      } sequence;

typedef struct  Occurrence {
	struct  Occurrence *pocc;
	int seq, pos;
	void *classe;
	} occurrence;

typedef struct Facteur {
	struct Facteur *pfils, *pfrere, *lien;
	occurrence *occ;
	int seq, label_pos, label_taille, pos;
	} facteur;

typedef struct CFacteur {
	struct CFacteur *suivant, *representant, *dernier;
	facteur *mot;
	indice nbre;
	} cfacteur;

typedef struct COccurrence {
	struct COccurrence *suivant, *representant, *dernier;
	occurrence *occ;
	indice nbre;
	} coccurrence;


void *allouer(size_t);
void *reallouer(void *, size_t);
void **callouer_mat(size_t, size_t, size_t);
void **recallouer_mat(void **, size_t, size_t, size_t, size_t);
void **recallouer_mat2(void **, size_t, size_t, size_t, size_t);
void liberer(void *);
void liberer_mat(void **, size_t);

int temp_a, temp_b;

#define max(a,b)	(((temp_a=(a))>(temp_b=(b))) ? (temp_a) : (temp_b))
#define min(a,b)	(((temp_a=(a))<(temp_b=(b))) ? (temp_a) : (temp_b))

