#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "greedy.h"
 
extern int alignable(int x, indice i, int y, indice j);
extern indice longueur_alignable(indice l, int x, indice i, int y);

void lire_scores_karlin(void);
score score_paire(indice l, int x, indice i, int y, indice j);
char paire_significative(indice l, int x, indice i, indice larg1, int y, indice j, indice larg2);
double proba_bloc(int m, indice *l, indice *g, tbloc *bloc);
indice elargir(int m, indice *pl, indice *pg, tbloc *bloc);
score score_colonne(tbloc *bloc, int m, indice decalage);
double proba_paire_seg(indice l, int x, indice i, int y, indice j);

extern int NBRE_LETTRES, **sim_karlin, R, INCONNU;
extern lettre code[128];
extern char DNA, SIMILARITE;
extern double MU, MUp;
extern indice long_bloc;
extern sequence *seq;
extern char ELARGIR;
extern score *(matrices[]);
extern double **combinaison;
extern score alphaK, betaK;


double lambda_prot[] = {0.000, 0.000, 0.319, 0.254, 0.208, 0.173, 0.147, 0.126, 0.110,
			0.097, 0.087, 0.078, 0.071, 0.065, 0.060, 0.056, 0.052 };
double kappa_prot[] = {	0.000, 0.000, 0.135, 0.157, 0.136, 0.103, 0.074, 0.055, 0.042,
			0.034, 0.029, 0.025, 0.022, 0.020, 0.019, 0.018, 0.017 };

double lambda_dna[] = {	0.0000, 0.0000, 0.1435, 0.1189, 0.1008, 0.0870, 0.0762, 0.0677, 0.0607, 
			0.0549, 0.0501, 0.0461, 0.0426, 0.0420, 0.0390, 0.0360, 0.0340 };
double kappa_dna[] = {	0.0000, 0.0000, 0.0949, 0.1283, 0.1669, 0.1651, 0.1522, 0.1437, 0.1422, 
			0.1304, 0.1093, 0.1009, 0.0944, 0.0900, 0.0870, 0.0850, 0.0830};

double *lambda, *kappa;


void lire_scores_karlin(void)
{
indice i, j, n;
score moy_s;

if (DNA)
     {
	for (j=0; j < NBRE_LETTRES; j++)
	   for (i=0; i < j; i++)
		sim_karlin[i][j] = -3;
	for (i=0; i < NBRE_LETTRES; i++)
		sim_karlin[i][i] = 5;

	lambda = lambda_dna;
	kappa = kappa_dna;

	alphaK = -12; betaK = -5; 
     }
else {
	for (j=n=0; j < NBRE_LETTRES; j++)
	   for (i=0; i <= j; i++, n++)
		sim_karlin[i][j] = matrices[BLOSUM62][n];

	lambda = lambda_prot;
	kappa = kappa_prot;

	alphaK = -300; betaK = -200; 
     }

moy_s = 0;
for (j=0; j < NBRE_LETTRES; j++)
	for (i=0; i <= j; i++)
            {
		sim_karlin[j][i] = sim_karlin[i][j];
		moy_s += sim_karlin[i][j];
            }
moy_s = moy_s / (NBRE_LETTRES * (NBRE_LETTRES-1) / 2);

for (i=0; i < NBRE_LETTRES; i++)
	sim_karlin[i][INCONNU] = sim_karlin[INCONNU][i] = moy_s;
sim_karlin[INCONNU][INCONNU] = moy_s;

}

score score_paire(indice l, int x, indice i, int y, indice j)
{
indice jf;
score scr;
lettre a, b;

for (scr=0, jf=j+l; j < jf; i++, j++)
   {
	a = coder(seq[x].u[i]); b = coder(seq[y].u[j]);
	scr += sim_karlin[a][b];
   }

return(scr);
}

double proba_paire_seg(indice l, int x, indice i, int y, indice j)
{
indice larg1, larg2;
double proba, N, S, K, L;
indice k, larg, jf, e, g, d, mg, md, li, lj, lx, ly;
lettre a, b, *pa, *pb;
score sc, sp, st, stmax;

lx = seq[x].longueur;
ly = seq[y].longueur;

if (ELARGIR)
   {
	a = coder(seq[x].u[i]); b = coder(seq[y].u[j]); 
	for (g=1, mg=0, pa=(&seq[x].u[i])-1, pb=(&seq[y].u[j])-1,sp=sim_karlin[a][b],st=stmax=0; 
		i > g && j > g && (sc=sim_karlin[coder(*pa)][coder(*pb)])+sp >= 0; 
		pa--, pb--, g++, sp=sc, st+=sc)
	  if (st+sc > stmax)
	     {
		stmax = st+sc;
		mg = g;
	     }
	g = mg;

	a = coder(seq[x].u[i+l-1]); b = coder(seq[y].u[j+l-1]); 
	for (d=1, md=0, pa=(&seq[x].u[i])+l, pb=(&seq[y].u[j])+l, li=i+l, lj=j+l,sp=sim_karlin[a][b],st=stmax=0; 
		li <= lx && lj <= ly && (sc=sim_karlin[coder(*pa)][coder(*pb)])+sp >= 0; 
		li++, lj++, pa++, pb++, d++, sp=sc, st+=sc)  
	  if (st+sc > stmax)
	     {
		stmax = st+sc;
		md = d;
	     }
	d = md;

	l += g + d;
	i -= g; j -= g;
   }

/*if (ELARGIR && l < long_bloc)	return(1.);*/

larg1 = longueur_alignable(l, x, i, y);
larg2 = longueur_alignable(l, y, j, x);

/*larg1 = seq[x].longueur; 
larg2 = seq[y].longueur; */

N = (double)larg1 * (double)larg2;
S = (double) score_paire(l, x, i, y, j);
K = kappa[2];
L = lambda[2];
proba = 1.0  - exp(-K*N*exp(-L*S));


return(proba);
}

char paire_significative(indice l, int x, indice i, indice larg1, int y, indice j, indice larg2)
{
double proba, N, S, K, L;
indice k, larg, jf, e;
lettre a, b;


N = (double)larg1 * (double)larg2;
S = (double) score_paire(l, x, i, y, j);
K = kappa[2];
L = lambda[2];
proba = 1.0  - exp(-K*N*exp(-L*S));

return(proba < MUp);
}

score score_colonne(tbloc *bloc, int m, indice decalage)
{
char possible;
indice i, j;
int s1, s2, x, y;
lettre a, b;
score sc;

for (s1=1, possible=true, sc=0; possible && s1 < m; s1++)
    {
	x = bloc[s1].seq; 
	i = bloc[s1].ind + decalage;
	if (i >= 1 && i <= seq[x].longueur)
	    {
		a = coder(seq[x].u[i]); 
		for (s2=0; possible && s2 < s1; s2++)
	 	    {
			y = bloc[s2].seq; 
			j = bloc[s2].ind + decalage;
			if (j >= 1 && j <= seq[y].longueur && alignable(x, i, y, j))
			    {
				b = coder(seq[y].u[j]);
				sc += sim_karlin[a][b];
			    }
			else	possible = false;
		     }
	    }
	else 	possible = false;
    }

if (possible)	return(sc);
else		return(-1000000000);
}

indice elargir(int m, indice *pl, indice *pg, tbloc *bloc)
{
indice g, d, mg, md, i, j, largeur, l;
int s1, s2, x, y;
lettre a, b;
score sc, sp, st, stmax;

/*printf("elagie de %d ", l);*/

/*
for (g=1; score_colonne(bloc, m, -g) >= 0; g++); g--;
for (d=1; score_colonne(bloc, m, l+d-1) >= 0; d++); d--;
*/

l = *pl;

for (mg=0, g=1,sp=score_colonne(bloc, m, 0),st=stmax=0; 
			(sc=score_colonne(bloc, m, -g))+sp >= 0; g++, sp=sc, st+=sc)
  if (st+sc > stmax)
     {
	stmax = st+sc;
	mg = g;
     }
g = mg;
for (md=0, d=1,sp=score_colonne(bloc, m, l-1),st=stmax=0; 
			(sc=score_colonne(bloc, m, l+d-1))+sp >= 0; d++, sp=sc, st+=sc)
  if (st+sc > stmax)
     {
	stmax = st+sc;
	md = d;
     }
d = md;

l += g + d;

*pl = l; *pg = g;

for (s1=0; s1 < m; s1++)
    {
	x = bloc[s1].seq; 
	i = bloc[s1].ind - g;

	largeur = 0;
	for (s2=0; s2 < m; s2++)
	  if (s1 != s2)
	     {
		y = bloc[s2].seq; 
		j = bloc[s2].ind - g;

		largeur = max(largeur, longueur_alignable(l, y, j, x));
	     }
/*largeur = seq[x].longueur;*/
	bloc[s1].largeur = largeur;
    }
}


double proba_bloc(int m, indice *l, indice *g, tbloc *bloc)
{
double proba;
double N, S, K, L;
int s, s1, s2;
indice vl;

vl = *l;

if (ELARGIR)	elargir(m, l, g, bloc);
else		*g = 0;

/*if (ELARGIR && *l < long_bloc)	return(1.);*/

N = (double) 1.0;
for (s=0; s < m; s++)	N *= (double) bloc[s].largeur;

S = (double) 0.0;
for (s1=1; s1 < m; s1++)
    for (s2=0; s2 < s1; s2++)
	S += (double) score_paire(*l, bloc[s1].seq, bloc[s1].ind-*g, bloc[s2].seq, bloc[s2].ind-*g);

K = (m<15) ? kappa[m] : kappa[15];
L = (m<15) ? lambda[m] : lambda[15];
proba = 1.0  - exp(-K*N*exp(-L*S));

/*if (ELARGIR)
    {
	if (*l >= 2 * vl)	return(MUp/2);
	else			return(MUp*2);
    }*/

return(proba);
}
